
;CodeVisionAVR C Compiler V1.24.8d Professional
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 14.745600 MHz
;Memory model           : Medium
;Optimize for           : Speed
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __GETBRPF
	OUT  RAMPZ,R22
	ELPM R@0,Z
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Main.vec"
	.INCLUDE "Main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
	LDI  R29,BYTE3(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	OUT  RAMPZ,R29
	ELPM R24,Z+
	ELPM R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	ELPM R26,Z+
	ELPM R27,Z+
	ELPM R0,Z+
	ELPM R1,Z+
	ELPM R28,Z+
	ELPM R29,Z+
	MOVW R22,R30
	IN   R29,RAMPZ
	MOVW R30,R0
	OUT  RAMPZ,R28
__GLOBAL_INI_LOOP:
	ELPM R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 //==============================================================================
;       2 //	 RoboBuilder MainController
;       3 //==============================================================================
;       4 #include <mega128.h>
;       5 #include <stdio.h>
;       6 #include <delay.h>
;       7 
;       8 #include "Macro.h"
;       9 #include "Main.h"
;      10 #include "Comm.h"
;      11 #include "Dio.h"
;      12 #include "Adc.h"
;      13 #include "math.h"
;      14 #include "accel.h"
;      15 
;      16 BYTE	F_PF;
;      17 BYTE	F_ERR_CODE;
;      18 bit 	F_SCENE_PLAYING;
;      19 bit 	F_ACTION_PLAYING;
;      20 bit 	F_DIRECT_C_EN;
;      21 bit 	F_MOTION_STOPPED;
;      22 bit     F_DOWNLOAD;
;      23 bit 	F_PS_PLUGGED;
;      24 bit 	F_CHARGING;
;      25 bit     F_AD_CONVERTING;
;      26 bit     F_MIC_INPUT;
;      27 bit     F_PF_CHANGED;
;      28 bit     F_IR_RECEIVED;
;      29 bit     F_FIRST_M;
;      30 bit		F_RSV_MOTION;
;      31 bit		F_RSV_SOUND_READ;
;      32 bit		F_RSV_BTN_READ;
;      33 bit		F_RSV_PSD_READ;
;      34 BYTE	F_EEPROM_BUSY;
_F_EEPROM_BUSY:
	.BYTE 0x1
;      35 
;      36 char	gTx0Buf[TX0_BUF_SIZE];
_gTx0Buf:
	.BYTE 0xBA
;      37 BYTE	gTx0Cnt;
_gTx0Cnt:
	.BYTE 0x1
;      38 BYTE	gRx0Cnt;
_gRx0Cnt:
	.BYTE 0x1
;      39 BYTE	gTx0BufIdx;
_gTx0BufIdx:
	.BYTE 0x1
;      40 char	gRx0Buf[RX0_BUF_SIZE];
_gRx0Buf:
	.BYTE 0x8
;      41 char	gRx1Buf[RX1_BUF_SIZE];
_gRx1Buf:
	.BYTE 0x14
;      42 WORD	gRx1Step;
_gRx1Step:
	.BYTE 0x2
;      43 WORD	gRx1_DStep;
_gRx1_DStep:
	.BYTE 0x2
;      44 WORD	gFieldIdx;
_gFieldIdx:
	.BYTE 0x2
;      45 BYTE	gFileCheckSum;
_gFileCheckSum:
	.BYTE 0x1
;      46 BYTE	gRxData;
_gRxData:
	.BYTE 0x1
;      47 
;      48 WORD	gPF1BtnCnt;
_gPF1BtnCnt:
	.BYTE 0x2
;      49 WORD	gPF2BtnCnt;
_gPF2BtnCnt:
	.BYTE 0x2
;      50 WORD	gPF12BtnCnt;
_gPF12BtnCnt:
	.BYTE 0x2
;      51 BYTE	gBtn_val;
_gBtn_val:
	.BYTE 0x1
;      52 
;      53 WORD    g10MSEC;
_g10MSEC:
	.BYTE 0x2
;      54 BYTE    gSEC;
_gSEC:
	.BYTE 0x1
;      55 BYTE    gMIN;
_gMIN:
	.BYTE 0x1
;      56 BYTE    gHOUR;
_gHOUR:
	.BYTE 0x1
;      57 WORD	gSEC_DCOUNT;
_gSEC_DCOUNT:
	.BYTE 0x2
;      58 WORD	gMIN_DCOUNT;
_gMIN_DCOUNT:
	.BYTE 0x2
;      59 
;      60 WORD    gPSplugCount;
_gPSplugCount:
	.BYTE 0x2
;      61 WORD    gPSunplugCount;
_gPSunplugCount:
	.BYTE 0x2
;      62 WORD	gPwrLowCount;
_gPwrLowCount:
	.BYTE 0x2
;      63 
;      64 char	gIrBuf[IR_BUFFER_SIZE];
_gIrBuf:
	.BYTE 0x4
;      65 BYTE	gIrBitIndex = 0;
_gIrBitIndex:
	.BYTE 0x1
;      66 
;      67 signed char	gAccX;
_gAccX:
	.BYTE 0x1
;      68 signed char	gAccY;
_gAccY:
	.BYTE 0x1
;      69 signed char	gAccZ;
_gAccZ:
	.BYTE 0x1
;      70 
;      71 BYTE	gSoundMinTh;
_gSoundMinTh:
	.BYTE 0x1
;      72 
;      73 int		gFrameIdx = 0;
_gFrameIdx:
	.BYTE 0x2
;      74 WORD	TxInterval = 0;
_TxInterval:
	.BYTE 0x2
;      75 float	gUnitD[MAX_wCK];
_gUnitD:
	.BYTE 0x7C
;      76 BYTE	gLastID;
_gLastID:
	.BYTE 0x1
;      77 BYTE flash	*gpT_Table;
_gpT_Table:
	.BYTE 0x4
;      78 BYTE flash	*gpE_Table;
_gpE_Table:
	.BYTE 0x4
;      79 BYTE flash	*gpPg_Table;
_gpPg_Table:
	.BYTE 0x4
;      80 BYTE flash	*gpDg_Table;
_gpDg_Table:
	.BYTE 0x4
;      81 BYTE flash	*gpIg_Table;
_gpIg_Table:
	.BYTE 0x4
;      82 WORD flash	*gpFN_Table;
_gpFN_Table:
	.BYTE 0x4
;      83 WORD flash	*gpRT_Table;
_gpRT_Table:
	.BYTE 0x4
;      84 BYTE flash	*gpPos_Table;
_gpPos_Table:
	.BYTE 0x4
;      85 
;      86 
;      87 BYTE flash	StandardZeroPos[16]={

	.CSEG
;      88 /* ID
;      89   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;      90 125,202,162, 66,108,124, 48, 88,184,142, 90, 40,125,161,210,127};
;      91 
;      92 BYTE flash	U_Boundary_Huno[16]={
;      93 /* ID
;      94   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;      95 174,228,254,130,185,254,180,126,208,208,254,224,198,254,228,254};
;      96 
;      97 BYTE flash	L_Boundary_Huno[16]={
;      98 /* ID
;      99   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;     100   1, 70,124, 40, 41, 73, 22,  1,120, 57,  1, 23,  1,  1, 25, 40};
;     101 
;     102 BYTE flash	U_Boundary_Dino[16]={
;     103 /* ID
;     104   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;     105 174,228,254,130,185,254,185,126,208,230,254,254,205,254,254,254};
;     106 
;     107 BYTE flash	L_Boundary_Dino[16]={
;     108 /* ID
;     109   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;     110   1, 75,124, 40, 41, 73, 22,  1,120, 45,  1,  1, 25,  1, 45, 45};
;     111 
;     112 BYTE flash	U_Boundary_Dogy[16]={
;     113 /* ID
;     114   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;     115 254,225,225,210,254,254,225,185,203,205,254,230,205,254,230,254};
;     116 
;     117 BYTE flash	L_Boundary_Dogy[16]={
;     118 /* ID
;     119   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;     120   1, 25, 25, 25, 45,  1, 25, 82,  5,  1,  1, 20,  1,  1, 17, 40};
;     121 
;     122 struct TwCK_in_Motion{
;     123 	BYTE	Exist;
;     124 	BYTE	RPgain;
;     125 	BYTE	RDgain;
;     126 	BYTE	RIgain;
;     127 	BYTE	PortEn;
;     128 	BYTE	InitPos;
;     129 };
;     130 
;     131 struct TwCK_in_Scene{
;     132 	BYTE	Exist;
;     133 	BYTE	SPos;
;     134 	BYTE	DPos;
;     135 	BYTE	Torq;
;     136 	BYTE	ExPortD;
;     137 };
;     138 
;     139 struct TMotion{
;     140 	BYTE	RIdx;
;     141 	DWORD	AIdx;
;     142 	BYTE	PF;
;     143 	WORD	NumOfScene;
;     144 	WORD	NumOfwCK;
;     145 	struct	TwCK_in_Motion  wCK[MAX_wCK];
;     146 	WORD	FileSize;
;     147 }Motion;

	.DSEG
_Motion:
	.BYTE 0xC6
;     148 
;     149 struct TScene{
;     150 	WORD	Idx;
;     151 	WORD	NumOfFrame;
;     152 	WORD	RTime;
;     153 	struct	TwCK_in_Scene   wCK[MAX_wCK];
;     154 }Scene;
_Scene:
	.BYTE 0xA1
;     155 
;     156 WORD	gScIdx;
_gScIdx:
	.BYTE 0x2
;     157 
;     158 eeprom  char    eData[13];

	.ESEG
_eData:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     159 eeprom	BYTE	eRCodeH[NUM_OF_REMOCON];
_eRCodeH:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     160 eeprom	BYTE	eRCodeM[NUM_OF_REMOCON];
_eRCodeM:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     161 eeprom	BYTE	eRCodeL[NUM_OF_REMOCON];
_eRCodeL:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     162 eeprom	BYTE	eM_OriginPose[NUM_OF_WCK_HUNO]={
_eM_OriginPose:
;     163 /* ID
;     164   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
;     165 124,202,162, 65,108,125, 46, 88,184,142, 90, 40,125,161,210,126};
	.DB  0x7C
	.DB  0xCA
	.DB  0xA2
	.DB  0x41
	.DB  0x6C
	.DB  0x7D
	.DB  0x2E
	.DB  0x58
	.DB  0xB8
	.DB  0x8E
	.DB  0x5A
	.DB  0x28
	.DB  0x7D
	.DB  0xA1
	.DB  0xD2
	.DB  0x7E
;     166 
;     167 int		gPoseDelta[31];

	.DSEG
_gPoseDelta:
	.BYTE 0x3E
;     168 eeprom	BYTE	ePF = 1;

	.ESEG
_ePF:
	.DB  0x1
;     169 
;     170 eeprom  BYTE    eNumOfM = 0;
_eNumOfM:
	.DB  0x0
;     171 eeprom  BYTE    eNumOfA = 0;
_eNumOfA:
	.DB  0x0
;     172 eeprom  WORD    eM_Addr[20];
_eM_Addr:
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
;     173 eeprom  WORD    eM_FSize[20];
_eM_FSize:
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
;     174 eeprom  WORD    eA_Addr[10];
_eA_Addr:
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
;     175 eeprom  WORD    eA_FSize[10];
_eA_FSize:
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
	.DW  0x0
;     176 
;     177 BYTE    gDownNumOfM;

	.DSEG
_gDownNumOfM:
	.BYTE 0x1
;     178 BYTE    gDownNumOfA;
_gDownNumOfA:
	.BYTE 0x1
;     179 
;     180 WORD Sound_Length[25]={
_Sound_Length:
;     181 2268,1001,832,365,838,417,5671,5916,780,2907,552,522,1525,2494,438,402,433,461,343,472,354,461,458,442,371};
	.BYTE 0x32
;     182 
;     183 
;     184 int Round(float num,int precision)
;     185 {

	.CSEG
_Round:
;     186 	float tempNum;
;     187 	tempNum = num;
	SBIW R28,4
;	num -> Y+6
;	precision -> Y+4
;	tempNum -> Y+0
	__GETD1S 6
	__PUTD1S 0
;     188 	if(tempNum - floor(tempNum) >= 0.5)
	CALL __PUTPARD1
	CALL _floor
	__GETD2S 0
	CALL __SWAPD12
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3F000000
	CALL __CMPF12
	BRLO _0x4
;     189 		return (int)( ceil(tempNum)  );
	__GETD1S 0
	CALL __PUTPARD1
	CALL _ceil
	CALL __CFD1
	RJMP _0x31F
;     190 	else return (int)(floor(tempNum));
_0x4:
	__GETD1S 0
	CALL __PUTPARD1
	CALL _floor
	CALL __CFD1
;     191 }
_0x31F:
	ADIW R28,10
	RET
;     192 
;     193 
;     194 void U1I_case100(void)
;     195 {
_U1I_case100:
;     196 	Motion.PF = gRxData;
	LDS  R30,_gRxData
	__PUTB1MN _Motion,5
;     197 	gFieldIdx = 0;
	LDI  R30,0
	STS  _gFieldIdx,R30
	STS  _gFieldIdx+1,R30
;     198 	gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     199 }
	RET
;     200 
;     201 
;     202 void U1I_case301(BYTE LC)
;     203 {
_U1I_case301:
;     204 	gFieldIdx++;
;	LC -> Y+0
	LDS  R30,_gFieldIdx
	LDS  R31,_gFieldIdx+1
	ADIW R30,1
	STS  _gFieldIdx,R30
	STS  _gFieldIdx+1,R31
;     205 	if(gFieldIdx == 4){
	LDS  R26,_gFieldIdx
	LDS  R27,_gFieldIdx+1
	SBIW R26,4
	BRNE _0x6
;     206 		gFieldIdx = 0;
	LDI  R30,0
	STS  _gFieldIdx,R30
	STS  _gFieldIdx+1,R30
;     207 		gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     208 		if(gRxData == LC)	
	LD   R30,Y
	LDS  R26,_gRxData
	CP   R30,R26
	BRNE _0x7
;     209 			gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     210 		else{
	RJMP _0x8
_0x7:
;     211 			gRx1Step = 0;
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     212 			F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     213 			RUN_LED2_OFF;
	SBI  0x1B,6
;     214 		}
_0x8:
;     215 	}
;     216 }
_0x6:
	RJMP _0x31E
;     217 
;     218 
;     219 void U1I_case302(void)
;     220 {
_U1I_case302:
;     221 	gFileCheckSum ^= gRxData;
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     222 	if(gRxData == 1)
	LDS  R26,_gRxData
	CPI  R26,LOW(0x1)
	BRNE _0x9
;     223 		gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     224 	else{
	RJMP _0xA
_0x9:
;     225 		gRx1Step = 0;
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     226 		F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     227 		RUN_LED2_OFF;
	SBI  0x1B,6
;     228 	}
_0xA:
;     229 }
	RET
;     230 
;     231 
;     232 void U1I_case303(void)
;     233 {
_U1I_case303:
;     234 	int		i;
;     235 	if(gRxData == 1){
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDS  R26,_gRxData
	CPI  R26,LOW(0x1)
	BRNE _0xB
;     236 		SendToPC(11,16);
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _SendToPC
;     237 		gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     238 		for(i = 0; i < 16; i++){
	__GETWRN 16,17,0
_0xD:
	__CPWRN 16,17,16
	BRGE _0xE
;     239 			sciTx1Data(eM_OriginPose[i]);
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	ST   -Y,R30
	CALL _sciTx1Data
;     240 			gFileCheckSum ^= eM_OriginPose[i];
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     241 		}
	__ADDWRN 16,17,1
	RJMP _0xD
_0xE:
;     242 		sciTx1Data(gFileCheckSum);
	LDS  R30,_gFileCheckSum
	ST   -Y,R30
	CALL _sciTx1Data
;     243 	}
;     244 	gRx1Step = 0;
_0xB:
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     245 	F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     246 	RUN_LED2_OFF;
	SBI  0x1B,6
;     247 }
	RJMP _0x31D
;     248 
;     249 
;     250 void U1I_case502(BYTE LC)
;     251 {
_U1I_case502:
;     252 	gFileCheckSum ^= gRxData;
;	LC -> Y+0
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     253 	gFieldIdx++;
	LDS  R30,_gFieldIdx
	LDS  R31,_gFieldIdx+1
	ADIW R30,1
	STS  _gFieldIdx,R30
	STS  _gFieldIdx+1,R31
;     254 	if(gFieldIdx == LC){
	LD   R30,Y
	LDS  R26,_gFieldIdx
	LDS  R27,_gFieldIdx+1
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xF
;     255 		gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
	SBIW R30,1
;     256 	}
;     257 }
_0xF:
_0x31E:
	ADIW R28,1
	RET
;     258 
;     259 
;     260 void U1I_case603(void)
;     261 {
_U1I_case603:
;     262 	int		i;
;     263 
;     264 	if(gFileCheckSum == gRxData){
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BREQ PC+3
	JMP _0x10
;     265 		F_ERR_CODE = NO_ERR;
	LDI  R30,LOW(255)
	MOV  R14,R30
;     266 		for(i = 0; i < 16; i++){
	__GETWRN 16,17,0
_0x12:
	__CPWRN 16,17,16
	BRGE _0x13
;     267 			if((StandardZeroPos[i]+15) < gRx1Buf[RX1_BUF_SIZE-17+i]
;     268 			 ||(StandardZeroPos[i]-15) > gRx1Buf[RX1_BUF_SIZE-17+i]){
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_StandardZeroPos*2)
	SBCI R31,HIGH(-_StandardZeroPos*2)
	SBCI R22,BYTE3(-_StandardZeroPos*2)
	__GETBRPF 30
	SUBI R30,-LOW(15)
	MOV  R26,R30
	MOVW R30,R16
	__ADDW1MN _gRx1Buf,3
	LD   R30,Z
	CP   R26,R30
	BRLO _0x15
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_StandardZeroPos*2)
	SBCI R31,HIGH(-_StandardZeroPos*2)
	SBCI R22,BYTE3(-_StandardZeroPos*2)
	__GETBRPF 30
	SUBI R30,LOW(15)
	MOV  R26,R30
	MOVW R30,R16
	__ADDW1MN _gRx1Buf,3
	LD   R30,Z
	CP   R30,R26
	BRSH _0x14
_0x15:
;     269 				F_ERR_CODE = ZERO_SET_ERR;
	LDI  R30,LOW(7)
	MOV  R14,R30
;     270 				break;
	RJMP _0x13
;     271 			}
;     272 		}
_0x14:
	__ADDWRN 16,17,1
	RJMP _0x12
_0x13:
;     273 		if(F_ERR_CODE == NO_ERR){
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ PC+3
	JMP _0x17
;     274 			for(i = 0; i < 16; i++)
	__GETWRN 16,17,0
_0x19:
	__CPWRN 16,17,16
	BRGE _0x1A
;     275 				eM_OriginPose[i] = gRx1Buf[RX1_BUF_SIZE-17+i];
	MOVW R26,R16
	SUBI R26,LOW(-_eM_OriginPose)
	SBCI R27,HIGH(-_eM_OriginPose)
	MOVW R30,R16
	__ADDW1MN _gRx1Buf,3
	LD   R30,Z
	CALL __EEPROMWRB
;     276 
;     277 			SendToPC(14,16);
	__ADDWRN 16,17,1
	RJMP _0x19
_0x1A:
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _SendToPC
;     278 			gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     279 			for(i = 0; i < 16; i++){
	__GETWRN 16,17,0
_0x1C:
	__CPWRN 16,17,16
	BRGE _0x1D
;     280 				sciTx1Data(eM_OriginPose[i]);
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	ST   -Y,R30
	CALL _sciTx1Data
;     281 				gFileCheckSum ^= eM_OriginPose[i];
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     282 			}
	__ADDWRN 16,17,1
	RJMP _0x1C
_0x1D:
;     283 			sciTx1Data(gFileCheckSum);
	LDS  R30,_gFileCheckSum
	ST   -Y,R30
	CALL _sciTx1Data
;     284 		}
;     285 	}
_0x17:
;     286 	gRx1Step = 0;
_0x10:
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     287 	F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     288 	RUN_LED2_OFF;
	SBI  0x1B,6
;     289 }
_0x31D:
	LD   R16,Y+
	LD   R17,Y+
	RET
;     290 
;     291 
;     292 void U1I_case703(void)
;     293 {
;     294 	WORD    lwtmp;
;     295 	BYTE	lbtmp;
;     296 
;     297 	if(gFileCheckSum == gRxData){
;	lwtmp -> R16,R17
;	lbtmp -> R18
;     298 		if(gDownNumOfM == 0){
;     299 			if(gRx1Buf[RX1_BUF_SIZE-2] == 1)
;     300 				lwtmp = 0x6000;
;     301 			else if(gRx1Buf[RX1_BUF_SIZE-2] == 2)
;     302 				lwtmp = 0x2000;
;     303 		}
;     304 		else{
;     305 			if(gRx1Buf[RX1_BUF_SIZE-2] == 1){
;     306 				lwtmp = eM_Addr[gDownNumOfM-1] + eM_FSize[gDownNumOfM-1];
;     307 				lwtmp = lwtmp + 64 - (eM_FSize[gDownNumOfM-1]%64);
;     308 				lwtmp = 0x6000 - lwtmp;
;     309 			}
;     310 			else if(gRx1Buf[RX1_BUF_SIZE-2] == 2){
;     311 				lwtmp = eA_Addr[gDownNumOfA-1] + eA_FSize[gDownNumOfA-1];
;     312 				lwtmp = lwtmp + 64 - (eA_FSize[gDownNumOfA-1]%64);
;     313 				lwtmp = 0x8000 - lwtmp;
;     314 			}
;     315 		}
;     316 		SendToPC(15,4);
;     317 		gFileCheckSum = 0;
;     318 		sciTx1Data(0x00);
;     319 		sciTx1Data(0x00);
;     320 		lbtmp = (BYTE)((lwtmp>>8) & 0xFF);
;     321 		sciTx1Data(lbtmp);
;     322 		gFileCheckSum ^= lbtmp;
;     323 		lbtmp = (BYTE)(lwtmp & 0xFF);
;     324 		sciTx1Data(lbtmp);
;     325 		gFileCheckSum ^= lbtmp;
;     326 		sciTx1Data(gFileCheckSum);
;     327 	}
;     328 	gRx1Step = 0;
;     329 	F_DOWNLOAD = 0;
;     330 	RUN_LED2_OFF;
;     331 }
;     332 
;     333 
;     334 //------------------------------------------------------------------------------
;     335 // UART0 ۽ ͷƮ(Ŷ ۽ſ)
;     336 //------------------------------------------------------------------------------
;     337 interrupt [USART0_TXC] void usart0_tx_isr(void)
;     338 {
_usart0_tx_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     339 	if(gTx0BufIdx < gTx0Cnt){
	LDS  R30,_gTx0Cnt
	LDS  R26,_gTx0BufIdx
	CP   R26,R30
	BRSH _0x27
;     340 		while(!(UCSR0A & DATA_REGISTER_EMPTY));
_0x28:
	SBIS 0xB,5
	RJMP _0x28
;     341 		UDR0 = gTx0Buf[gTx0BufIdx];
	LDS  R30,_gTx0BufIdx
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LD   R30,Z
	OUT  0xC,R30
;     342     	gTx0BufIdx++;
	LDS  R30,_gTx0BufIdx
	SUBI R30,-LOW(1)
	STS  _gTx0BufIdx,R30
;     343 	}
;     344 	else if(gTx0BufIdx == gTx0Cnt){
	RJMP _0x2B
_0x27:
	LDS  R30,_gTx0Cnt
	LDS  R26,_gTx0BufIdx
	CP   R30,R26
	BRNE _0x2C
;     345 		gTx0BufIdx = 0;
	LDI  R30,LOW(0)
	STS  _gTx0BufIdx,R30
;     346 		gTx0Cnt = 0;
	STS  _gTx0Cnt,R30
;     347 	}
;     348 }
_0x2C:
_0x2B:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;     349 
;     350 
;     351 //------------------------------------------------------------------------------
;     352 // UART0  ͷƮ(wCK, ⿡  ȣ)
;     353 //------------------------------------------------------------------------------
;     354 interrupt [USART0_RXC] void usart0_rx_isr(void)
;     355 {
_usart0_rx_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     356 	int		i;
;     357 	char	data;
;     358 	data = UDR0;
	CALL __SAVELOCR3
;	i -> R16,R17
;	data -> R18
	IN   R18,12
;     359 	if(F_DIRECT_C_EN){
	SBRS R2,2
	RJMP _0x2D
;     360 		while ( (UCSR1A & DATA_REGISTER_EMPTY) == 0 );
_0x2E:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x2E
;     361 		UDR1 = data;
	STS  156,R18
;     362 		return;
	CALL __LOADLOCR3
	ADIW R28,3
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     363 	}
;     364 	gRx0Cnt++;
_0x2D:
	LDS  R30,_gRx0Cnt
	SUBI R30,-LOW(1)
	STS  _gRx0Cnt,R30
;     365 	for(i = 1; i < RX0_BUF_SIZE; i++) gRx0Buf[i-1] = gRx0Buf[i];
	__GETWRN 16,17,1
_0x32:
	__CPWRN 16,17,8
	BRGE _0x33
	MOVW R30,R16
	SBIW R30,1
	SUBI R30,LOW(-_gRx0Buf)
	SBCI R31,HIGH(-_gRx0Buf)
	MOVW R0,R30
	LDI  R26,LOW(_gRx0Buf)
	LDI  R27,HIGH(_gRx0Buf)
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
;     366 	gRx0Buf[RX0_BUF_SIZE-1] = data;
	__ADDWRN 16,17,1
	RJMP _0x32
_0x33:
	__PUTBMRN _gRx0Buf,7,18
;     367 }
	CALL __LOADLOCR3
	ADIW R28,3
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     368 
;     369 
;     370 //------------------------------------------------------------------------------
;     371 // UART1  ͷƮ(RF, PC  ȣ)
;     372 //------------------------------------------------------------------------------
;     373 interrupt [USART1_RXC] void usart1_rx_isr(void)
;     374 {
_usart1_rx_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,RAMPZ
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     375     WORD    i;
;     376     
;     377     gRxData = UDR1;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDS  R30,156
	STS  _gRxData,R30
;     378 	if(F_DIRECT_C_EN){
	SBRS R2,2
	RJMP _0x34
;     379 		while( (UCSR0A & DATA_REGISTER_EMPTY) == 0 );
_0x35:
	SBIS 0xB,5
	RJMP _0x35
;     380 		UDR0 = gRxData;
	LDS  R30,_gRxData
	OUT  0xC,R30
;     381 		if(gRxData == 0xff){
	LDS  R26,_gRxData
	CPI  R26,LOW(0xFF)
	BRNE _0x38
;     382 			gRx1_DStep = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R31
;     383 			gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     384 			return;
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     385 		}
;     386 		switch(gRx1_DStep){
_0x38:
	LDS  R30,_gRx1_DStep
	LDS  R31,_gRx1_DStep+1
;     387 			case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x3C
;     388 				if(gRxData == 0xe0) gRx1_DStep = 2;
	LDS  R26,_gRxData
	CPI  R26,LOW(0xE0)
	BRNE _0x3D
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R31
;     389 				else gRx1_DStep = 0;
	RJMP _0x3E
_0x3D:
	LDI  R30,0
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R30
;     390 				gFileCheckSum ^= gRxData;
_0x3E:
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     391 				break;
	RJMP _0x3B
;     392 			case 2:
_0x3C:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x3F
;     393 				if(gRxData == 251) gRx1_DStep = 3;
	LDS  R26,_gRxData
	CPI  R26,LOW(0xFB)
	BRNE _0x40
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R31
;     394 				else gRx1_DStep = 0;
	RJMP _0x41
_0x40:
	LDI  R30,0
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R30
;     395 				gFileCheckSum ^= gRxData;
_0x41:
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     396 				break;
	RJMP _0x3B
;     397 			case 3:
_0x3F:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x42
;     398 				if(gRxData == 1) gRx1_DStep = 4;
	LDS  R26,_gRxData
	CPI  R26,LOW(0x1)
	BRNE _0x43
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R31
;     399 				else gRx1_DStep = 0;
	RJMP _0x44
_0x43:
	LDI  R30,0
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R30
;     400 				gFileCheckSum ^= gRxData;
_0x44:
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     401 				break;
	RJMP _0x3B
;     402 			case 4:
_0x42:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x45
;     403 				gRx1_DStep = 5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R31
;     404 				gFileCheckSum ^= gRxData;
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     405 				gFileCheckSum &= 0x7F;
	ANDI R30,0x7F
	STS  _gFileCheckSum,R30
;     406 				break;
	RJMP _0x3B
;     407 			case 5:
_0x45:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x3B
;     408 				if(gRxData == gFileCheckSum){
	LDS  R30,_gFileCheckSum
	LDS  R26,_gRxData
	CP   R30,R26
	BRNE _0x47
;     409 				    TIMSK |= 0x01;
	IN   R30,0x37
	ORI  R30,1
	OUT  0x37,R30
;     410 					EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;     411 					UCSR0B &= 0x7F;
	CBI  0xA,7
;     412 					UCSR0B |= 0x40;
	SBI  0xA,6
;     413 					F_DIRECT_C_EN = 0;
	CLT
	BLD  R2,2
;     414 				}
;     415 				gRx1_DStep = 0;
_0x47:
	LDI  R30,0
	STS  _gRx1_DStep,R30
	STS  _gRx1_DStep+1,R30
;     416 				break;
;     417 		}
_0x3B:
;     418 		return;
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     419 	}
;     420 	UCSR0B &= 0xBF;
_0x34:
	CBI  0xA,6
;     421 	EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     422 
;     423    	for(i = 1; i < RX1_BUF_SIZE; i++) gRx1Buf[i-1] = gRx1Buf[i];
	__GETWRN 16,17,1
_0x49:
	__CPWRN 16,17,20
	BRSH _0x4A
	MOVW R30,R16
	SBIW R30,1
	SUBI R30,LOW(-_gRx1Buf)
	SBCI R31,HIGH(-_gRx1Buf)
	MOVW R0,R30
	LDI  R26,LOW(_gRx1Buf)
	LDI  R27,HIGH(_gRx1Buf)
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
;     424    	gRx1Buf[RX1_BUF_SIZE-1] = gRxData;
	__ADDWRN 16,17,1
	RJMP _0x49
_0x4A:
	__POINTW2MN _gRx1Buf,19
	LDS  R30,_gRxData
	ST   X,R30
;     425 
;     426     if(F_DOWNLOAD == 0
;     427      && gRx1Buf[RX1_BUF_SIZE-8] == 0xFF
;     428      && gRx1Buf[RX1_BUF_SIZE-7] == 0xFF
;     429      && gRx1Buf[RX1_BUF_SIZE-6] == 0xAA
;     430      && gRx1Buf[RX1_BUF_SIZE-5] == 0x55
;     431      && gRx1Buf[RX1_BUF_SIZE-4] == 0xAA
;     432      && gRx1Buf[RX1_BUF_SIZE-3] == 0x55
;     433      && gRx1Buf[RX1_BUF_SIZE-2] == 0x37
;     434      && gRx1Buf[RX1_BUF_SIZE-1] == 0xBA){
	SBRC R2,4
	RJMP _0x4C
	__GETB1MN _gRx1Buf,12
	CPI  R30,LOW(0xFF)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,13
	CPI  R30,LOW(0xFF)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,14
	CPI  R30,LOW(0xAA)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,15
	CPI  R30,LOW(0x55)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,16
	CPI  R30,LOW(0xAA)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,17
	CPI  R30,LOW(0x55)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,18
	CPI  R30,LOW(0x37)
	BRNE _0x4C
	__GETB1MN _gRx1Buf,19
	CPI  R30,LOW(0xBA)
	BREQ _0x4D
_0x4C:
	RJMP _0x4B
_0x4D:
;     435 		F_DOWNLOAD = 1;
	SET
	BLD  R2,4
;     436 		F_RSV_SOUND_READ = 0;
	CLT
	BLD  R3,5
;     437 		F_RSV_BTN_READ = 0;
	BLD  R3,6
;     438 		RUN_LED2_ON;
	CBI  0x1B,6
;     439 		gRx1Step = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     440 
;     441 		UCSR0B |= 0x40;
	SBI  0xA,6
;     442 		EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;     443 		return;
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     444 	}
;     445 
;     446 	switch(gRx1Step){          	
_0x4B:
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
;     447 		case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x51
;     448     	    if(gRxData == 11){
	LDS  R26,_gRxData
	CPI  R26,LOW(0xB)
	BRNE _0x52
;     449     	        gRx1Step = 300;
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     450     	    }
;     451     	    else if(gRxData == 14){
	RJMP _0x53
_0x52:
	LDS  R26,_gRxData
	CPI  R26,LOW(0xE)
	BRNE _0x54
;     452     	        gRx1Step = 600;
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     453     	    }
;     454     	    else if(gRxData == 16){
	RJMP _0x55
_0x54:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x10)
	BRNE _0x56
;     455     	        gRx1Step = 800;
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     456     	    }
;     457     	    else if(gRxData == 17){
	RJMP _0x57
_0x56:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x11)
	BRNE _0x58
;     458     	        gRx1Step = 900;
	LDI  R30,LOW(900)
	LDI  R31,HIGH(900)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     459     	    }
;     460     	    else if(gRxData == 18){
	RJMP _0x59
_0x58:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x12)
	BRNE _0x5A
;     461     	        gRx1Step = 1000;
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     462     	    }
;     463     	    else if(gRxData == 20){
	RJMP _0x5B
_0x5A:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x14)
	BRNE _0x5C
;     464     	        gRx1Step = 1200;
	LDI  R30,LOW(1200)
	LDI  R31,HIGH(1200)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     465     	    }
;     466     	    else if(gRxData == 21){
	RJMP _0x5D
_0x5C:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x15)
	BRNE _0x5E
;     467     	        gRx1Step = 1300;
	LDI  R30,LOW(1300)
	LDI  R31,HIGH(1300)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     468     	    }
;     469     	    else if(gRxData == 22){
	RJMP _0x5F
_0x5E:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x16)
	BRNE _0x60
;     470     	        gRx1Step = 1400;
	LDI  R30,LOW(1400)
	LDI  R31,HIGH(1400)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     471     	    }
;     472     	    else if(gRxData == 23){
	RJMP _0x61
_0x60:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x17)
	BRNE _0x62
;     473     	        gRx1Step = 1500;
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     474     	    }
;     475     	    else if(gRxData == 24){
	RJMP _0x63
_0x62:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x18)
	BRNE _0x64
;     476     	        gRx1Step = 1600;
	LDI  R30,LOW(1600)
	LDI  R31,HIGH(1600)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     477     	    }
;     478     	    else if(gRxData == 26){
	RJMP _0x65
_0x64:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x1A)
	BRNE _0x66
;     479     	        gRx1Step = 1800;
	LDI  R30,LOW(1800)
	LDI  R31,HIGH(1800)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     480     	    }
;     481     	    else if(gRxData == 31){
	RJMP _0x67
_0x66:
	LDS  R26,_gRxData
	CPI  R26,LOW(0x1F)
	BRNE _0x68
;     482     	        gRx1Step = 2300;
	LDI  R30,LOW(2300)
	LDI  R31,HIGH(2300)
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     483     	    }
;     484     	    else{
	RJMP _0x69
_0x68:
;     485 				gRx1Step = 0;
	RJMP _0x320
;     486 				F_DOWNLOAD = 0;
;     487 				RUN_LED2_OFF;
;     488 				break;
;     489 			}    	    	
_0x69:
_0x67:
_0x65:
_0x63:
_0x61:
_0x5F:
_0x5D:
_0x5B:
_0x59:
_0x57:
_0x55:
_0x53:
;     490     	    break;
	RJMP _0x50
;     491     	case 300:
_0x51:
	CPI  R30,LOW(0x12C)
	LDI  R26,HIGH(0x12C)
	CPC  R31,R26
	BRNE _0x6A
;     492 			U1I_case100();
	CALL _U1I_case100
;     493     	    break;
	RJMP _0x50
;     494     	case 301:
_0x6A:
	CPI  R30,LOW(0x12D)
	LDI  R26,HIGH(0x12D)
	CPC  R31,R26
	BRNE _0x6B
;     495 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     496        	 	break;
	RJMP _0x50
;     497     	case 302:
_0x6B:
	CPI  R30,LOW(0x12E)
	LDI  R26,HIGH(0x12E)
	CPC  R31,R26
	BRNE _0x6C
;     498 			U1I_case302();
	CALL _U1I_case302
;     499        	 	break;
	RJMP _0x50
;     500     	case 303:
_0x6C:
	CPI  R30,LOW(0x12F)
	LDI  R26,HIGH(0x12F)
	CPC  R31,R26
	BRNE _0x6D
;     501     		U1I_case303();
	CALL _U1I_case303
;     502        	 	break;
	RJMP _0x50
;     503     	case 600:
_0x6D:
	CPI  R30,LOW(0x258)
	LDI  R26,HIGH(0x258)
	CPC  R31,R26
	BRNE _0x6E
;     504 			U1I_case100();
	CALL _U1I_case100
;     505     	    break;
	RJMP _0x50
;     506     	case 601:
_0x6E:
	CPI  R30,LOW(0x259)
	LDI  R26,HIGH(0x259)
	CPC  R31,R26
	BRNE _0x6F
;     507 			U1I_case301(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _U1I_case301
;     508        	 	break;
	RJMP _0x50
;     509     	case 602:
_0x6F:
	CPI  R30,LOW(0x25A)
	LDI  R26,HIGH(0x25A)
	CPC  R31,R26
	BRNE _0x70
;     510 			U1I_case502(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _U1I_case502
;     511        	 	break;
	RJMP _0x50
;     512     	case 603:
_0x70:
	CPI  R30,LOW(0x25B)
	LDI  R26,HIGH(0x25B)
	CPC  R31,R26
	BRNE _0x71
;     513     		U1I_case603();
	CALL _U1I_case603
;     514        	 	break;
	RJMP _0x50
;     515     	case 800:
_0x71:
	CPI  R30,LOW(0x320)
	LDI  R26,HIGH(0x320)
	CPC  R31,R26
	BRNE _0x72
;     516 			U1I_case100();
	CALL _U1I_case100
;     517     	    break;
	RJMP _0x50
;     518     	case 801:
_0x72:
	CPI  R30,LOW(0x321)
	LDI  R26,HIGH(0x321)
	CPC  R31,R26
	BRNE _0x73
;     519 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     520        	 	break;
	RJMP _0x50
;     521     	case 802:
_0x73:
	CPI  R30,LOW(0x322)
	LDI  R26,HIGH(0x322)
	CPC  R31,R26
	BRNE _0x74
;     522 			U1I_case302();
	CALL _U1I_case302
;     523        	 	break;
	RJMP _0x50
;     524     	case 803:
_0x74:
	CPI  R30,LOW(0x323)
	LDI  R26,HIGH(0x323)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x75
;     525 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BREQ PC+3
	JMP _0x76
;     526 				SendToPC(16,1);
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _SendToPC
;     527 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     528 				sciTx1Data(0x01);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _sciTx1Data
;     529 				gFileCheckSum ^= 0x01;
	LDS  R26,_gFileCheckSum
	LDI  R30,LOW(1)
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     530 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	CALL _sciTx1Data
;     531 				gRx1Step = 0;
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     532 				F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     533 				RUN_LED2_OFF;
	SBI  0x1B,6
;     534 			    TIMSK &= 0xFE;
	IN   R30,0x37
	ANDI R30,0xFE
	OUT  0x37,R30
;     535 				EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     536 				UCSR0B |= 0x80;
	SBI  0xA,7
;     537 				UCSR0B &= 0xBF;
	CBI  0xA,6
;     538 				F_DIRECT_C_EN = 1;
	SET
	BLD  R2,2
;     539 				PF1_LED1_ON;
	CBI  0x1B,2
;     540 				PF1_LED2_OFF;
	SBI  0x1B,3
;     541 				PF2_LED_ON;
	CBI  0x1B,4
;     542 				return;
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     543 			}
;     544 			gRx1Step = 0;
_0x76:
	RJMP _0x320
;     545 			F_DOWNLOAD = 0;
;     546 			RUN_LED2_OFF;
;     547        	 	break;
;     548     	case 900:
_0x75:
	CPI  R30,LOW(0x384)
	LDI  R26,HIGH(0x384)
	CPC  R31,R26
	BRNE _0x77
;     549 			U1I_case100();
	CALL _U1I_case100
;     550     	    break;
	RJMP _0x50
;     551     	case 901:
_0x77:
	CPI  R30,LOW(0x385)
	LDI  R26,HIGH(0x385)
	CPC  R31,R26
	BRNE _0x78
;     552 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     553        	 	break;
	RJMP _0x50
;     554     	case 902:
_0x78:
	CPI  R30,LOW(0x386)
	LDI  R26,HIGH(0x386)
	CPC  R31,R26
	BRNE _0x79
;     555 			U1I_case302();
	CALL _U1I_case302
;     556        	 	break;
	RJMP _0x50
;     557     	case 903:
_0x79:
	CPI  R30,LOW(0x387)
	LDI  R26,HIGH(0x387)
	CPC  R31,R26
	BRNE _0x7A
;     558 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x7B
;     559 				SendToPC(17,2);
	LDI  R30,LOW(17)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _SendToPC
;     560 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     561 				sciTx1Data(F_ERR_CODE);
	ST   -Y,R14
	CALL _sciTx1Data
;     562 				gFileCheckSum ^= F_ERR_CODE;
	MOV  R30,R14
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     563 				sciTx1Data(F_PF);
	ST   -Y,R13
	CALL _sciTx1Data
;     564 				gFileCheckSum ^= F_PF;
	MOV  R30,R13
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     565 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	CALL _sciTx1Data
;     566 			}
;     567 			gRx1Step = 0;
_0x7B:
	RJMP _0x320
;     568 			F_DOWNLOAD = 0;
;     569 			RUN_LED2_OFF;
;     570        	 	break;
;     571     	case 1000:
_0x7A:
	CPI  R30,LOW(0x3E8)
	LDI  R26,HIGH(0x3E8)
	CPC  R31,R26
	BRNE _0x7C
;     572 			U1I_case100();
	CALL _U1I_case100
;     573     	    break;
	RJMP _0x50
;     574     	case 1001:
_0x7C:
	CPI  R30,LOW(0x3E9)
	LDI  R26,HIGH(0x3E9)
	CPC  R31,R26
	BRNE _0x7D
;     575 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     576        	 	break;
	RJMP _0x50
;     577     	case 1002:
_0x7D:
	CPI  R30,LOW(0x3EA)
	LDI  R26,HIGH(0x3EA)
	CPC  R31,R26
	BRNE _0x7E
;     578 			U1I_case302();
	CALL _U1I_case302
;     579        	 	break;
	RJMP _0x50
;     580     	case 1003:
_0x7E:
	CPI  R30,LOW(0x3EB)
	LDI  R26,HIGH(0x3EB)
	CPC  R31,R26
	BRNE _0x7F
;     581 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x80
;     582 				SendToPC(18,2);
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _SendToPC
;     583 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     584 				sciTx1Data(9);
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL _sciTx1Data
;     585 				gFileCheckSum ^= 9;
	LDS  R26,_gFileCheckSum
	LDI  R30,LOW(9)
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     586 				sciTx1Data(99);
	LDI  R30,LOW(99)
	ST   -Y,R30
	RCALL _sciTx1Data
;     587 				gFileCheckSum ^= 99;
	LDS  R26,_gFileCheckSum
	LDI  R30,LOW(99)
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     588 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;     589 			}
;     590 			gRx1Step = 0;
_0x80:
	RJMP _0x320
;     591 			F_DOWNLOAD = 0;
;     592 			RUN_LED2_OFF;
;     593        	 	break;
;     594     	case 1200:
_0x7F:
	CPI  R30,LOW(0x4B0)
	LDI  R26,HIGH(0x4B0)
	CPC  R31,R26
	BRNE _0x81
;     595 			U1I_case100();
	CALL _U1I_case100
;     596     	    break;
	RJMP _0x50
;     597     	case 1201:
_0x81:
	CPI  R30,LOW(0x4B1)
	LDI  R26,HIGH(0x4B1)
	CPC  R31,R26
	BRNE _0x82
;     598 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     599        	 	break;
	RJMP _0x50
;     600     	case 1202:
_0x82:
	CPI  R30,LOW(0x4B2)
	LDI  R26,HIGH(0x4B2)
	CPC  R31,R26
	BRNE _0x83
;     601 			gFileCheckSum ^= gRxData;
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     602 			if(gRxData < 64)
	LDS  R26,_gRxData
	CPI  R26,LOW(0x40)
	BRSH _0x84
;     603 				gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     604 			else{
	RJMP _0x85
_0x84:
;     605 				gRx1Step = 0;
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     606 				F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     607 				RUN_LED2_OFF;
	SBI  0x1B,6
;     608 			}
_0x85:
;     609        	 	break;
	RJMP _0x50
;     610     	case 1203:
_0x83:
	CPI  R30,LOW(0x4B3)
	LDI  R26,HIGH(0x4B3)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x86
;     611 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x87
;     612 				F_RSV_MOTION = 1;
	SET
	BLD  R3,4
;     613 				if(gRx1Buf[RX1_BUF_SIZE-2] == 0x07)	F_MOTION_STOPPED = 1;
	__GETB1MN _gRx1Buf,18
	CPI  R30,LOW(0x7)
	BRNE _0x88
	BLD  R2,3
;     614 				gRx1Step = 0;
_0x88:
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     615 				F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     616 				RUN_LED2_OFF;
	SBI  0x1B,6
;     617 				UCSR0B |= 0x40;
	SBI  0xA,6
;     618 				EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;     619 				F_IR_RECEIVED = 1;
	SET
	BLD  R3,2
;     620 				gIrBuf[0] = eRCodeH[0];
	LDI  R26,LOW(_eRCodeH)
	LDI  R27,HIGH(_eRCodeH)
	CALL __EEPROMRDB
	STS  _gIrBuf,R30
;     621 				gIrBuf[1] = eRCodeM[0];
	LDI  R26,LOW(_eRCodeM)
	LDI  R27,HIGH(_eRCodeM)
	CALL __EEPROMRDB
	__PUTB1MN _gIrBuf,1
;     622 				gIrBuf[2] = eRCodeL[0];
	LDI  R26,LOW(_eRCodeL)
	LDI  R27,HIGH(_eRCodeL)
	CALL __EEPROMRDB
	__PUTB1MN _gIrBuf,2
;     623 				gIrBuf[3] = gRx1Buf[RX1_BUF_SIZE-2];
	__GETB1MN _gRx1Buf,18
	__PUTB1MN _gIrBuf,3
;     624 				return;
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     625 			}
;     626 			gRx1Step = 0;
_0x87:
	RJMP _0x320
;     627 			F_DOWNLOAD = 0;
;     628 			RUN_LED2_OFF;
;     629        	 	break;
;     630     	case 1300:
_0x86:
	CPI  R30,LOW(0x514)
	LDI  R26,HIGH(0x514)
	CPC  R31,R26
	BRNE _0x89
;     631 			U1I_case100();
	CALL _U1I_case100
;     632     	    break;
	RJMP _0x50
;     633     	case 1301:
_0x89:
	CPI  R30,LOW(0x515)
	LDI  R26,HIGH(0x515)
	CPC  R31,R26
	BRNE _0x8A
;     634 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     635        	 	break;
	RJMP _0x50
;     636     	case 1302:
_0x8A:
	CPI  R30,LOW(0x516)
	LDI  R26,HIGH(0x516)
	CPC  R31,R26
	BRNE _0x8B
;     637 			gFileCheckSum ^= gRxData;
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     638 			if(gRxData < 26)
	LDS  R26,_gRxData
	CPI  R26,LOW(0x1A)
	BRSH _0x8C
;     639 				gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     640 			else{
	RJMP _0x8D
_0x8C:
;     641 			gRx1Step = 0;
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     642 				F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     643 				RUN_LED2_OFF;
	SBI  0x1B,6
;     644 			}
_0x8D:
;     645        	 	break;
	RJMP _0x50
;     646     	case 1303:
_0x8B:
	CPI  R30,LOW(0x517)
	LDI  R26,HIGH(0x517)
	CPC  R31,R26
	BRNE _0x8E
;     647 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x8F
;     648 				SendToSoundIC(gRx1Buf[RX1_BUF_SIZE-2]);
	__GETB1MN _gRx1Buf,18
	ST   -Y,R30
	CALL _SendToSoundIC
;     649 				delay_ms(200 + Sound_Length[gRx1Buf[RX1_BUF_SIZE-2]-1]);
	__GETB1MN _gRx1Buf,18
	SUBI R30,LOW(1)
	LDI  R26,LOW(_Sound_Length)
	LDI  R27,HIGH(_Sound_Length)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	SUBI R30,LOW(-200)
	SBCI R31,HIGH(-200)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     650 				SendToPC(21,1);
	LDI  R30,LOW(21)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _SendToPC
;     651 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     652 				sciTx1Data(gRx1Buf[RX1_BUF_SIZE-2]);
	__GETB1MN _gRx1Buf,18
	ST   -Y,R30
	RCALL _sciTx1Data
;     653 				gFileCheckSum ^= gRx1Buf[RX1_BUF_SIZE-2];
	__GETB1MN _gRx1Buf,18
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     654 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;     655 			}
;     656 			gRx1Step = 0;
_0x8F:
	RJMP _0x320
;     657 			F_DOWNLOAD = 0;
;     658 			RUN_LED2_OFF;
;     659        	 	break;
;     660     	case 1400:
_0x8E:
	CPI  R30,LOW(0x578)
	LDI  R26,HIGH(0x578)
	CPC  R31,R26
	BRNE _0x90
;     661 			U1I_case100();
	CALL _U1I_case100
;     662     	    break;
	RJMP _0x50
;     663     	case 1401:
_0x90:
	CPI  R30,LOW(0x579)
	LDI  R26,HIGH(0x579)
	CPC  R31,R26
	BRNE _0x91
;     664 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     665        	 	break;
	RJMP _0x50
;     666     	case 1402:
_0x91:
	CPI  R30,LOW(0x57A)
	LDI  R26,HIGH(0x57A)
	CPC  R31,R26
	BRNE _0x92
;     667 			U1I_case302();
	CALL _U1I_case302
;     668        	 	break;
	RJMP _0x50
;     669     	case 1403:
_0x92:
	CPI  R30,LOW(0x57B)
	LDI  R26,HIGH(0x57B)
	CPC  R31,R26
	BRNE _0x93
;     670 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x94
;     671 				F_RSV_PSD_READ = 1;
	SET
	BLD  R3,7
;     672 			}
;     673 			gRx1Step = 0;
_0x94:
	RJMP _0x320
;     674 			F_DOWNLOAD = 0;
;     675 			RUN_LED2_OFF;
;     676        	 	break;
;     677     	case 1500:
_0x93:
	CPI  R30,LOW(0x5DC)
	LDI  R26,HIGH(0x5DC)
	CPC  R31,R26
	BRNE _0x95
;     678 			U1I_case100();
	CALL _U1I_case100
;     679     	    break;
	RJMP _0x50
;     680     	case 1501:
_0x95:
	CPI  R30,LOW(0x5DD)
	LDI  R26,HIGH(0x5DD)
	CPC  R31,R26
	BRNE _0x96
;     681 			U1I_case301(2);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _U1I_case301
;     682        	 	break;
	RJMP _0x50
;     683     	case 1502:
_0x96:
	CPI  R30,LOW(0x5DE)
	LDI  R26,HIGH(0x5DE)
	CPC  R31,R26
	BRNE _0x97
;     684 			U1I_case502(2);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _U1I_case502
;     685        	 	break;
	RJMP _0x50
;     686     	case 1503:
_0x97:
	CPI  R30,LOW(0x5DF)
	LDI  R26,HIGH(0x5DF)
	CPC  R31,R26
	BRNE _0x98
;     687 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x99
;     688 				gSoundMinTh = gRx1Buf[RX1_BUF_SIZE-2];
	__GETB1MN _gRx1Buf,18
	STS  _gSoundMinTh,R30
;     689 				F_RSV_SOUND_READ = 1;
	SET
	BLD  R3,5
;     690 			}
;     691 			gRx1Step = 0;
_0x99:
	RJMP _0x320
;     692 			F_DOWNLOAD = 0;
;     693 			RUN_LED2_OFF;
;     694        	 	break;
;     695     	case 1600:
_0x98:
	CPI  R30,LOW(0x640)
	LDI  R26,HIGH(0x640)
	CPC  R31,R26
	BRNE _0x9A
;     696 			U1I_case100();
	CALL _U1I_case100
;     697     	    break;
	RJMP _0x50
;     698     	case 1601:
_0x9A:
	CPI  R30,LOW(0x641)
	LDI  R26,HIGH(0x641)
	CPC  R31,R26
	BRNE _0x9B
;     699 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     700        	 	break;
	RJMP _0x50
;     701     	case 1602:
_0x9B:
	CPI  R30,LOW(0x642)
	LDI  R26,HIGH(0x642)
	CPC  R31,R26
	BRNE _0x9C
;     702 			U1I_case302();
	CALL _U1I_case302
;     703        	 	break;
	RJMP _0x50
;     704     	case 1603:
_0x9C:
	CPI  R30,LOW(0x643)
	LDI  R26,HIGH(0x643)
	CPC  R31,R26
	BRNE _0x9D
;     705 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0x9E
;     706 				F_RSV_BTN_READ = 1;
	SET
	BLD  R3,6
;     707 			}
;     708 			gRx1Step = 0;
_0x9E:
	RJMP _0x320
;     709 			F_DOWNLOAD = 0;
;     710 			RUN_LED2_OFF;
;     711        	 	break;
;     712     	case 1800:
_0x9D:
	CPI  R30,LOW(0x708)
	LDI  R26,HIGH(0x708)
	CPC  R31,R26
	BRNE _0x9F
;     713 			U1I_case100();
	CALL _U1I_case100
;     714     	    break;
	RJMP _0x50
;     715     	case 1801:
_0x9F:
	CPI  R30,LOW(0x709)
	LDI  R26,HIGH(0x709)
	CPC  R31,R26
	BRNE _0xA0
;     716 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     717        	 	break;
	RJMP _0x50
;     718     	case 1802:
_0xA0:
	CPI  R30,LOW(0x70A)
	LDI  R26,HIGH(0x70A)
	CPC  R31,R26
	BRNE _0xA1
;     719 			U1I_case302();
	CALL _U1I_case302
;     720        	 	break;
	RJMP _0x50
;     721     	case 1803:
_0xA1:
	CPI  R30,LOW(0x70B)
	LDI  R26,HIGH(0x70B)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xA2
;     722 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BREQ PC+3
	JMP _0xA3
;     723 				SendToPC(26,6);
	LDI  R30,LOW(26)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _SendToPC
;     724 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     725 				if(gAccX < 0){
	LDS  R26,_gAccX
	CPI  R26,0
	BRGE _0xA4
;     726 	    			sciTx1Data(gAccX);
	LDS  R30,_gAccX
	ST   -Y,R30
	RCALL _sciTx1Data
;     727     				sciTx1Data(0xff);
	LDI  R30,LOW(255)
	RJMP _0x321
;     728         	    }
;     729             	else{
_0xA4:
;     730 	    			sciTx1Data(gAccX);
	LDS  R30,_gAccX
	ST   -Y,R30
	RCALL _sciTx1Data
;     731     				sciTx1Data(0);
	LDI  R30,LOW(0)
_0x321:
	ST   -Y,R30
	RCALL _sciTx1Data
;     732         	    }
;     733 				gFileCheckSum ^= gAccX;
	LDS  R30,_gAccX
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     734 				if(gAccY < 0){
	LDS  R26,_gAccY
	CPI  R26,0
	BRGE _0xA6
;     735     				sciTx1Data(gAccY);
	LDS  R30,_gAccY
	ST   -Y,R30
	RCALL _sciTx1Data
;     736 	    			sciTx1Data(0xff);
	LDI  R30,LOW(255)
	RJMP _0x322
;     737     	        }
;     738         	    else{
_0xA6:
;     739     				sciTx1Data(gAccY);
	LDS  R30,_gAccY
	ST   -Y,R30
	RCALL _sciTx1Data
;     740 	    			sciTx1Data(0);
	LDI  R30,LOW(0)
_0x322:
	ST   -Y,R30
	RCALL _sciTx1Data
;     741     	        }
;     742 				gFileCheckSum ^= gAccY;
	LDS  R30,_gAccY
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     743 				if(gAccZ < 0){
	LDS  R26,_gAccZ
	CPI  R26,0
	BRGE _0xA8
;     744 	    			sciTx1Data(gAccZ);
	LDS  R30,_gAccZ
	ST   -Y,R30
	RCALL _sciTx1Data
;     745     				sciTx1Data(0xff);
	LDI  R30,LOW(255)
	RJMP _0x323
;     746         	    }
;     747             	else{
_0xA8:
;     748 	    			sciTx1Data(gAccZ);
	LDS  R30,_gAccZ
	ST   -Y,R30
	RCALL _sciTx1Data
;     749     				sciTx1Data(0);
	LDI  R30,LOW(0)
_0x323:
	ST   -Y,R30
	RCALL _sciTx1Data
;     750         	    }
;     751 				gFileCheckSum ^= gAccZ;
	LDS  R30,_gAccZ
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     752 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;     753 			}
;     754 			gRx1Step = 0;			// ٿε 
_0xA3:
	RJMP _0x320
;     755 			F_DOWNLOAD = 0;			// ٿε  ǥ 
;     756 			RUN_LED2_OFF;			//   LED ǥ 
;     757        	 	break;
;     758     	case 2300:
_0xA2:
	CPI  R30,LOW(0x8FC)
	LDI  R26,HIGH(0x8FC)
	CPC  R31,R26
	BRNE _0xAA
;     759 			U1I_case100();
	CALL _U1I_case100
;     760     	    break;
	RJMP _0x50
;     761     	case 2301:
_0xAA:
	CPI  R30,LOW(0x8FD)
	LDI  R26,HIGH(0x8FD)
	CPC  R31,R26
	BRNE _0xAB
;     762 			U1I_case301(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _U1I_case301
;     763        	 	break;
	RJMP _0x50
;     764     	case 2302:
_0xAB:
	CPI  R30,LOW(0x8FE)
	LDI  R26,HIGH(0x8FE)
	CPC  R31,R26
	BRNE _0xAC
;     765 			gFileCheckSum ^= gRxData;
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     766 			if(gRxData < 4)
	LDS  R26,_gRxData
	CPI  R26,LOW(0x4)
	BRSH _0xAD
;     767 				gRx1Step++;
	LDS  R30,_gRx1Step
	LDS  R31,_gRx1Step+1
	ADIW R30,1
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R31
;     768 			else{
	RJMP _0xAE
_0xAD:
;     769 				gRx1Step = 0;
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     770 				F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     771 				RUN_LED2_OFF;
	SBI  0x1B,6
;     772 			}
_0xAE:
;     773        	 	break;
	RJMP _0x50
;     774     	case 2303:
_0xAC:
	CPI  R30,LOW(0x8FF)
	LDI  R26,HIGH(0x8FF)
	CPC  R31,R26
	BRNE _0x50
;     775 			if(gFileCheckSum == gRxData){
	LDS  R30,_gRxData
	LDS  R26,_gFileCheckSum
	CP   R30,R26
	BRNE _0xB0
;     776 				if(gRx1Buf[RX1_BUF_SIZE-2] == 1){
	__GETB1MN _gRx1Buf,18
	CPI  R30,LOW(0x1)
	BRNE _0xB1
;     777 					gDownNumOfM = 0;
	LDI  R30,LOW(0)
	STS  _gDownNumOfM,R30
;     778 					eNumOfM = 0;
	LDI  R26,LOW(_eNumOfM)
	LDI  R27,HIGH(_eNumOfM)
	CALL __EEPROMWRB
;     779 				}
;     780 				else if(gRx1Buf[RX1_BUF_SIZE-2] == 2){
	RJMP _0xB2
_0xB1:
	__GETB1MN _gRx1Buf,18
	CPI  R30,LOW(0x2)
	BRNE _0xB3
;     781 					gDownNumOfA = 0;
	LDI  R30,LOW(0)
	STS  _gDownNumOfA,R30
;     782 					eNumOfA = 0;
	LDI  R26,LOW(_eNumOfA)
	LDI  R27,HIGH(_eNumOfA)
	CALL __EEPROMWRB
;     783 				}
;     784 				SendToPC(31,1);
_0xB3:
_0xB2:
	LDI  R30,LOW(31)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _SendToPC
;     785 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;     786 				sciTx1Data(gRx1Buf[RX1_BUF_SIZE-2]);
	__GETB1MN _gRx1Buf,18
	ST   -Y,R30
	RCALL _sciTx1Data
;     787 				gFileCheckSum ^= gRx1Buf[RX1_BUF_SIZE-2];
	__GETB1MN _gRx1Buf,18
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;     788 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;     789 			}
;     790 			gRx1Step = 0;
_0xB0:
_0x320:
	LDI  R30,0
	STS  _gRx1Step,R30
	STS  _gRx1Step+1,R30
;     791 			F_DOWNLOAD = 0;
	CLT
	BLD  R2,4
;     792 			RUN_LED2_OFF;
	SBI  0x1B,6
;     793        	 	break;
;     794 	}
_0x50:
;     795 	UCSR0B |= 0x40;
	SBI  0xA,6
;     796 	EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;     797 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     798 
;     799 
;     800 //------------------------------------------------------------------------------
;     801 // Ÿ̸0 ÷ ͷƮ
;     802 //------------------------------------------------------------------------------
;     803 interrupt [TIM0_OVF] void timer0_ovf_isr(void) {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     804 	TCNT0 = 111;
	LDI  R30,LOW(111)
	OUT  0x32,R30
;     805 	if(++g10MSEC > 99){
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	ADIW R26,1
	STS  _g10MSEC,R26
	STS  _g10MSEC+1,R27
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRSH PC+3
	JMP _0xB4
;     806         g10MSEC = 0;
	LDI  R30,0
	STS  _g10MSEC,R30
	STS  _g10MSEC+1,R30
;     807         if(gSEC_DCOUNT > 0)	gSEC_DCOUNT--;
	LDS  R26,_gSEC_DCOUNT
	LDS  R27,_gSEC_DCOUNT+1
	CALL __CPW02
	BRSH _0xB5
	LDS  R30,_gSEC_DCOUNT
	LDS  R31,_gSEC_DCOUNT+1
	SBIW R30,1
	STS  _gSEC_DCOUNT,R30
	STS  _gSEC_DCOUNT+1,R31
;     808         if(++gSEC > 59){
_0xB5:
	LDS  R26,_gSEC
	SUBI R26,-LOW(1)
	STS  _gSEC,R26
	CPI  R26,LOW(0x3C)
	BRLO _0xB6
;     809             gSEC = 0;
	LDI  R30,LOW(0)
	STS  _gSEC,R30
;     810 	        if(gMIN_DCOUNT > 0)	gMIN_DCOUNT--;
	LDS  R26,_gMIN_DCOUNT
	LDS  R27,_gMIN_DCOUNT+1
	CALL __CPW02
	BRSH _0xB7
	LDS  R30,_gMIN_DCOUNT
	LDS  R31,_gMIN_DCOUNT+1
	SBIW R30,1
	STS  _gMIN_DCOUNT,R30
	STS  _gMIN_DCOUNT+1,R31
;     811             if(++gMIN > 59){
_0xB7:
	LDS  R26,_gMIN
	SUBI R26,-LOW(1)
	STS  _gMIN,R26
	CPI  R26,LOW(0x3C)
	BRLO _0xB8
;     812                 gMIN = 0;
	LDI  R30,LOW(0)
	STS  _gMIN,R30
;     813                 if(++gHOUR > 23)
	LDS  R26,_gHOUR
	SUBI R26,-LOW(1)
	STS  _gHOUR,R26
	CPI  R26,LOW(0x18)
	BRLO _0xB9
;     814                     gHOUR = 0;
	STS  _gHOUR,R30
;     815             }
_0xB9:
;     816 		}
_0xB8:
;     817     }
_0xB6:
;     818 }
_0xB4:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;     819 
;     820 //------------------------------------------------------------------------------
;     821 // Ÿ̸1 ÷ ͷƮ
;     822 //------------------------------------------------------------------------------
;     823 interrupt [TIM1_OVF] void timer1_ovf_isr(void) {
_timer1_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,RAMPZ
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     824 	if( gFrameIdx == Scene.NumOfFrame ) {
	__GETW1MN _Scene,2
	LDS  R26,_gFrameIdx
	LDS  R27,_gFrameIdx+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xBA
;     825    	    gFrameIdx = 0;
	LDI  R30,0
	STS  _gFrameIdx,R30
	STS  _gFrameIdx+1,R30
;     826     	RUN_LED1_OFF;
	SBI  0x1B,5
;     827 		F_SCENE_PLAYING = 0;
	CLT
	BLD  R2,0
;     828 		TIMSK &= 0xfb;
	IN   R30,0x37
	ANDI R30,0xFB
	OUT  0x37,R30
;     829 		TCCR1B = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
;     830 		return;
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     831 	}
;     832 	TCNT1 = TxInterval;
_0xBA:
	LDS  R30,_TxInterval
	LDS  R31,_TxInterval+1
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     833 	TIFR |= 0x04;
	IN   R30,0x36
	ORI  R30,4
	OUT  0x36,R30
;     834 	TIMSK |= 0x04;
	IN   R30,0x37
	ORI  R30,4
	OUT  0x37,R30
;     835 	MakeFrame();
	CALL _MakeFrame
;     836 	SendFrame();
	CALL _SendFrame
;     837 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     838 
;     839 
;     840 //------------------------------------------------------------------------------
;     841 //  ſ IR ͷƮ
;     842 //------------------------------------------------------------------------------
;     843 interrupt [EXT_INT6] void ext_int6_isr(void) {
_ext_int6_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     844 	BYTE width;
;     845 	WORD i;
;     846 
;     847 	width = TCNT2;
	CALL __SAVELOCR3
;	width -> R16
;	i -> R17,R18
	IN   R16,36
;     848 	TCNT2 = 0;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     849 
;     850 	if(gIrBitIndex == 0xFF){
	LDS  R26,_gIrBitIndex
	CPI  R26,LOW(0xFF)
	BRNE _0xBB
;     851 		if((width >= IR_HEADER_LT) && (width <= IR_HEADER_UT)){
	CPI  R16,63
	BRLO _0xBD
	CPI  R16,82
	BRLO _0xBE
_0xBD:
	RJMP _0xBC
_0xBE:
;     852 			F_IR_RECEIVED = 0;
	CLT
	BLD  R3,2
;     853 			gIrBitIndex = 0;
	LDI  R30,LOW(0)
	STS  _gIrBitIndex,R30
;     854 			for(i = 0; i < IR_BUFFER_SIZE; i++)
	__GETWRN 17,18,0
_0xC0:
	__CPWRN 17,18,4
	BRSH _0xC1
;     855                 gIrBuf[i] = 0;
	LDI  R26,LOW(_gIrBuf)
	LDI  R27,HIGH(_gIrBuf)
	ADD  R26,R17
	ADC  R27,R18
	LDI  R30,LOW(0)
	ST   X,R30
;     856         }
	__ADDWRN 17,18,1
	RJMP _0xC0
_0xC1:
;     857 	}
_0xBC:
;     858 	else{
	RJMP _0xC2
_0xBB:
;     859         if((width >= IR_LOW_BIT_LT)&&(width <= IR_LOW_BIT_UT))
	CPI  R16,10
	BRLO _0xC4
	CPI  R16,19
	BRLO _0xC5
_0xC4:
	RJMP _0xC3
_0xC5:
;     860             gIrBitIndex++;
	LDS  R30,_gIrBitIndex
	SUBI R30,-LOW(1)
	RJMP _0x324
;     861         else if((width >= IR_HIGH_BIT_LT)&&(width <= IR_HIGH_BIT_UT)){
_0xC3:
	CPI  R16,19
	BRLO _0xC8
	CPI  R16,27
	BRLO _0xC9
_0xC8:
	RJMP _0xC7
_0xC9:
;     862             if(gIrBitIndex != 0)
	LDS  R30,_gIrBitIndex
	CPI  R30,0
	BREQ _0xCA
;     863                 gIrBuf[(BYTE)(gIrBitIndex/8)] |= 0x01<<(gIrBitIndex%8);
	LSR  R30
	LSR  R30
	LSR  R30
	LDI  R31,0
	SUBI R30,LOW(-_gIrBuf)
	SBCI R31,HIGH(-_gIrBuf)
	MOVW R22,R30
	LD   R1,Z
	LDS  R30,_gIrBitIndex
	ANDI R30,LOW(0x7)
	LDI  R26,LOW(1)
	CALL __LSLB12
	OR   R30,R1
	MOVW R26,R22
	ST   X,R30
;     864             else
	RJMP _0xCB
_0xCA:
;     865                 gIrBuf[0] = 0x01;
	LDI  R30,LOW(1)
	STS  _gIrBuf,R30
;     866             gIrBitIndex++;
_0xCB:
	LDS  R30,_gIrBitIndex
	SUBI R30,-LOW(1)
	RJMP _0x324
;     867         }
;     868         else gIrBitIndex = 0xFF;
_0xC7:
	LDI  R30,LOW(255)
_0x324:
	STS  _gIrBitIndex,R30
;     869       
;     870         if(gIrBitIndex == (IR_BUFFER_SIZE * 8)){
	LDS  R26,_gIrBitIndex
	CPI  R26,LOW(0x20)
	BRNE _0xCD
;     871             F_IR_RECEIVED = 1;
	SET
	BLD  R3,2
;     872             gIrBitIndex = 0xFF;
	LDI  R30,LOW(255)
	STS  _gIrBitIndex,R30
;     873 		}
;     874 	}
_0xCD:
_0xC2:
;     875 }
	CALL __LOADLOCR3
	ADIW R28,3
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     876 
;     877 
;     878 //------------------------------------------------------------------------------
;     879 // A/D ȯ Ϸ ͷƮ
;     880 //------------------------------------------------------------------------------
;     881 interrupt [ADC_INT] void adc_isr(void) {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     882 	WORD i;
;     883 	gAD_val=(signed char)ADCH;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	IN   R12,5
;     884 	switch(gAD_Ch_Index){
	MOV  R30,R5
;     885 		case PSD_CH:
	CPI  R30,0
	BRNE _0xD1
;     886     	    gPSD_val = (BYTE)gAD_val;
	MOV  R10,R12
;     887 			break; 
	RJMP _0xD0
;     888 		case VOLTAGE_CH:
_0xD1:
	CPI  R30,LOW(0x1)
	BRNE _0xD2
;     889 			i = (BYTE)gAD_val;
	MOV  R16,R12
	CLR  R17
;     890 			gVOLTAGE = i*57;
	__MULBNWRU 16,17,57
	MOVW R6,R30
;     891 			break; 
	RJMP _0xD0
;     892 		case MIC_CH:
_0xD2:
	CPI  R30,LOW(0xF)
	BRNE _0xD0
;     893 			if((BYTE)gAD_val < 230)
	LDI  R30,LOW(230)
	CP   R12,R30
	BRSH _0xD4
;     894 				gMIC_val = (BYTE)gAD_val;
	MOV  R11,R12
;     895 			else
	RJMP _0xD5
_0xD4:
;     896 				gMIC_val = 0;
	CLR  R11
;     897 			break; 
_0xD5:
;     898 	}  
_0xD0:
;     899 	F_AD_CONVERTING = 0;    
	CLT
	BLD  R2,7
;     900 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     901 
;     902 
;     903 void ADC_set(BYTE mode)
;     904 {                                    
_ADC_set:
;     905 	ADMUX=0x20 | gAD_Ch_Index;
;	mode -> Y+0
	MOV  R30,R5
	ORI  R30,0x20
	OUT  0x7,R30
;     906 	ADCSRA=mode;     
	LD   R30,Y
	OUT  0x6,R30
;     907 }		
	ADIW R28,1
	RET
;     908 
;     909 
;     910 //------------------------------------------------------------------------------
;     911 //  ˻
;     912 //------------------------------------------------------------------------------
;     913 void DetectPower(void)
;     914 {
_DetectPower:
;     915 	if(F_DOWNLOAD) return;
	SBRC R2,4
	RET
;     916 	if(F_PS_PLUGGED){
	SBRS R2,5
	RJMP _0xD7
;     917 		if(gVOLTAGE >= U_T_OF_POWER)
	LDI  R30,LOW(9650)
	LDI  R31,HIGH(9650)
	CP   R6,R30
	CPC  R7,R31
	BRLO _0xD8
;     918 			gPSunplugCount = 0;
	LDI  R30,0
	STS  _gPSunplugCount,R30
	STS  _gPSunplugCount+1,R30
;     919 		else
	RJMP _0xD9
_0xD8:
;     920 			gPSunplugCount++;
	LDS  R30,_gPSunplugCount
	LDS  R31,_gPSunplugCount+1
	ADIW R30,1
	STS  _gPSunplugCount,R30
	STS  _gPSunplugCount+1,R31
;     921 		if(gPSunplugCount > 6){
_0xD9:
	LDS  R26,_gPSunplugCount
	LDS  R27,_gPSunplugCount+1
	SBIW R26,7
	BRLO _0xDA
;     922 			F_PS_PLUGGED = 0;
	CLT
	BLD  R2,5
;     923 			gPSunplugCount = 0;
	LDI  R30,0
	STS  _gPSunplugCount,R30
	STS  _gPSunplugCount+1,R30
;     924 		}
;     925 	}
_0xDA:
;     926 	else{
	RJMP _0xDB
_0xD7:
;     927 		if(gVOLTAGE >= U_T_OF_POWER){
	LDI  R30,LOW(9650)
	LDI  R31,HIGH(9650)
	CP   R6,R30
	CPC  R7,R31
	BRLO _0xDC
;     928 			gPSunplugCount = 0;
	LDI  R30,0
	STS  _gPSunplugCount,R30
	STS  _gPSunplugCount+1,R30
;     929 			gPSplugCount++;
	LDS  R30,_gPSplugCount
	LDS  R31,_gPSplugCount+1
	ADIW R30,1
	STS  _gPSplugCount,R30
	STS  _gPSplugCount+1,R31
;     930 		}
;     931 		else{
	RJMP _0xDD
_0xDC:
;     932 			gPSplugCount = 0;
	LDI  R30,0
	STS  _gPSplugCount,R30
	STS  _gPSplugCount+1,R30
;     933 		}
_0xDD:
;     934 
;     935 		if(gPSplugCount>2){
	LDS  R26,_gPSplugCount
	LDS  R27,_gPSplugCount+1
	SBIW R26,3
	BRLO _0xDE
;     936 			F_PS_PLUGGED = 1;
	SET
	BLD  R2,5
;     937 			gPSplugCount = 0;
	LDI  R30,0
	STS  _gPSplugCount,R30
	STS  _gPSplugCount+1,R30
;     938 		}
;     939 	}
_0xDE:
_0xDB:
;     940 }
	RET
;     941 
;     942 
;     943 //-----------------------------------------------------------------------------
;     944 // NiMH ͸ 
;     945 //-----------------------------------------------------------------------------
;     946 void ChargeNiMH(void)
;     947 {
_ChargeNiMH:
;     948 	F_CHARGING = 1;
	SET
	BLD  R2,6
;     949 	gMIN_DCOUNT = 5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	STS  _gMIN_DCOUNT,R30
	STS  _gMIN_DCOUNT+1,R31
;     950 	while(gMIN_DCOUNT){
_0xDF:
	LDS  R30,_gMIN_DCOUNT
	LDS  R31,_gMIN_DCOUNT+1
	SBIW R30,0
	BREQ _0xE1
;     951 		PWR_LED2_OFF;
	SBI  0x15,7
;     952 		PWR_LED1_ON;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;     953 		Get_VOLTAGE();	DetectPower();
	CALL _Get_VOLTAGE
	CALL _DetectPower
;     954 		if(F_PS_PLUGGED == 0) break;
	SBRS R2,5
	RJMP _0xE1
;     955 		CHARGE_ENABLE;
	SBI  0x18,4
;     956 		delay_ms(40);
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     957 		CHARGE_DISABLE;
	CBI  0x18,4
;     958 		delay_ms(500-40);
	LDI  R30,LOW(460)
	LDI  R31,HIGH(460)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     959 		PWR_LED1_OFF;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;     960 		Get_VOLTAGE();	DetectPower();
	CALL _Get_VOLTAGE
	CALL _DetectPower
;     961 		if(F_PS_PLUGGED == 0) break;
	SBRS R2,5
	RJMP _0xE1
;     962 		delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     963 	}
	RJMP _0xDF
_0xE1:
;     964 	gMIN_DCOUNT = 85;
	LDI  R30,LOW(85)
	LDI  R31,HIGH(85)
	STS  _gMIN_DCOUNT,R30
	STS  _gMIN_DCOUNT+1,R31
;     965 	while(gMIN_DCOUNT){
_0xE4:
	LDS  R30,_gMIN_DCOUNT
	LDS  R31,_gMIN_DCOUNT+1
	SBIW R30,0
	BREQ _0xE6
;     966 		PWR_LED2_OFF;
	SBI  0x15,7
;     967 		if(g10MSEC > 50)	PWR_LED1_ON;
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,51
	BRLO _0xE7
	LDS  R30,101
	ANDI R30,0xFB
	RJMP _0x325
;     968 		else			PWR_LED1_OFF;
_0xE7:
	LDS  R30,101
	ORI  R30,4
_0x325:
	STS  101,R30
;     969 		if(g10MSEC == 0 || g10MSEC == 50){
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CALL __CPW02
	BREQ _0xEA
	SBIW R26,50
	BRNE _0xE9
_0xEA:
;     970 			Get_VOLTAGE();
	CALL _Get_VOLTAGE
;     971 			DetectPower();
	CALL _DetectPower
;     972 		}
;     973 		if(F_PS_PLUGGED == 0) break;
_0xE9:
	SBRS R2,5
	RJMP _0xE6
;     974 		CHARGE_ENABLE;
	SBI  0x18,4
;     975 	}
	RJMP _0xE4
_0xE6:
;     976 	CHARGE_DISABLE;
	CBI  0x18,4
;     977 	F_CHARGING = 0;
	CLT
	BLD  R2,6
;     978 }
	RET
;     979 
;     980 
;     981 //------------------------------------------------------------------------------
;     982 // ϵ ʱȭ
;     983 //------------------------------------------------------------------------------
;     984 void HW_init(void) {
_HW_init:
;     985 	// Input/Output Ports initialization
;     986 	// Port A initialization
;     987 	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
;     988 	// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=P State0=P 
;     989 	PORTA=0x03;
	LDI  R30,LOW(3)
	OUT  0x1B,R30
;     990 	DDRA=0xFC;
	LDI  R30,LOW(252)
	OUT  0x1A,R30
;     991 
;     992 	// Port B initialization
;     993 	// Func7=In Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=In Func0=In 
;     994 	// State7=T State6=0 State5=0 State4=0 State3=T State2=0 State1=T State0=T 
;     995 	PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     996 	DDRB=0x74;
	LDI  R30,LOW(116)
	OUT  0x17,R30
;     997 
;     998 	// Port C initialization
;     999 	// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;    1000 	// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;    1001 	PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;    1002 	DDRC=0x80;
	LDI  R30,LOW(128)
	OUT  0x14,R30
;    1003 
;    1004 	// Port D initialization
;    1005 	// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;    1006 	// State7=1 State6=T State5=T State4=T State3=T State2=T State1=P State0=P 
;    1007 	PORTD=0x83;
	LDI  R30,LOW(131)
	OUT  0x12,R30
;    1008 	DDRD=0x80;
	LDI  R30,LOW(128)
	OUT  0x11,R30
;    1009 
;    1010 	// Port E initialization
;    1011 	// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
;    1012 	// State7=T State6=T State5=P State4=P State3=0 State2=T State1=T State0=T 
;    1013 	PORTE=0x30;
	LDI  R30,LOW(48)
	OUT  0x3,R30
;    1014 	DDRE=0x08;
	LDI  R30,LOW(8)
	OUT  0x2,R30
;    1015 
;    1016     // Port F initialization
;    1017     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;    1018     // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;    1019     PORTF=0x00;
	LDI  R30,LOW(0)
	STS  98,R30
;    1020     DDRF=0x00;
	STS  97,R30
;    1021 
;    1022 	// Port G initialization
;    1023 	// Func4=In Func3=In Func2=Out Func1=In Func0=In 
;    1024 	// State4=T State3=T State2=0 State1=T State0=T 
;    1025 	PORTG=0x00;
	STS  101,R30
;    1026 	DDRG=0x04;
	LDI  R30,LOW(4)
	STS  100,R30
;    1027 
;    1028     // Timer/Counter 0 initialization
;    1029     // Clock source: System Clock
;    1030     // Clock value: 14.400 kHz
;    1031     // Mode: Normal top=FFh
;    1032     // OC0 output: Disconnected
;    1033     ASSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;    1034     TCCR0=0x07;
	LDI  R30,LOW(7)
	OUT  0x33,R30
;    1035     TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;    1036     OCR0=0x00;
	OUT  0x31,R30
;    1037 
;    1038 	// Timer/Counter 1 initialization
;    1039 	// Clock source: System Clock
;    1040 	// Clock value: 14.400 kHz
;    1041 	// Mode: Normal top=FFFFh
;    1042 	// OC1A output: Discon.
;    1043 	// OC1B output: Discon.
;    1044 	// OC1C output: Discon.
;    1045 	// Noise Canceler: Off
;    1046 	// Input Capture on Falling Edge
;    1047 	// Timer 1 Overflow Interrupt: On
;    1048 	// Input Capture Interrupt: Off
;    1049 	// Compare A Match Interrupt: Off
;    1050 	// Compare B Match Interrupt: Off
;    1051 	// Compare C Match Interrupt: Off
;    1052 	TCCR1A=0x00;
	OUT  0x2F,R30
;    1053 	TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;    1054 	TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;    1055 	TCNT1L=0x00;
	OUT  0x2C,R30
;    1056 	ICR1H=0x00;
	OUT  0x27,R30
;    1057 	ICR1L=0x00;
	OUT  0x26,R30
;    1058 	OCR1AH=0x00;
	OUT  0x2B,R30
;    1059 	OCR1AL=0x00;
	OUT  0x2A,R30
;    1060 	OCR1BH=0x00;
	OUT  0x29,R30
;    1061 	OCR1BL=0x00;
	OUT  0x28,R30
;    1062 	OCR1CH=0x00;
	STS  121,R30
;    1063 	OCR1CL=0x00;
	STS  120,R30
;    1064 
;    1065 	// Ÿ̸ 2---------------------------------------------------------------
;    1066     // Timer/Counter 2 initialization
;    1067     // Clock source: System Clock
;    1068     // Clock value: 14.400 kHz
;    1069     // Mode: Normal top=FFh
;    1070     // OC2 output: Disconnected
;    1071     TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
;    1072     TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;    1073     OCR2=0x00;
	OUT  0x23,R30
;    1074 
;    1075 	// Ÿ̸ 3---------------------------------------------------------------
;    1076 	// Timer/Counter 3 initialization
;    1077 	// Clock source: System Clock
;    1078 	// Clock value: 230.400 kHz
;    1079 	// Mode: Normal top=FFFFh
;    1080 	// Noise Canceler: Off
;    1081 	// Input Capture on Falling Edge
;    1082 	// OC3A output: Discon.
;    1083 	// OC3B output: Discon.
;    1084 	// OC3C output: Discon.
;    1085 	// Timer 3 Overflow Interrupt: Off
;    1086 	// Input Capture Interrupt: Off
;    1087 	// Compare A Match Interrupt: Off
;    1088 	// Compare B Match Interrupt: Off
;    1089 	// Compare C Match Interrupt: Off
;    1090 	TCCR3A=0x00;
	STS  139,R30
;    1091 	TCCR3B=0x03;
	LDI  R30,LOW(3)
	STS  138,R30
;    1092 	TCNT3H=0x00;
	LDI  R30,LOW(0)
	STS  137,R30
;    1093 	TCNT3L=0x00;
	STS  136,R30
;    1094 	ICR3H=0x00;
	STS  129,R30
;    1095 	ICR3L=0x00;
	STS  128,R30
;    1096 	OCR3AH=0x00;
	STS  135,R30
;    1097 	OCR3AL=0x00;
	STS  134,R30
;    1098 	OCR3BH=0x00;
	STS  133,R30
;    1099 	OCR3BL=0x00;
	STS  132,R30
;    1100 	OCR3CH=0x00;
	STS  131,R30
;    1101 	OCR3CL=0x00;
	STS  130,R30
;    1102 
;    1103 	// External Interrupt(s) initialization
;    1104 	// INT0: Off
;    1105 	// INT1: Off
;    1106 	// INT2: Off
;    1107 	// INT3: Off
;    1108 	// INT4: Off
;    1109 	// INT5: Off
;    1110 	// INT6: On
;    1111 	// INT6 Mode: Falling Edge
;    1112 	// INT7: Off
;    1113 	EICRA=0x00;
	STS  106,R30
;    1114 	EICRB=0x20;
	LDI  R30,LOW(32)
	OUT  0x3A,R30
;    1115 	EIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
;    1116 	EIFR=0x40;
	OUT  0x38,R30
;    1117 
;    1118     // Timer(s)/Counter(s) Interrupt(s) initialization
;    1119     TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x37,R30
;    1120     ETIMSK=0x00;
	STS  125,R30
;    1121 
;    1122     // USART0 initialization
;    1123     // Communication Parameters: 8 Data, 1 Stop, No Parity
;    1124     // USART0 Receiver: On
;    1125     // USART0 Transmitter: On
;    1126     // USART0 Mode: Asynchronous
;    1127     // USART0 Baud rate: 115200
;    1128     UCSR0A=0x00;
	OUT  0xB,R30
;    1129 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;    1130     UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;    1131     UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;    1132 	UBRR0L=BR115200;
	LDI  R30,LOW(7)
	OUT  0x9,R30
;    1133 
;    1134     // USART1 initialization
;    1135     // Communication Parameters: 8 Data, 1 Stop, No Parity
;    1136     // USART1 Receiver: On
;    1137     // USART1 Transmitter: On
;    1138     // USART1 Mode: Asynchronous
;    1139     // USART1 Baud rate: 115200
;    1140     UCSR1A=0x00;
	LDI  R30,LOW(0)
	STS  155,R30
;    1141     UCSR1B=0x98;
	LDI  R30,LOW(152)
	STS  154,R30
;    1142     UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  157,R30
;    1143     UBRR1H=0x00;
	LDI  R30,LOW(0)
	STS  152,R30
;    1144 	UBRR1L=BR115200;
	LDI  R30,LOW(7)
	STS  153,R30
;    1145 
;    1146 	// Analog Comparator initialization
;    1147 	// Analog Comparator: Off
;    1148 	// Analog Comparator Input Capture by Timer/Counter 1: Off
;    1149 	// Analog Comparator Output: Off
;    1150 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;    1151 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;    1152 
;    1153     //ADC initialization
;    1154     //ADC Clock frequency: 460.800 kHz
;    1155     //ADC Voltage Reference: AREF pin
;    1156     //Only the 8 most significant bits of
;    1157     //the AD conversion result are used
;    1158     ADMUX=ADC_VREF_TYPE;
	LDI  R30,LOW(32)
	OUT  0x7,R30
;    1159     ADCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x6,R30
;    1160     
;    1161     TWCR = 0;
	STS  116,R30
;    1162 }
	RET
;    1163 
;    1164 
;    1165 //------------------------------------------------------------------------------
;    1166 // ÷ ʱȭ
;    1167 //------------------------------------------------------------------------------
;    1168 void SW_init(void) {
_SW_init:
;    1169 	PF1_LED1_OFF;
	SBI  0x1B,2
;    1170 	PF1_LED2_OFF;
	SBI  0x1B,3
;    1171 	PF2_LED_OFF;
	SBI  0x1B,4
;    1172 	PWR_LED1_OFF;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;    1173 	PWR_LED2_OFF;
	SBI  0x15,7
;    1174 	RUN_LED1_OFF;
	SBI  0x1B,5
;    1175 	RUN_LED2_OFF;
	SBI  0x1B,6
;    1176 	ERR_LED_OFF;
	SBI  0x1B,7
;    1177 	F_PF = ePF;
	LDI  R26,LOW(_ePF)
	LDI  R27,HIGH(_ePF)
	CALL __EEPROMRDB
	MOV  R13,R30
;    1178 	F_SCENE_PLAYING = 0;
	CLT
	BLD  R2,0
;    1179 	F_ACTION_PLAYING = 0;
	BLD  R2,1
;    1180 	F_MOTION_STOPPED = 0;
	BLD  R2,3
;    1181 	F_DIRECT_C_EN = 0;
	BLD  R2,2
;    1182 	F_CHARGING = 0;
	BLD  R2,6
;    1183 	F_MIC_INPUT = 0;
	BLD  R3,0
;    1184 	F_ERR_CODE = NO_ERR;
	LDI  R30,LOW(255)
	MOV  R14,R30
;    1185 	F_DOWNLOAD = 0;
	BLD  R2,4
;    1186 
;    1187 	gTx0Cnt = 0;
	LDI  R30,LOW(0)
	STS  _gTx0Cnt,R30
;    1188 	gTx0BufIdx = 0;
	STS  _gTx0BufIdx,R30
;    1189 	PSD_OFF;
	CBI  0x18,5
;    1190     g10MSEC=0;
	LDI  R30,0
	STS  _g10MSEC,R30
	STS  _g10MSEC+1,R30
;    1191     gSEC=0;
	LDI  R30,LOW(0)
	STS  _gSEC,R30
;    1192     gMIN=0;
	STS  _gMIN,R30
;    1193     gHOUR=0;
	STS  _gHOUR,R30
;    1194     F_PS_PLUGGED = 0;
	BLD  R2,5
;    1195     F_PF_CHANGED = 0;
	BLD  R3,1
;    1196     F_IR_RECEIVED = 0;
	BLD  R3,2
;    1197     F_EEPROM_BUSY = 0;
	STS  _F_EEPROM_BUSY,R30
;    1198 	P_EEP_VCC(1);
	SBI  0x18,2
;    1199 
;    1200 	gDownNumOfM = 0;
	STS  _gDownNumOfM,R30
;    1201 	gDownNumOfA = 0;
	STS  _gDownNumOfA,R30
;    1202 	F_FIRST_M = 1;
	SET
	BLD  R3,3
;    1203 }
	RET
;    1204 
;    1205 
;    1206 void SpecialMode(void)
;    1207 {
_SpecialMode:
;    1208 	int i;
;    1209 
;    1210 	if(F_PF == PF1_HUNO)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDI  R30,LOW(1)
	CP   R30,R13
	BRNE _0xEF
;    1211 		for(i = 0; i < 16; i++) BoundSetCmdSend(i, 1, 254);
	__GETWRN 16,17,0
_0xF1:
	__CPWRN 16,17,16
	BRGE _0xF2
	ST   -Y,R16
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(254)
	ST   -Y,R30
	RCALL _BoundSetCmdSend
;    1212 	else if(F_PF == PF1_DINO)
	__ADDWRN 16,17,1
	RJMP _0xF1
_0xF2:
	RJMP _0xF3
_0xEF:
	LDI  R30,LOW(2)
	CP   R30,R13
	BRNE _0xF4
;    1213 		for(i = 0; i < 16; i++) BoundSetCmdSend(i, 1, 254);
	__GETWRN 16,17,0
_0xF6:
	__CPWRN 16,17,16
	BRGE _0xF7
	ST   -Y,R16
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(254)
	ST   -Y,R30
	RCALL _BoundSetCmdSend
;    1214 	else if(F_PF == PF1_DOGY)
	__ADDWRN 16,17,1
	RJMP _0xF6
_0xF7:
	RJMP _0xF8
_0xF4:
	LDI  R30,LOW(3)
	CP   R30,R13
	BRNE _0xF9
;    1215 		for(i = 0; i < 16; i++) BoundSetCmdSend(i, 1, 254);
	__GETWRN 16,17,0
_0xFB:
	__CPWRN 16,17,16
	BRGE _0xFC
	ST   -Y,R16
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(254)
	ST   -Y,R30
	RCALL _BoundSetCmdSend
;    1216 	else if(F_PF == PF2)
	__ADDWRN 16,17,1
	RJMP _0xFB
_0xFC:
	RJMP _0xFD
_0xF9:
	LDI  R30,LOW(4)
	CP   R30,R13
	BRNE _0xFE
;    1217 		for(i = 0; i < 16; i++) BoundSetCmdSend(i, 1, 254);
	__GETWRN 16,17,0
_0x100:
	__CPWRN 16,17,16
	BRGE _0x101
	ST   -Y,R16
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(254)
	ST   -Y,R30
	RCALL _BoundSetCmdSend
;    1218 
;    1219 	BreakModeCmdSend();
	__ADDWRN 16,17,1
	RJMP _0x100
_0x101:
_0xFE:
_0xFD:
_0xF8:
_0xF3:
	RCALL _BreakModeCmdSend
;    1220 	delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1221 	
;    1222 	if(PINA.0 == 0 && PINA.1 == 1){
	SBIC 0x19,0
	RJMP _0x103
	SBIC 0x19,1
	RJMP _0x104
_0x103:
	RJMP _0x102
_0x104:
;    1223 		BasicPose(0, 150, 3000, 4);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _BasicPose
;    1224 		delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1225 		if(F_ERR_CODE != NO_ERR){
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ _0x105
;    1226 			gSEC_DCOUNT = 30;
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	STS  _gSEC_DCOUNT,R30
	STS  _gSEC_DCOUNT+1,R31
;    1227 			EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;    1228 			while(gSEC_DCOUNT){
_0x106:
	LDS  R30,_gSEC_DCOUNT
	LDS  R31,_gSEC_DCOUNT+1
	SBIW R30,0
	BREQ _0x108
;    1229 				if(g10MSEC < 25)		ERR_LED_ON;
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,25
	BRSH _0x109
	CBI  0x1B,7
;    1230 				else if(g10MSEC < 50)	ERR_LED_OFF;
	RJMP _0x10A
_0x109:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,50
	BRSH _0x10B
	RJMP _0x326
;    1231 				else if(g10MSEC < 75)	ERR_LED_ON;
_0x10B:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CPI  R26,LOW(0x4B)
	LDI  R30,HIGH(0x4B)
	CPC  R27,R30
	BRSH _0x10D
	CBI  0x1B,7
;    1232 				else if(g10MSEC < 100)	ERR_LED_OFF;
	RJMP _0x10E
_0x10D:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRSH _0x10F
_0x326:
	SBI  0x1B,7
;    1233 			}
_0x10F:
_0x10E:
_0x10A:
	RJMP _0x106
_0x108:
;    1234 			F_ERR_CODE = NO_ERR;
	LDI  R30,LOW(255)
	MOV  R14,R30
;    1235 			EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;    1236 		}
;    1237 		else BasicPose(0, 1, 100, 1);
	RJMP _0x110
_0x105:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _BasicPose
;    1238 	}
_0x110:
;    1239 	else if(PINA.0 == 1 && PINA.1 == 0){
	RJMP _0x111
_0x102:
	SBIS 0x19,0
	RJMP _0x113
	SBIS 0x19,1
	RJMP _0x114
_0x113:
	RJMP _0x112
_0x114:
;    1240 		delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1241 		if(PINA.0 == 1){
	SBIS 0x19,0
	RJMP _0x115
;    1242 		    TIMSK &= 0xFE;
	IN   R30,0x37
	ANDI R30,0xFE
	OUT  0x37,R30
;    1243 			EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;    1244 			UCSR0B |= 0x80;
	SBI  0xA,7
;    1245 			UCSR0B &= 0xBF;
	CBI  0xA,6
;    1246 			F_DIRECT_C_EN = 1;
	SET
	BLD  R2,2
;    1247 		}
;    1248 	}
_0x115:
;    1249 	else if(PINA.0 == 0 && PINA.1 == 0){
	RJMP _0x116
_0x112:
	SBIC 0x19,0
	RJMP _0x118
	SBIS 0x19,1
	RJMP _0x119
_0x118:
	RJMP _0x117
_0x119:
;    1250 		while(gSEC < 11){
_0x11A:
	LDS  R26,_gSEC
	CPI  R26,LOW(0xB)
	BRLO PC+3
	JMP _0x11C
;    1251 			if(g10MSEC > 50){	RUN_LED1_OFF;	RUN_LED2_OFF;	}
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,51
	BRLO _0x11D
	SBI  0x1B,5
	SBI  0x1B,6
;    1252 			else{				RUN_LED1_ON;	RUN_LED2_ON;	}
	RJMP _0x11E
_0x11D:
	CBI  0x1B,5
	CBI  0x1B,6
_0x11E:
;    1253 			if(F_IR_RECEIVED){
	SBRS R3,2
	RJMP _0x11F
;    1254 			    EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;    1255 				F_IR_RECEIVED = 0;
	CLT
	BLD  R3,2
;    1256 				if(gIrBuf[3] == BTN_C){
	__GETB1MN _gIrBuf,3
	CPI  R30,LOW(0x7)
	BREQ PC+3
	JMP _0x120
;    1257 					for(i = 1; i < NUM_OF_REMOCON; i++){
	__GETWRN 16,17,1
_0x122:
	__CPWRN 16,17,5
	BRGE _0x123
;    1258 						eRCodeH[i-1] = eRCodeH[i];
	MOVW R30,R16
	SBIW R30,1
	SUBI R30,LOW(-_eRCodeH)
	SBCI R31,HIGH(-_eRCodeH)
	MOVW R0,R30
	LDI  R26,LOW(_eRCodeH)
	LDI  R27,HIGH(_eRCodeH)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;    1259 						eRCodeM[i-1] = eRCodeM[i];
	MOVW R30,R16
	SBIW R30,1
	SUBI R30,LOW(-_eRCodeM)
	SBCI R31,HIGH(-_eRCodeM)
	MOVW R0,R30
	LDI  R26,LOW(_eRCodeM)
	LDI  R27,HIGH(_eRCodeM)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;    1260 						eRCodeL[i-1] = eRCodeL[i];
	MOVW R30,R16
	SBIW R30,1
	SUBI R30,LOW(-_eRCodeL)
	SBCI R31,HIGH(-_eRCodeL)
	MOVW R0,R30
	LDI  R26,LOW(_eRCodeL)
	LDI  R27,HIGH(_eRCodeL)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	MOVW R26,R0
	CALL __EEPROMWRB
;    1261 					}
	__ADDWRN 16,17,1
	RJMP _0x122
_0x123:
;    1262 					eRCodeH[NUM_OF_REMOCON-1] = gIrBuf[0]; 
	__POINTW2MN _eRCodeH,4
	LDS  R30,_gIrBuf
	CALL __EEPROMWRB
;    1263 					eRCodeM[NUM_OF_REMOCON-1] = gIrBuf[1]; 
	__POINTW2MN _eRCodeM,4
	__GETB1MN _gIrBuf,1
	CALL __EEPROMWRB
;    1264 					eRCodeL[NUM_OF_REMOCON-1] = gIrBuf[2];
	__POINTW2MN _eRCodeL,4
	__GETB1MN _gIrBuf,2
	CALL __EEPROMWRB
;    1265 
;    1266 					for(i = 0; i < 3; i++){
	__GETWRN 16,17,0
_0x125:
	__CPWRN 16,17,3
	BRGE _0x126
;    1267 						PF1_LED1_ON; PF1_LED2_ON; PF2_LED_ON; RUN_LED1_ON; 
	CBI  0x1B,2
	CBI  0x1B,3
	CBI  0x1B,4
	CBI  0x1B,5
;    1268 						RUN_LED2_ON; ERR_LED_ON; PWR_LED1_ON; PWR_LED2_ON;
	CBI  0x1B,6
	CBI  0x1B,7
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
	CBI  0x15,7
;    1269 						delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1270 						PF1_LED1_OFF; PF1_LED2_OFF; PF2_LED_OFF; RUN_LED1_OFF; 
	SBI  0x1B,2
	SBI  0x1B,3
	SBI  0x1B,4
	SBI  0x1B,5
;    1271 						RUN_LED2_OFF; ERR_LED_OFF; PWR_LED1_OFF; PWR_LED2_ON;
	SBI  0x1B,6
	SBI  0x1B,7
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
	CBI  0x15,7
;    1272 						delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1273 					}
	__ADDWRN 16,17,1
	RJMP _0x125
_0x126:
;    1274 
;    1275 					for(i = 0; i < IR_BUFFER_SIZE; i++)	gIrBuf[i]=0;
	__GETWRN 16,17,0
_0x128:
	__CPWRN 16,17,4
	BRGE _0x129
	LDI  R26,LOW(_gIrBuf)
	LDI  R27,HIGH(_gIrBuf)
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
;    1276 				    EIMSK |= 0x40;
	__ADDWRN 16,17,1
	RJMP _0x128
_0x129:
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;    1277 					break;
	RJMP _0x11C
;    1278 				}
;    1279 				for(i = 0; i < IR_BUFFER_SIZE; i++)	gIrBuf[i]=0;
_0x120:
	__GETWRN 16,17,0
_0x12B:
	__CPWRN 16,17,4
	BRGE _0x12C
	LDI  R26,LOW(_gIrBuf)
	LDI  R27,HIGH(_gIrBuf)
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
;    1280 			    EIMSK |= 0x40;
	__ADDWRN 16,17,1
	RJMP _0x12B
_0x12C:
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;    1281 			}
;    1282 		}
_0x11F:
	RJMP _0x11A
_0x11C:
;    1283 	}
;    1284 }
_0x117:
_0x116:
_0x111:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1285 
;    1286 
;    1287 void ProcComm(void)
;    1288 {
_ProcComm:
;    1289 	BYTE	lbtmp;
;    1290 
;    1291 	if(F_RSV_PSD_READ){
	ST   -Y,R16
;	lbtmp -> R16
	SBRS R3,7
	RJMP _0x12D
;    1292 		F_RSV_PSD_READ = 0;
	CLT
	BLD  R3,7
;    1293 		Get_AD_PSD();
	CALL _Get_AD_PSD
;    1294 		SendToPC(22,2);
	LDI  R30,LOW(22)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _SendToPC
;    1295 		gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;    1296 		sciTx1Data(gDistance);
	ST   -Y,R8
	RCALL _sciTx1Data
;    1297 		sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _sciTx1Data
;    1298 		gFileCheckSum ^= gDistance;
	MOV  R30,R8
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;    1299 		sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;    1300 	}
;    1301 	if(F_RSV_SOUND_READ){
_0x12D:
	SBRS R3,5
	RJMP _0x12E
;    1302 		Get_AD_MIC();
	CALL _Get_AD_MIC
;    1303 		if(gSoundMinTh <= gSoundLevel){
	LDS  R26,_gSoundMinTh
	CP   R9,R26
	BRLO _0x12F
;    1304 			SendToPC(23,2);
	LDI  R30,LOW(23)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _SendToPC
;    1305 			gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;    1306 			sciTx1Data(gSoundLevel);
	ST   -Y,R9
	RCALL _sciTx1Data
;    1307 			sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _sciTx1Data
;    1308 			gFileCheckSum ^= gSoundLevel;
	MOV  R30,R9
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;    1309 			sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;    1310 		}
;    1311 	}
_0x12F:
;    1312 	if(F_RSV_BTN_READ){
_0x12E:
	SBRS R3,6
	RJMP _0x130
;    1313 		lbtmp = PINA & 0x03;
	IN   R30,0x19
	ANDI R30,LOW(0x3)
	MOV  R16,R30
;    1314 		if(lbtmp == 0x02){	
	CPI  R16,2
	BRNE _0x131
;    1315 			delay_ms(30);
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1316 			if(lbtmp == 0x02){
	CPI  R16,2
	BRNE _0x132
;    1317 				SendToPC(24,2);
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _SendToPC
;    1318 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;    1319 				sciTx1Data(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _sciTx1Data
;    1320 				sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _sciTx1Data
;    1321 				gFileCheckSum ^= 1;
	LDS  R26,_gFileCheckSum
	LDI  R30,LOW(1)
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;    1322 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;    1323 				delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1324 			}
;    1325 		}
_0x132:
;    1326 		else if(lbtmp == 0x01){
	RJMP _0x133
_0x131:
	CPI  R16,1
	BRNE _0x134
;    1327 			delay_ms(30);
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1328 			if(lbtmp == 0x01){
	CPI  R16,1
	BRNE _0x135
;    1329 				SendToPC(24,2);
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _SendToPC
;    1330 				gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;    1331 				sciTx1Data(2);
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _sciTx1Data
;    1332 				sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _sciTx1Data
;    1333 				gFileCheckSum ^= 2;
	LDS  R26,_gFileCheckSum
	LDI  R30,LOW(2)
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;    1334 				sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	RCALL _sciTx1Data
;    1335 				delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1336 			}
;    1337 		}
_0x135:
;    1338 	}
_0x134:
_0x133:
;    1339 }
_0x130:
	LD   R16,Y+
	RET
;    1340 
;    1341 
;    1342 //------------------------------------------------------------------------------
;    1343 //  Լ
;    1344 //------------------------------------------------------------------------------
;    1345 void main(void) {
_main:
;    1346 	WORD    l10MSEC;
;    1347 
;    1348 	HW_init();
;	l10MSEC -> R16,R17
	CALL _HW_init
;    1349 	SW_init();
	CALL _SW_init
;    1350 	Acc_init();
	CALL _Acc_init
;    1351 
;    1352 	#asm("sei");
	sei
;    1353 	TIMSK |= 0x01;
	IN   R30,0x37
	ORI  R30,1
	OUT  0x37,R30
;    1354 
;    1355 	SpecialMode();
	CALL _SpecialMode
;    1356 
;    1357 	P_BMC504_RESET(0);
	CBI  0x18,6
;    1358 	delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1359 	P_BMC504_RESET(1);
	SBI  0x18,6
;    1360 
;    1361 	SelfTest1();
	CALL _SelfTest1
;    1362 	while(1){
_0x13A:
;    1363 		ReadButton();
	CALL _ReadButton
;    1364 		ProcButton();
	CALL _ProcButton
;    1365 		IoUpdate();
	CALL _IoUpdate
;    1366 		if(g10MSEC == 0 || g10MSEC == 50){
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CALL __CPW02
	BREQ _0x13E
	SBIW R26,50
	BRNE _0x13D
_0x13E:
;    1367 			if(g10MSEC != l10MSEC){
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CP   R16,R26
	CPC  R17,R27
	BREQ _0x140
;    1368 				l10MSEC = g10MSEC;
	__GETWRMN 16,17,0,_g10MSEC
;    1369 				Get_VOLTAGE();
	CALL _Get_VOLTAGE
;    1370 				DetectPower();
	CALL _DetectPower
;    1371 			}
;    1372 		}
_0x140:
;    1373 		ProcIr();
_0x13D:
	CALL _ProcIr
;    1374 		AccGetData();
	CALL _AccGetData
;    1375 		ProcComm();
	CALL _ProcComm
;    1376 	}
	RJMP _0x13A
;    1377 }
_0x141:
	RJMP _0x141
;    1378 //==============================================================================
;    1379 //						Communication & Command Լ
;    1380 //==============================================================================
;    1381 
;    1382 #include <mega128.h>
;    1383 #include <string.h>
;    1384 #include "Main.h"
;    1385 #include "Macro.h"
;    1386 #include "Comm.h"
;    1387 #include "HunoBasic_080819.h"
;    1388 #include "DinoBasic_2.h"
;    1389 #include "DogyBasic_2.h"
;    1390 #include "my_demo1.h"	//   
;    1391 
;    1392 
;    1393 BYTE flash fM1_BasicPose[16]={
;    1394 /* ID
;    1395  0 ,1  ,2  ,3  ,4  ,5  ,6  ,7  ,8  ,9  , 10, 11, 12, 13, 14, 15 */
;    1396 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205};
;    1397 
;    1398 BYTE flash fM2_BasicPose[16]={
;    1399 /* ID
;    1400  0 ,1  ,2  ,3  ,4  ,5  ,6  ,7  ,8  ,9  , 10, 11, 12, 13, 14, 15 */
;    1401 125,179,199, 88,108,126, 72, 49,163,141, 89,127, 47,159,112,171};
;    1402 
;    1403 BYTE flash fM3_BasicPose[16]={
;    1404 /* ID
;    1405  0 ,1  ,2  ,3  ,4  ,5  ,6  ,7  ,8  ,9  , 10, 11, 12, 13, 14, 15 */
;    1406 159,209,127,127,200, 91, 41,127,127, 52,143, 39, 52,109,210,200};
;    1407 
;    1408 
;    1409 //------------------------------------------------------------------------------
;    1410 // ø Ʈ  ڸ ϱ  Լ
;    1411 //------------------------------------------------------------------------------
;    1412 void sciTx0Data(BYTE td)
;    1413 {
_sciTx0Data:
;    1414 	while(!(UCSR0A & DATA_REGISTER_EMPTY));
;	td -> Y+0
_0x142:
	SBIS 0xB,5
	RJMP _0x142
;    1415 	UDR0 = td;
	LD   R30,Y
	OUT  0xC,R30
;    1416 }
	RJMP _0x31C
;    1417 
;    1418 void sciTx1Data(BYTE td)
;    1419 {
_sciTx1Data:
;    1420 	while(!(UCSR1A & DATA_REGISTER_EMPTY));
;	td -> Y+0
_0x145:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x145
;    1421 	UDR1 = td;
	LD   R30,Y
	STS  156,R30
;    1422 }
_0x31C:
	ADIW R28,1
	RET
;    1423 
;    1424 
;    1425 //------------------------------------------------------------------------------
;    1426 // ø Ʈ  ڸ  ϱ  Լ
;    1427 //------------------------------------------------------------------------------
;    1428 BYTE sciRx0Ready(void)
;    1429 {
;    1430 	WORD	startT;
;    1431 
;    1432 	startT = g10MSEC;
;	startT -> R16,R17
;    1433 	while(!(UCSR0A & RX_COMPLETE)){
;    1434         if(g10MSEC < startT){
;    1435             if((100 - startT + g10MSEC) > RX_T_OUT) break;
;    1436         }
;    1437 		else if((g10MSEC-startT) > RX_T_OUT) break;
;    1438 	}
;    1439 	return UDR0;
;    1440 }
;    1441 
;    1442 BYTE sciRx1Ready(void)
;    1443 {
;    1444 	WORD	startT;
;    1445 
;    1446 	startT = g10MSEC;
;	startT -> R16,R17
;    1447 	while(!(UCSR1A & RX_COMPLETE)){
;    1448         if(g10MSEC < startT){
;    1449             if((100 - startT + g10MSEC) > RX_T_OUT) break;
;    1450         }
;    1451 		else if((g10MSEC-startT) > RX_T_OUT) break;
;    1452 	}
;    1453 	return UDR1;
;    1454 }
;    1455 
;    1456 
;    1457 //------------------------------------------------------------------------------
;    1458 // wCK   Ŷ(4Ʈ)  Լ                                                                     */
;    1459 //------------------------------------------------------------------------------
;    1460 void SendOperCmd(BYTE Data1,BYTE Data2)
;    1461 {
_SendOperCmd:
;    1462 	BYTE CheckSum; 
;    1463 	CheckSum = (Data1^Data2)&0x7f;
	ST   -Y,R16
;	Data1 -> Y+2
;	Data2 -> Y+1
;	CheckSum -> R16
	LDD  R30,Y+1
	LDD  R26,Y+2
	EOR  R26,R30
	LDI  R30,LOW(127)
	AND  R30,R26
	MOV  R16,R30
;    1464 
;    1465 	gTx0Buf[gTx0Cnt] = HEADER;
	LDS  R26,_gTx0Cnt
	LDI  R27,0
	SUBI R26,LOW(-_gTx0Buf)
	SBCI R27,HIGH(-_gTx0Buf)
	LDI  R30,LOW(255)
	ST   X,R30
;    1466 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1467 
;    1468 	gTx0Buf[gTx0Cnt] = Data1;
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LDD  R26,Y+2
	STD  Z+0,R26
;    1469 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1470 
;    1471 	gTx0Buf[gTx0Cnt] = Data2;
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LDD  R26,Y+1
	STD  Z+0,R26
;    1472 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1473 
;    1474 	gTx0Buf[gTx0Cnt] = CheckSum;
	LDS  R26,_gTx0Cnt
	LDI  R27,0
	SUBI R26,LOW(-_gTx0Buf)
	SBCI R27,HIGH(-_gTx0Buf)
	ST   X,R16
;    1475 	gTx0Cnt++;
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1476 
;    1477 }
	LDD  R16,Y+0
	ADIW R28,3
	RET
;    1478 
;    1479 
;    1480 //------------------------------------------------------------------------------
;    1481 // wCK Ķ͸   Ѵ
;    1482 //------------------------------------------------------------------------------
;    1483 void SendSetCmd(BYTE ID, BYTE Data1, BYTE Data2, BYTE Data3)
;    1484 {
_SendSetCmd:
;    1485 	BYTE	CheckSum; 
;    1486 
;    1487 	ID = (BYTE)(7<<5)|ID; 
	ST   -Y,R16
;	ID -> Y+4
;	Data1 -> Y+3
;	Data2 -> Y+2
;	Data3 -> Y+1
;	CheckSum -> R16
	LDD  R30,Y+4
	ORI  R30,LOW(0xE0)
	STD  Y+4,R30
;    1488 	CheckSum = (ID^Data1^Data2^Data3)&0x7f;
	LDD  R30,Y+3
	LDD  R26,Y+4
	EOR  R30,R26
	LDD  R26,Y+2
	EOR  R30,R26
	LDD  R26,Y+1
	EOR  R26,R30
	LDI  R30,LOW(127)
	AND  R30,R26
	MOV  R16,R30
;    1489 
;    1490 	gTx0Buf[gTx0Cnt] = HEADER;
	LDS  R26,_gTx0Cnt
	LDI  R27,0
	SUBI R26,LOW(-_gTx0Buf)
	SBCI R27,HIGH(-_gTx0Buf)
	LDI  R30,LOW(255)
	ST   X,R30
;    1491 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1492 
;    1493 	gTx0Buf[gTx0Cnt] = ID;
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LDD  R26,Y+4
	STD  Z+0,R26
;    1494 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1495 
;    1496 	gTx0Buf[gTx0Cnt] = Data1;
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LDD  R26,Y+3
	STD  Z+0,R26
;    1497 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1498 
;    1499 	gTx0Buf[gTx0Cnt] = Data2;
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LDD  R26,Y+2
	STD  Z+0,R26
;    1500 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1501 
;    1502 	gTx0Buf[gTx0Cnt] = Data3;
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LDD  R26,Y+1
	STD  Z+0,R26
;    1503 	gTx0Cnt++;
	LDS  R30,_gTx0Cnt
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1504 
;    1505 	gTx0Buf[gTx0Cnt] = CheckSum;
	LDS  R26,_gTx0Cnt
	LDI  R27,0
	SUBI R26,LOW(-_gTx0Buf)
	SBCI R27,HIGH(-_gTx0Buf)
	ST   X,R16
;    1506 	gTx0Cnt++;
	SUBI R30,-LOW(1)
	STS  _gTx0Cnt,R30
;    1507 }
	LDD  R16,Y+0
	ADIW R28,5
	RET
;    1508 
;    1509 
;    1510 //------------------------------------------------------------------------------
;    1511 // ġ (Position Send Command)  Լ
;    1512 //------------------------------------------------------------------------------
;    1513 void PosSend(BYTE ID, BYTE Position, BYTE SpeedLevel) 
;    1514 {
_PosSend:
;    1515 	BYTE Data1;
;    1516 
;    1517 	Data1 = (SpeedLevel<<5) | ID;
	ST   -Y,R16
;	ID -> Y+3
;	Position -> Y+2
;	SpeedLevel -> Y+1
;	Data1 -> R16
	LDD  R30,Y+1
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LDD  R26,Y+3
	OR   R30,R26
	MOV  R16,R30
;    1518 	SendOperCmd(Data1,Position);
	ST   -Y,R16
	LDD  R30,Y+3
	ST   -Y,R30
	CALL _SendOperCmd
;    1519 }
	LDD  R16,Y+0
	RJMP _0x319
;    1520 
;    1521 
;    1522 //------------------------------------------------------------------------------
;    1523 // 극ũ    Լ
;    1524 //------------------------------------------------------------------------------
;    1525 void BreakModeCmdSend(void)
;    1526 {
_BreakModeCmdSend:
;    1527 	BYTE	Data1, Data2;
;    1528 	BYTE	CheckSum; 
;    1529 
;    1530 	Data1 = (6<<5) | 31;
	CALL __SAVELOCR3
;	Data1 -> R16
;	Data2 -> R17
;	CheckSum -> R18
	LDI  R16,LOW(223)
;    1531 	Data2 = 0x20;
	LDI  R17,LOW(32)
;    1532 	CheckSum = (Data1^Data2)&0x7f;
	MOV  R30,R17
	EOR  R30,R16
	ANDI R30,0x7F
	MOV  R18,R30
;    1533 
;    1534 	sciTx0Data(HEADER);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _sciTx0Data
;    1535 	sciTx0Data(Data1);
	ST   -Y,R16
	CALL _sciTx0Data
;    1536 	sciTx0Data(Data2);
	ST   -Y,R17
	CALL _sciTx0Data
;    1537 	sciTx0Data(CheckSum);
	ST   -Y,R18
	CALL _sciTx0Data
;    1538 } 
	CALL __LOADLOCR3
	ADIW R28,3
	RET
;    1539 
;    1540 
;    1541 //------------------------------------------------------------------------------
;    1542 // ̵    Լ
;    1543 //------------------------------------------------------------------------------
;    1544 void BoundSetCmdSend(BYTE ID, BYTE B_L, BYTE B_U)
;    1545 {
_BoundSetCmdSend:
;    1546 	BYTE	Data1, Data2;
;    1547 	BYTE	CheckSum; 
;    1548 
;    1549 	Data1 = (7<<5) | ID;
	CALL __SAVELOCR3
;	ID -> Y+5
;	B_L -> Y+4
;	B_U -> Y+3
;	Data1 -> R16
;	Data2 -> R17
;	CheckSum -> R18
	LDD  R30,Y+5
	ORI  R30,LOW(0xE0)
	MOV  R16,R30
;    1550 	Data2 = 17;
	LDI  R17,LOW(17)
;    1551 	CheckSum = (Data1^Data2^B_U^B_L)&0x7f;
	MOV  R30,R17
	EOR  R30,R16
	LDD  R26,Y+3
	EOR  R30,R26
	LDD  R26,Y+4
	EOR  R26,R30
	LDI  R30,LOW(127)
	AND  R30,R26
	MOV  R18,R30
;    1552 
;    1553 	sciTx0Data(HEADER);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _sciTx0Data
;    1554 	sciTx0Data(Data1);
	ST   -Y,R16
	CALL _sciTx0Data
;    1555 	sciTx0Data(Data2);
	ST   -Y,R17
	CALL _sciTx0Data
;    1556 	sciTx0Data(B_L);
	LDD  R30,Y+4
	ST   -Y,R30
	CALL _sciTx0Data
;    1557 	sciTx0Data(B_U);
	LDD  R30,Y+3
	ST   -Y,R30
	CALL _sciTx0Data
;    1558 	sciTx0Data(CheckSum);
	ST   -Y,R18
	CALL _sciTx0Data
;    1559 }
	CALL __LOADLOCR3
	ADIW R28,6
	RET
;    1560 
;    1561 //------------------------------------------------------------------------------
;    1562 // ġ б (Position Send Command)  Լ
;    1563 //------------------------------------------------------------------------------
;    1564 WORD PosRead(BYTE ID) 
;    1565 {
_PosRead:
;    1566 	BYTE	Data1, Data2;
;    1567 	BYTE	CheckSum; 
;    1568 	WORD	startT;
;    1569 
;    1570 	Data1 = (5<<5) | ID;
	CALL __SAVELOCR5
;	ID -> Y+5
;	Data1 -> R16
;	Data2 -> R17
;	CheckSum -> R18
;	startT -> R19,R20
	LDD  R30,Y+5
	ORI  R30,LOW(0xA0)
	MOV  R16,R30
;    1571 	Data2 = 0;
	LDI  R17,LOW(0)
;    1572 	gRx0Cnt = 0;
	LDI  R30,LOW(0)
	STS  _gRx0Cnt,R30
;    1573 	CheckSum = (Data1^Data2)&0x7f;
	MOV  R30,R17
	EOR  R30,R16
	ANDI R30,0x7F
	MOV  R18,R30
;    1574 	RX0_OFF;
	CBI  0xA,4
;    1575 	sciTx0Data(HEADER);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _sciTx0Data
;    1576 	sciTx0Data(Data1);
	ST   -Y,R16
	CALL _sciTx0Data
;    1577 	sciTx0Data(Data2);
	ST   -Y,R17
	CALL _sciTx0Data
;    1578 	sciTx0Data(CheckSum);
	ST   -Y,R18
	CALL _sciTx0Data
;    1579 	RX0_ON;
	SBI  0xA,4
;    1580 	startT = g10MSEC;
	__GETWRMN 19,20,0,_g10MSEC
;    1581 	while(gRx0Cnt < 2){
_0x156:
	LDS  R26,_gRx0Cnt
	CPI  R26,LOW(0x2)
	BRSH _0x158
;    1582         if(g10MSEC < startT){
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CP   R26,R19
	CPC  R27,R20
	BRSH _0x159
;    1583             if((100 - startT + g10MSEC) > RX_T_OUT)
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	SUB  R30,R19
	SBC  R31,R20
	ADD  R26,R30
	ADC  R27,R31
	SBIW R26,21
	BRLO _0x15A
;    1584             	return 444;
	LDI  R30,LOW(444)
	LDI  R31,HIGH(444)
	RJMP _0x31B
;    1585         }
_0x15A:
;    1586 		else if((g10MSEC - startT) > RX_T_OUT) return 444;
	RJMP _0x15B
_0x159:
	LDS  R30,_g10MSEC
	LDS  R31,_g10MSEC+1
	SUB  R30,R19
	SBC  R31,R20
	SBIW R30,21
	BRLO _0x15C
	LDI  R30,LOW(444)
	LDI  R31,HIGH(444)
	RJMP _0x31B
;    1587 	}
_0x15C:
_0x15B:
	RJMP _0x156
_0x158:
;    1588 	return (WORD)gRx0Buf[RX0_BUF_SIZE - 1];
	__GETB1MN _gRx0Buf,7
	LDI  R31,0
_0x31B:
	CALL __LOADLOCR5
	ADIW R28,6
	RET
;    1589 } 
;    1590 
;    1591 
;    1592 //------------------------------------------------------------------------------
;    1593 //  Ĩ   Լ
;    1594 //------------------------------------------------------------------------------
;    1595 void SendToSoundIC(BYTE cmd) 
;    1596 {
_SendToSoundIC:
;    1597 	BYTE	CheckSum; 
;    1598 
;    1599 	gRx0Cnt = 0;
	ST   -Y,R16
;	cmd -> Y+1
;	CheckSum -> R16
	LDI  R30,LOW(0)
	STS  _gRx0Cnt,R30
;    1600 	CheckSum = (29^cmd)&0x7f;
	LDD  R30,Y+1
	LDI  R26,LOW(29)
	EOR  R26,R30
	LDI  R30,LOW(127)
	AND  R30,R26
	MOV  R16,R30
;    1601 	sciTx0Data(HEADER);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _sciTx0Data
;    1602 	delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1603 	sciTx0Data(29);
	LDI  R30,LOW(29)
	ST   -Y,R30
	CALL _sciTx0Data
;    1604 	delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1605 	sciTx0Data(cmd);
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _sciTx0Data
;    1606 	delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1607 	sciTx0Data(CheckSum);
	ST   -Y,R16
	CALL _sciTx0Data
;    1608 } 
	LDD  R16,Y+0
	RJMP _0x31A
;    1609 
;    1610 
;    1611 //------------------------------------------------------------------------------
;    1612 // PC   
;    1613 //------------------------------------------------------------------------------
;    1614 void SendToPC(BYTE Cmd, BYTE CSize)
;    1615 {
_SendToPC:
;    1616 	sciTx1Data(0xFF);
;	Cmd -> Y+1
;	CSize -> Y+0
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _sciTx1Data
;    1617 	sciTx1Data(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _sciTx1Data
;    1618 	sciTx1Data(0xAA);
	LDI  R30,LOW(170)
	ST   -Y,R30
	CALL _sciTx1Data
;    1619 	sciTx1Data(0x55);
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _sciTx1Data
;    1620 	sciTx1Data(0xAA);
	LDI  R30,LOW(170)
	ST   -Y,R30
	CALL _sciTx1Data
;    1621 	sciTx1Data(0x55);
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _sciTx1Data
;    1622 	sciTx1Data(0x37);
	LDI  R30,LOW(55)
	ST   -Y,R30
	CALL _sciTx1Data
;    1623 	sciTx1Data(0xBA);
	LDI  R30,LOW(186)
	ST   -Y,R30
	CALL _sciTx1Data
;    1624 	sciTx1Data(Cmd);
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _sciTx1Data
;    1625 	sciTx1Data(F_PF);
	ST   -Y,R13
	CALL _sciTx1Data
;    1626 	sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _sciTx1Data
;    1627 	sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _sciTx1Data
;    1628 	sciTx1Data(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _sciTx1Data
;    1629 	sciTx1Data(CSize);
	LD   R30,Y
	ST   -Y,R30
	CALL _sciTx1Data
;    1630 }
_0x31A:
	ADIW R28,2
	RET
;    1631 
;    1632 
;    1633 
;    1634 //------------------------------------------------------------------------------
;    1635 // Flash   б
;    1636 //------------------------------------------------------------------------------
;    1637 void GetMotionFromFlash(void)
;    1638 {
_GetMotionFromFlash:
;    1639 	WORD	i;
;    1640 
;    1641 	for(i=0;i<MAX_wCK;i++){
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,0
_0x15E:
	__CPWRN 16,17,31
	BRLO PC+3
	JMP _0x15F
;    1642 		Motion.wCK[i].Exist		= 0;
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1643 		Motion.wCK[i].RPgain	= 0;
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,11
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1644 		Motion.wCK[i].RDgain	= 0;
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,12
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1645 		Motion.wCK[i].RIgain	= 0;
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,13
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1646 		Motion.wCK[i].PortEn	= 0;
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,14
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1647 		Motion.wCK[i].InitPos	= 0;
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,15
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1648 		gPoseDelta[i] = 0;
	MOVW R30,R16
	LDI  R26,LOW(_gPoseDelta)
	LDI  R27,HIGH(_gPoseDelta)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
;    1649 	}
	__ADDWRN 16,17,1
	RJMP _0x15E
_0x15F:
;    1650 	gLastID = wCK_IDs[Motion.NumOfwCK-1];
	__GETW1MN _Motion,8
	SBIW R30,1
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	STS  _gLastID,R30
;    1651 	for(i=0;i<Motion.NumOfwCK;i++){
	__GETWRN 16,17,0
_0x161:
	__GETW1MN _Motion,8
	CP   R16,R30
	CPC  R17,R31
	BRLO PC+3
	JMP _0x162
;    1652 		Motion.wCK[wCK_IDs[i]].Exist	= 1;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1653 		Motion.wCK[wCK_IDs[i]].RPgain	= *(gpPg_Table+i);
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Motion,11
	MOVW R0,R30
	MOVW R30,R16
	LDS  R26,_gpPg_Table
	LDS  R27,_gpPg_Table+1
	LDS  R24,_gpPg_Table+2
	LDS  R25,_gpPg_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	MOVW R26,R0
	ST   X,R30
;    1654 		Motion.wCK[wCK_IDs[i]].RDgain	= *(gpDg_Table+i);
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Motion,12
	MOVW R0,R30
	MOVW R30,R16
	LDS  R26,_gpDg_Table
	LDS  R27,_gpDg_Table+1
	LDS  R24,_gpDg_Table+2
	LDS  R25,_gpDg_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	MOVW R26,R0
	ST   X,R30
;    1655 		Motion.wCK[wCK_IDs[i]].RIgain	= *(gpIg_Table+i);
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Motion,13
	MOVW R0,R30
	MOVW R30,R16
	LDS  R26,_gpIg_Table
	LDS  R27,_gpIg_Table+1
	LDS  R24,_gpIg_Table+2
	LDS  R25,_gpIg_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	MOVW R26,R0
	ST   X,R30
;    1656 		Motion.wCK[wCK_IDs[i]].PortEn	= 1;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Motion,14
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1657 		Motion.wCK[wCK_IDs[i]].InitPos	= MotionZeroPos[i];
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Motion,15
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_MotionZeroPos*2)
	SBCI R31,HIGH(-_MotionZeroPos*2)
	SBCI R22,BYTE3(-_MotionZeroPos*2)
	__GETBRPF 30
	ST   X,R30
;    1658 	}
	__ADDWRN 16,17,1
	RJMP _0x161
_0x162:
;    1659 	for(i=0;i<Motion.NumOfwCK;i++)
	__GETWRN 16,17,0
_0x164:
	__GETW1MN _Motion,8
	CP   R16,R30
	CPC  R17,R31
	BRSH _0x165
;    1660 		gPoseDelta[i] = (int)eM_OriginPose[i] - (int)Motion.wCK[i].InitPos;
	MOVW R30,R16
	LDI  R26,LOW(_gPoseDelta)
	LDI  R27,HIGH(_gPoseDelta)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R24,R30
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	MOV  R22,R30
	CLR  R23
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,15
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CLR  R27
	MOVW R30,R22
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R24
	ST   X+,R30
	ST   X,R31
;    1661 }
	__ADDWRN 16,17,1
	RJMP _0x164
_0x165:
	RJMP _0x318
;    1662 
;    1663 
;    1664 //------------------------------------------------------------------------------
;    1665 // Runtime P,D,I ̵ ۽
;    1666 //------------------------------------------------------------------------------
;    1667 void SendTGain(void)
;    1668 {
_SendTGain:
;    1669 	WORD	i;
;    1670 
;    1671 	RX0_INT_OFF;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	CBI  0xA,7
;    1672 	TX0_INT_ON;
	SBI  0xA,6
;    1673 
;    1674 	while(gTx0Cnt);
_0x166:
	LDS  R30,_gTx0Cnt
	CPI  R30,0
	BRNE _0x166
;    1675 	for(i=0;i<MAX_wCK;i++){
	__GETWRN 16,17,0
_0x16A:
	__CPWRN 16,17,31
	BRSH _0x16B
;    1676 		if(Motion.wCK[i].Exist)
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BREQ _0x16C
;    1677 			SendSetCmd(i, 11, Motion.wCK[i].RPgain, Motion.wCK[i].RDgain);
	ST   -Y,R16
	LDI  R30,LOW(11)
	ST   -Y,R30
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,11
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,12
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	CALL _SendSetCmd
;    1678 	}
_0x16C:
	__ADDWRN 16,17,1
	RJMP _0x16A
_0x16B:
;    1679 	gTx0BufIdx++;
	LDS  R30,_gTx0BufIdx
	SUBI R30,-LOW(1)
	STS  _gTx0BufIdx,R30
;    1680 	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LD   R30,Z
	ST   -Y,R30
	CALL _sciTx0Data
;    1681 
;    1682 
;    1683 	while(gTx0Cnt);
_0x16D:
	LDS  R30,_gTx0Cnt
	CPI  R30,0
	BRNE _0x16D
;    1684 	for(i=0;i<MAX_wCK;i++){
	__GETWRN 16,17,0
_0x171:
	__CPWRN 16,17,31
	BRSH _0x172
;    1685 		if(Motion.wCK[i].Exist)
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BREQ _0x173
;    1686 			SendSetCmd(i, 24, Motion.wCK[i].RIgain, Motion.wCK[i].RIgain);
	ST   -Y,R16
	LDI  R30,LOW(24)
	ST   -Y,R30
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,13
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,13
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	CALL _SendSetCmd
;    1687 	}
_0x173:
	__ADDWRN 16,17,1
	RJMP _0x171
_0x172:
;    1688 	gTx0BufIdx++;
	LDS  R30,_gTx0BufIdx
	SUBI R30,-LOW(1)
	STS  _gTx0BufIdx,R30
;    1689 	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LD   R30,Z
	ST   -Y,R30
	CALL _sciTx0Data
;    1690 	delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1691 }
	RJMP _0x318
;    1692 
;    1693 
;    1694 //------------------------------------------------------------------------------
;    1695 // Ȯ Ʈ ۽
;    1696 //------------------------------------------------------------------------------
;    1697 void SendExPortD(void)
;    1698 {
_SendExPortD:
;    1699 	WORD	i;
;    1700 
;    1701 	UCSR0B &= 0x7F;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	CBI  0xA,7
;    1702 	UCSR0B |= 0x40;
	SBI  0xA,6
;    1703 
;    1704 	while(gTx0Cnt);
_0x174:
	LDS  R30,_gTx0Cnt
	CPI  R30,0
	BRNE _0x174
;    1705 	for(i=0;i<MAX_wCK;i++){
	__GETWRN 16,17,0
_0x178:
	__CPWRN 16,17,31
	BRSH _0x179
;    1706 		if(Scene.wCK[i].Exist)
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BREQ _0x17A
;    1707 			SendSetCmd(i, 100, Scene.wCK[i].ExPortD, Scene.wCK[i].ExPortD);
	ST   -Y,R16
	LDI  R30,LOW(100)
	ST   -Y,R30
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	CALL _SendSetCmd
;    1708 	}
_0x17A:
	__ADDWRN 16,17,1
	RJMP _0x178
_0x179:
;    1709 	gTx0BufIdx++;
	LDS  R30,_gTx0BufIdx
	SUBI R30,-LOW(1)
	STS  _gTx0BufIdx,R30
;    1710 	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LD   R30,Z
	ST   -Y,R30
	CALL _sciTx0Data
;    1711 }
	RJMP _0x318
;    1712 
;    1713 
;    1714 //------------------------------------------------------------------------------
;    1715 // Flash   б
;    1716 //------------------------------------------------------------------------------
;    1717 void GetSceneFromFlash(void)
;    1718 {
_GetSceneFromFlash:
;    1719 	WORD i;
;    1720 	
;    1721 	Scene.NumOfFrame = gpFN_Table[gScIdx];
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDS  R30,_gScIdx
	LDS  R31,_gScIdx+1
	LDS  R26,_gpFN_Table
	LDS  R27,_gpFN_Table+1
	LDS  R24,_gpFN_Table+2
	LDS  R25,_gpFN_Table+3
	CLR  R22
	CLR  R23
	CALL __LSLD1
	CALL __ADDD12
	CALL __GETW1PF
	__PUTW1MN _Scene,2
;    1722 	Scene.RTime = gpRT_Table[gScIdx];
	LDS  R30,_gScIdx
	LDS  R31,_gScIdx+1
	LDS  R26,_gpRT_Table
	LDS  R27,_gpRT_Table+1
	LDS  R24,_gpRT_Table+2
	LDS  R25,_gpRT_Table+3
	CLR  R22
	CLR  R23
	CALL __LSLD1
	CALL __ADDD12
	CALL __GETW1PF
	__PUTW1MN _Scene,4
;    1723 	for(i=0; i < MAX_wCK; i++){
	__GETWRN 16,17,0
_0x17C:
	__CPWRN 16,17,31
	BRSH _0x17D
;    1724 		Scene.wCK[i].Exist		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1725 		Scene.wCK[i].SPos		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1726 		Scene.wCK[i].DPos		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1727 		Scene.wCK[i].Torq		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,9
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1728 		Scene.wCK[i].ExPortD	= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1729 	}
	__ADDWRN 16,17,1
	RJMP _0x17C
_0x17D:
;    1730 	for(i=0; i < Motion.NumOfwCK; i++){
	__GETWRN 16,17,0
_0x17F:
	__GETW1MN _Motion,8
	CP   R16,R30
	CPC  R17,R31
	BRLO PC+3
	JMP _0x180
;    1731 		Scene.wCK[wCK_IDs[i]].Exist		= 1;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1732 		Scene.wCK[wCK_IDs[i]].SPos		= gpPos_Table[Motion.NumOfwCK*gScIdx+i];
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Scene,7
	PUSH R31
	PUSH R30
	__GETW1MN _Motion,8
	LDS  R26,_gScIdx
	LDS  R27,_gScIdx+1
	CALL __MULW12U
	ADD  R30,R16
	ADC  R31,R17
	LDS  R26,_gpPos_Table
	LDS  R27,_gpPos_Table+1
	LDS  R24,_gpPos_Table+2
	LDS  R25,_gpPos_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	POP  R26
	POP  R27
	ST   X,R30
;    1733 		Scene.wCK[wCK_IDs[i]].DPos		= gpPos_Table[Motion.NumOfwCK*(gScIdx+1)+i];
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Scene,8
	PUSH R31
	PUSH R30
	__GETW2MN _Motion,8
	LDS  R30,_gScIdx
	LDS  R31,_gScIdx+1
	ADIW R30,1
	CALL __MULW12U
	ADD  R30,R16
	ADC  R31,R17
	LDS  R26,_gpPos_Table
	LDS  R27,_gpPos_Table+1
	LDS  R24,_gpPos_Table+2
	LDS  R25,_gpPos_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	POP  R26
	POP  R27
	ST   X,R30
;    1734 		Scene.wCK[wCK_IDs[i]].Torq		= gpT_Table[Motion.NumOfwCK*gScIdx+i];
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Scene,9
	PUSH R31
	PUSH R30
	__GETW1MN _Motion,8
	LDS  R26,_gScIdx
	LDS  R27,_gScIdx+1
	CALL __MULW12U
	ADD  R30,R16
	ADC  R31,R17
	LDS  R26,_gpT_Table
	LDS  R27,_gpT_Table+1
	LDS  R24,_gpT_Table+2
	LDS  R25,_gpT_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	POP  R26
	POP  R27
	ST   X,R30
;    1735 		Scene.wCK[wCK_IDs[i]].ExPortD	= gpE_Table[Motion.NumOfwCK*gScIdx+i];
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Scene,10
	PUSH R31
	PUSH R30
	__GETW1MN _Motion,8
	LDS  R26,_gScIdx
	LDS  R27,_gScIdx+1
	CALL __MULW12U
	ADD  R30,R16
	ADC  R31,R17
	LDS  R26,_gpE_Table
	LDS  R27,_gpE_Table+1
	LDS  R24,_gpE_Table+2
	LDS  R25,_gpE_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	POP  R26
	POP  R27
	ST   X,R30
;    1736 	}
	__ADDWRN 16,17,1
	RJMP _0x17F
_0x180:
;    1737 	UCSR0B &= 0x7F;
	CBI  0xA,7
;    1738 	UCSR0B |= 0x40;
	SBI  0xA,6
;    1739 	delay_us(1300);
	__DELAY_USW 4792
;    1740 }
	RJMP _0x318
;    1741 
;    1742 
;    1743 //------------------------------------------------------------------------------
;    1744 //  ۽  
;    1745 //------------------------------------------------------------------------------
;    1746 void CalcFrameInterval(void)
;    1747 {
_CalcFrameInterval:
;    1748 	float	tmp;
;    1749 
;    1750 	if((Scene.RTime / Scene.NumOfFrame) < 20){
	SBIW R28,4
;	tmp -> Y+0
	__GETW2MN _Scene,4
	__GETW1MN _Scene,2
	CALL __DIVW21U
	SBIW R30,20
	BRSH _0x181
;    1751 		F_ERR_CODE = INTERVAL_ERR;
	LDI  R30,LOW(6)
	MOV  R14,R30
;    1752 		return;
	RJMP _0x319
;    1753 	}
;    1754 	tmp = (float)Scene.RTime * 14.4;
_0x181:
	__GETW1MN _Scene,4
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x41666666
	CALL __MULF12
	__PUTD1S 0
;    1755 	tmp = tmp  / (float)Scene.NumOfFrame;
	__GETW1MN _Scene,2
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2S 0
	CALL __DIVF21
	__PUTD1S 0
;    1756 	TxInterval = 65535 - (WORD)tmp - 5;
	CALL __CFD1
	LDI  R26,LOW(65535)
	LDI  R27,HIGH(65535)
	SUB  R26,R30
	SBC  R27,R31
	SBIW R26,5
	STS  _TxInterval,R26
	STS  _TxInterval+1,R27
;    1757 
;    1758 	RUN_LED1_ON;
	CBI  0x1B,5
;    1759 	F_SCENE_PLAYING = 1;
	SET
	BLD  R2,0
;    1760 	F_MOTION_STOPPED = 0;
	CLT
	BLD  R2,3
;    1761 	TCCR1B = 0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;    1762 
;    1763 	if(TxInterval <= 65509)	
	CPI  R26,LOW(0xFFE6)
	LDI  R30,HIGH(0xFFE6)
	CPC  R27,R30
	BRSH _0x182
;    1764 		TCNT1 = TxInterval+26;
	LDS  R30,_TxInterval
	LDS  R31,_TxInterval+1
	ADIW R30,26
	RJMP _0x327
;    1765 	else
_0x182:
;    1766 		TCNT1 = 65535;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0x327:
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;    1767 
;    1768 	TIFR |= 0x04;
	IN   R30,0x36
	ORI  R30,4
	OUT  0x36,R30
;    1769 	TIMSK |= 0x04;
	IN   R30,0x37
	ORI  R30,4
	OUT  0x37,R30
;    1770 }
_0x319:
	ADIW R28,4
	RET
;    1771 
;    1772 
;    1773 //------------------------------------------------------------------------------
;    1774 // Ӵ  ̵ 
;    1775 //------------------------------------------------------------------------------
;    1776 void CalcUnitMove(void)
;    1777 {
_CalcUnitMove:
;    1778 	WORD	i;
;    1779 
;    1780 	for(i=0; i < MAX_wCK; i++){
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,0
_0x185:
	__CPWRN 16,17,31
	BRLO PC+3
	JMP _0x186
;    1781 		if(Scene.wCK[i].Exist){
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BRNE PC+3
	JMP _0x187
;    1782 			if(Scene.wCK[i].SPos != Scene.wCK[i].DPos){
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CP   R30,R22
	BRNE PC+3
	JMP _0x188
;    1783 				gUnitD[i] = (float)((int)Scene.wCK[i].DPos - (int)Scene.wCK[i].SPos);
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R24,R30
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X
	CLR  R23
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CLR  R27
	MOVW R30,R22
	SUB  R30,R26
	SBC  R31,R27
	CALL __CWD1
	CALL __CDF1
	MOVW R26,R24
	CALL __PUTDP1
;    1784 				gUnitD[i] = (float)(gUnitD[i] / Scene.NumOfFrame);
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETW1MN _Scene,2
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __DIVF21
	POP  R26
	POP  R27
	CALL __PUTDP1
;    1785 				if(gUnitD[i] > 253)			gUnitD[i] = 254;
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x437D0000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x189
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	__GETD1N 0x437E0000
	RJMP _0x328
;    1786 				else if(gUnitD[i] < -253)	gUnitD[i] = -254;
_0x189:
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xC37D0000
	CALL __CMPF12
	BRSH _0x18B
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	__GETD1N 0xC37E0000
_0x328:
	CALL __PUTDP1
;    1787 			}
_0x18B:
;    1788 			else
	RJMP _0x18C
_0x188:
;    1789 				gUnitD[i] = 0;
	MOVW R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	__GETD1N 0x0
	CALL __PUTDP1
;    1790 		}
_0x18C:
;    1791 	}
_0x187:
	__ADDWRN 16,17,1
	RJMP _0x185
_0x186:
;    1792 	gFrameIdx = 0;
	LDI  R30,0
	STS  _gFrameIdx,R30
	STS  _gFrameIdx+1,R30
;    1793 }
_0x318:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1794 
;    1795 
;    1796 //------------------------------------------------------------------------------
;    1797 //   ۽ غ
;    1798 //------------------------------------------------------------------------------
;    1799 void MakeFrame(void)
;    1800 {
_MakeFrame:
;    1801 	BYTE	i, tmp;
;    1802 	int		wTmp;
;    1803 
;    1804 	while(gTx0Cnt);
	CALL __SAVELOCR4
;	i -> R16
;	tmp -> R17
;	wTmp -> R18,R19
_0x18D:
	LDS  R30,_gTx0Cnt
	CPI  R30,0
	BRNE _0x18D
;    1805 	gFrameIdx++;
	LDS  R30,_gFrameIdx
	LDS  R31,_gFrameIdx+1
	ADIW R30,1
	STS  _gFrameIdx,R30
	STS  _gFrameIdx+1,R31
;    1806 
;    1807 	for(i=0; i < MAX_wCK; i++){
	LDI  R16,LOW(0)
_0x191:
	CPI  R16,31
	BRLO PC+3
	JMP _0x192
;    1808 		if(Scene.wCK[i].Exist){
	LDI  R30,LOW(5)
	MUL  R30,R16
	MOVW R30,R0
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BRNE PC+3
	JMP _0x193
;    1809 			if(Scene.wCK[i].Torq < 5){
	LDI  R30,LOW(5)
	MUL  R30,R16
	MOVW R30,R0
	__POINTW2MN _Scene,9
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x5)
	BRLO PC+3
	JMP _0x194
;    1810 				wTmp = (int)Scene.wCK[i].SPos + Round((float)gFrameIdx*gUnitD[i],1 );
	LDI  R30,LOW(5)
	MUL  R30,R16
	MOVW R30,R0
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	PUSH R31
	PUSH R30
	LDS  R30,_gFrameIdx
	LDS  R31,_gFrameIdx+1
	CALL __CWD1
	CALL __CDF1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	MOV  R30,R16
	LDI  R26,LOW(_gUnitD)
	LDI  R27,HIGH(_gUnitD)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Round
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	MOVW R18,R30
;    1811 				if(Motion.PF != PF2){
	__GETB2MN _Motion,5
	CPI  R26,LOW(0x4)
	BREQ _0x195
;    1812 					wTmp = wTmp + gPoseDelta[i];
	MOV  R30,R16
	LDI  R26,LOW(_gPoseDelta)
	LDI  R27,HIGH(_gPoseDelta)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	__ADDWRR 18,19,30,31
;    1813 				}
;    1814 				if(wTmp > 254)		wTmp = 254;
_0x195:
	__CPWRN 18,19,255
	BRLT _0x196
	__GETWRN 18,19,254
;    1815 				else if(wTmp < 1)	wTmp = 1;
	RJMP _0x197
_0x196:
	__CPWRN 18,19,1
	BRGE _0x198
	__GETWRN 18,19,1
;    1816 				tmp = (BYTE)wTmp;
_0x198:
_0x197:
	MOV  R17,R18
;    1817 			}
;    1818 			else{
	RJMP _0x199
_0x194:
;    1819 				tmp = Scene.wCK[i].DPos;
	LDI  R30,LOW(5)
	MUL  R30,R16
	MOVW R30,R0
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
;    1820 			}
_0x199:
;    1821 			PosSend(i,tmp, Scene.wCK[i].Torq);
	ST   -Y,R16
	ST   -Y,R17
	LDI  R30,LOW(5)
	MUL  R30,R16
	MOVW R30,R0
	__POINTW2MN _Scene,9
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	CALL _PosSend
;    1822 		}
;    1823 	}
_0x193:
	SUBI R16,-1
	RJMP _0x191
_0x192:
;    1824 }
	RJMP _0x316
;    1825 
;    1826 
;    1827 //------------------------------------------------------------------------------
;    1828 //   ۽
;    1829 //------------------------------------------------------------------------------
;    1830 void SendFrame(void)
;    1831 {
_SendFrame:
;    1832 	if(gTx0Cnt == 0)	return;
	LDS  R30,_gTx0Cnt
	CPI  R30,0
	BRNE _0x19A
	RET
;    1833 
;    1834 	gTx0BufIdx++;
_0x19A:
	LDS  R30,_gTx0BufIdx
	SUBI R30,-LOW(1)
	STS  _gTx0BufIdx,R30
;    1835 	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_gTx0Buf)
	SBCI R31,HIGH(-_gTx0Buf)
	LD   R30,Z
	ST   -Y,R30
	CALL _sciTx0Data
;    1836 }
	RET
;    1837 
;    1838 
;    1839 //------------------------------------------------------------------------------
;    1840 // HUNO 0 ڼ, HUNO, DINO, DOGY ⺻ ڼ 
;    1841 //------------------------------------------------------------------------------
;    1842 void BasicPose(BYTE PF, WORD NOF, WORD RT, BYTE TQ)
;    1843 {
_BasicPose:
;    1844 	BYTE	trigger = 0;
;    1845 	WORD	i;
;    1846 
;    1847 	if(F_CHARGING)	return;
	CALL __SAVELOCR3
;	PF -> Y+8
;	NOF -> Y+6
;	RT -> Y+4
;	TQ -> Y+3
;	trigger -> R16
;	i -> R17,R18
	LDI  R16,0
	SBRC R2,6
	RJMP _0x317
;    1848 	if(F_PF == PF2)	return;
	LDI  R30,LOW(4)
	CP   R30,R13
	BRNE _0x19C
	RJMP _0x317
;    1849 	if(F_PF != PF1_HUNO && PF == 0){
_0x19C:
	LDI  R30,LOW(1)
	CP   R30,R13
	BREQ _0x19E
	LDD  R26,Y+8
	CPI  R26,LOW(0x0)
	BREQ _0x19F
_0x19E:
	RJMP _0x19D
_0x19F:
;    1850 		F_ERR_CODE = PF_MATCH_ERR;
	LDI  R30,LOW(5)
	MOV  R14,R30
;    1851 		return;
	RJMP _0x317
;    1852 	}
;    1853 	
;    1854 	if(NOF != 1){
_0x19D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,1
	BREQ _0x1A0
;    1855 		if(PF == PF1_HUNO)		SendToSoundIC(1);
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	BRNE _0x1A1
	LDI  R30,LOW(1)
	RJMP _0x329
;    1856 		else if(PF == PF1_DOGY)	SendToSoundIC(9);
_0x1A1:
	LDD  R26,Y+8
	CPI  R26,LOW(0x3)
	BRNE _0x1A3
	LDI  R30,LOW(9)
_0x329:
	ST   -Y,R30
	CALL _SendToSoundIC
;    1857 	}
_0x1A3:
;    1858 
;    1859 	Motion.PF = PF;
_0x1A0:
	LDD  R30,Y+8
	__PUTB1MN _Motion,5
;    1860 	Motion.NumOfScene = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1MN _Motion,6
;    1861 	Motion.NumOfwCK = 16;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    1862 	gLastID = 15;
	LDI  R30,LOW(15)
	STS  _gLastID,R30
;    1863 
;    1864 	for(i=0; i < Motion.NumOfwCK; i++){
	__GETWRN 17,18,0
_0x1A5:
	__GETW1MN _Motion,8
	CP   R17,R30
	CPC  R18,R31
	BRLO PC+3
	JMP _0x1A6
;    1865 		Motion.wCK[i].Exist		= 1;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1866 		if(i>9){
	__CPWRN 17,18,10
	BRLO _0x1A7
;    1867 			Motion.wCK[i].RPgain	= 15;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,11
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(15)
	ST   X,R30
;    1868 			Motion.wCK[i].RDgain	= 25;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,12
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(25)
	RJMP _0x32A
;    1869 		}
;    1870 		else{
_0x1A7:
;    1871 			Motion.wCK[i].RPgain	= 20;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,11
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(20)
	ST   X,R30
;    1872 			Motion.wCK[i].RDgain	= 30;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,12
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(30)
_0x32A:
	ST   X,R30
;    1873 		}
;    1874 		Motion.wCK[i].RIgain	= 0;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,13
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1875 		Motion.wCK[i].PortEn	= 1;
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,14
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1876 		Motion.wCK[i].InitPos	= (int)MotionZeroPos[i];
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,15
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_MotionZeroPos*2)
	SBCI R31,HIGH(-_MotionZeroPos*2)
	SBCI R22,BYTE3(-_MotionZeroPos*2)
	__GETBRPF 30
	ST   X,R30
;    1877 		gPoseDelta[i] = (int)eM_OriginPose[i] - (int)MotionZeroPos[i];
	__GETW1R 17,18
	LDI  R26,LOW(_gPoseDelta)
	LDI  R27,HIGH(_gPoseDelta)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R24,R30
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R17
	ADC  R27,R18
	CALL __EEPROMRDB
	LDI  R31,0
	MOVW R26,R30
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_MotionZeroPos*2)
	SBCI R31,HIGH(-_MotionZeroPos*2)
	SBCI R22,BYTE3(-_MotionZeroPos*2)
	__GETBRPF 30
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R24
	ST   X+,R30
	ST   X,R31
;    1878 	}
	__ADDWRN 17,18,1
	RJMP _0x1A5
_0x1A6:
;    1879 	SendTGain();
	CALL _SendTGain
;    1880 	F_ERR_CODE = NO_ERR;
	LDI  R30,LOW(255)
	MOV  R14,R30
;    1881 	for(i=0; i < MAX_wCK; i++){					
	__GETWRN 17,18,0
_0x1AA:
	__CPWRN 17,18,31
	BRSH _0x1AB
;    1882 		if(Motion.wCK[i].Exist){ Scene.wCK[i].Exist = 1; }
	__MULBNWRU 17,18,6
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BREQ _0x1AC
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1883 	}
_0x1AC:
	__ADDWRN 17,18,1
	RJMP _0x1AA
_0x1AB:
;    1884 	GetPose();
	RCALL _GetPose
;    1885 	if(F_ERR_CODE != NO_ERR)	return;
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ _0x1AD
	RJMP _0x317
;    1886 	trigger = 0;
_0x1AD:
	LDI  R16,LOW(0)
;    1887 	for(i=0; i < Motion.NumOfwCK; i++){
	__GETWRN 17,18,0
_0x1AF:
	__GETW1MN _Motion,8
	CP   R17,R30
	CPC  R18,R31
	BRSH _0x1B0
;    1888 		if( abs((float)Scene.wCK[i].DPos - (float)Scene.wCK[i].SPos) > 5 ){
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	SBIW R30,6
	BRLO _0x1B1
;    1889 			trigger = 1;
	LDI  R16,LOW(1)
;    1890 			break;
	RJMP _0x1B0
;    1891 		}
;    1892 	}
_0x1B1:
	__ADDWRN 17,18,1
	RJMP _0x1AF
_0x1B0:
;    1893 	if(trigger){
	CPI  R16,0
	BREQ _0x1B2
;    1894 		trigger = 0;
	LDI  R16,LOW(0)
;    1895 		Scene.NumOfFrame = NOF;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	__PUTW1MN _Scene,2
;    1896 		Scene.RTime = RT;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RJMP _0x32B
;    1897 	}
;    1898 	else{
_0x1B2:
;    1899 		Scene.NumOfFrame = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1MN _Scene,2
;    1900 		Scene.RTime = 20;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
_0x32B:
	__PUTW1MN _Scene,4
;    1901 	}
;    1902 
;    1903 	for(i=0; i < Motion.NumOfwCK; i++){
	__GETWRN 17,18,0
_0x1B5:
	__GETW1MN _Motion,8
	CP   R17,R30
	CPC  R18,R31
	BRLO PC+3
	JMP _0x1B6
;    1904 		if(PF == 0){			Scene.wCK[i].DPos = eM_OriginPose[i];}
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x1B7
	__MULBNWRU 17,18,5
	__ADDW1MN _Scene,8
	MOVW R0,R30
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R17
	ADC  R27,R18
	CALL __EEPROMRDB
	MOVW R26,R0
	RJMP _0x32C
;    1905 		else if(PF == PF1_HUNO){Scene.wCK[i].DPos = fM1_BasicPose[i];}
_0x1B7:
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	BRNE _0x1B9
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_fM1_BasicPose*2)
	SBCI R31,HIGH(-_fM1_BasicPose*2)
	SBCI R22,BYTE3(-_fM1_BasicPose*2)
	RJMP _0x32D
;    1906 		else if(PF == PF1_DINO){Scene.wCK[i].DPos = fM2_BasicPose[i];}
_0x1B9:
	LDD  R26,Y+8
	CPI  R26,LOW(0x2)
	BRNE _0x1BB
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_fM2_BasicPose*2)
	SBCI R31,HIGH(-_fM2_BasicPose*2)
	SBCI R22,BYTE3(-_fM2_BasicPose*2)
	RJMP _0x32D
;    1907 		else if(PF == PF1_DOGY){Scene.wCK[i].DPos = fM3_BasicPose[i];}
_0x1BB:
	LDD  R26,Y+8
	CPI  R26,LOW(0x3)
	BRNE _0x1BD
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_fM3_BasicPose*2)
	SBCI R31,HIGH(-_fM3_BasicPose*2)
	SBCI R22,BYTE3(-_fM3_BasicPose*2)
_0x32D:
	__GETBRPF 30
_0x32C:
	ST   X,R30
;    1908 		Scene.wCK[i].Torq		= TQ;
_0x1BD:
	__MULBNWRU 17,18,5
	__ADDW1MN _Scene,9
	LDD  R26,Y+3
	STD  Z+0,R26
;    1909 		Scene.wCK[i].ExPortD	= 1;
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1910 	}
	__ADDWRN 17,18,1
	RJMP _0x1B5
_0x1B6:
;    1911 	RUN_LED1_ON;
	CBI  0x1B,5
;    1912 	SendExPortD();
	CALL _SendExPortD
;    1913 
;    1914 	CalcFrameInterval();
	CALL _CalcFrameInterval
;    1915 	if(F_ERR_CODE != NO_ERR)	return;
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ _0x1BE
	RJMP _0x317
;    1916 	CalcUnitMove();
_0x1BE:
	CALL _CalcUnitMove
;    1917 	MakeFrame();
	CALL _MakeFrame
;    1918 	SendFrame();
	CALL _SendFrame
;    1919 	while(F_SCENE_PLAYING);
_0x1BF:
	SBRC R2,0
	RJMP _0x1BF
;    1920 	if(F_MOTION_STOPPED == 1)	return;
	SBRC R2,3
	RJMP _0x317
;    1921 	if(NOF > 1){
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,2
	BRSH PC+3
	JMP _0x1C3
;    1922 		delay_ms(800);
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1923 		GetPose();
	RCALL _GetPose
;    1924 		if(F_ERR_CODE != NO_ERR)	return;
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ _0x1C4
	RJMP _0x317
;    1925 		for(i=0; i < Motion.NumOfwCK; i++){
_0x1C4:
	__GETWRN 17,18,0
_0x1C6:
	__GETW1MN _Motion,8
	CP   R17,R30
	CPC  R18,R31
	BRSH _0x1C7
;    1926 			if( abs((float)Scene.wCK[i].DPos - (float)Scene.wCK[i].SPos) > 10 ){
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__MULBNWRU 17,18,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	SBIW R30,11
	BRLO _0x1C8
;    1927 				F_ERR_CODE = WCK_POS_ERR;
	LDI  R30,LOW(10)
	MOV  R14,R30
;    1928 				break;
	RJMP _0x1C7
;    1929 			}
;    1930 		}
_0x1C8:
	__ADDWRN 17,18,1
	RJMP _0x1C6
_0x1C7:
;    1931 	}
;    1932 	RUN_LED1_OFF;
_0x1C3:
	SBI  0x1B,5
;    1933 }
_0x317:
	CALL __LOADLOCR3
	ADIW R28,9
	RET
;    1934 
;    1935 
;    1936 //------------------------------------------------------------------------------
;    1937 //  ڼ б
;    1938 //------------------------------------------------------------------------------
;    1939 void GetPose(void)
;    1940 {
_GetPose:
;    1941 	WORD	i, tmp;
;    1942 
;    1943 	UCSR0B |= 0x80;
	CALL __SAVELOCR4
;	i -> R16,R17
;	tmp -> R18,R19
	SBI  0xA,7
;    1944 	UCSR0B &= 0xBF;
	CBI  0xA,6
;    1945 	for(i=0; i < MAX_wCK; i++){
	__GETWRN 16,17,0
_0x1CA:
	__CPWRN 16,17,31
	BRSH _0x1CB
;    1946 		if(Motion.wCK[i].Exist){
	__MULBNWRU 16,17,6
	__POINTW2MN _Motion,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CPI  R30,0
	BREQ _0x1CC
;    1947 			tmp = PosRead(i);
	ST   -Y,R16
	CALL _PosRead
	MOVW R18,R30
;    1948 			if(tmp == 444){
	LDI  R30,LOW(444)
	LDI  R31,HIGH(444)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x1CD
;    1949 				tmp = PosRead(i);
	ST   -Y,R16
	CALL _PosRead
	MOVW R18,R30
;    1950 				if(tmp == 444){
	LDI  R30,LOW(444)
	LDI  R31,HIGH(444)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x1CE
;    1951 					tmp = PosRead(i);
	ST   -Y,R16
	CALL _PosRead
	MOVW R18,R30
;    1952 					if(tmp == 444){
	LDI  R30,LOW(444)
	LDI  R31,HIGH(444)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x1CF
;    1953 						F_ERR_CODE = WCK_NO_ACK_ERR;
	LDI  R30,LOW(11)
	MOV  R14,R30
;    1954 						return;
	RJMP _0x316
;    1955 					}
;    1956 				}
_0x1CF:
;    1957 			}
_0x1CE:
;    1958 			Scene.wCK[i].SPos = (BYTE)tmp;
_0x1CD:
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	ST   X,R18
;    1959 		}
;    1960 	}
_0x1CC:
	__ADDWRN 16,17,1
	RJMP _0x1CA
_0x1CB:
;    1961 }
_0x316:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;    1962 
;    1963 
;    1964 
;    1965 //------------------------------------------------------------------------------
;    1966 //  Ʈ  
;    1967 //------------------------------------------------------------------------------
;    1968 void MotionTweenFlash(BYTE GapMax)
;    1969 {
_MotionTweenFlash:
;    1970 	WORD	i;
;    1971 
;    1972 	Scene.NumOfFrame = (WORD)GapMax;
	ST   -Y,R17
	ST   -Y,R16
;	GapMax -> Y+2
;	i -> R16,R17
	LDD  R30,Y+2
	LDI  R31,0
	__PUTW1MN _Scene,2
;    1973 	Scene.RTime = (WORD)GapMax*20;
	LDD  R30,Y+2
	LDI  R26,LOW(20)
	MUL  R30,R26
	MOVW R30,R0
	__PUTW1MN _Scene,4
;    1974 	for(i=0;i<MAX_wCK;i++){
	__GETWRN 16,17,0
_0x1D1:
	__CPWRN 16,17,31
	BRSH _0x1D2
;    1975 		Scene.wCK[i].Exist		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1976 		Scene.wCK[i].DPos		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,8
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1977 		Scene.wCK[i].Torq		= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,9
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1978 		Scene.wCK[i].ExPortD	= 0;
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1979 	}
	__ADDWRN 16,17,1
	RJMP _0x1D1
_0x1D2:
;    1980 	for(i=0;i<Motion.NumOfwCK;i++){
	__GETWRN 16,17,0
_0x1D4:
	__GETW1MN _Motion,8
	CP   R16,R30
	CPC  R17,R31
	BRLO PC+3
	JMP _0x1D5
;    1981 		Scene.wCK[wCK_IDs[i]].Exist		= 1;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Scene,6
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	ST   X,R30
;    1982 		Scene.wCK[wCK_IDs[i]].DPos		= gpPos_Table[i];
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__ADDW1MN _Scene,8
	MOVW R0,R30
	MOVW R30,R16
	LDS  R26,_gpPos_Table
	LDS  R27,_gpPos_Table+1
	LDS  R24,_gpPos_Table+2
	LDS  R25,_gpPos_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	MOVW R26,R0
	ST   X,R30
;    1983 		Scene.wCK[wCK_IDs[i]].Torq		= 3;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Scene,9
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(3)
	ST   X,R30
;    1984 		Scene.wCK[wCK_IDs[i]].ExPortD	= 0;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_wCK_IDs*2)
	SBCI R31,HIGH(-_wCK_IDs*2)
	SBCI R22,BYTE3(-_wCK_IDs*2)
	__GETBRPF 30
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	__POINTW2MN _Scene,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1985 	}
	__ADDWRN 16,17,1
	RJMP _0x1D4
_0x1D5:
;    1986 	UCSR0B &= 0x7F;
	CBI  0xA,7
;    1987 	UCSR0B |= 0x40;
	SBI  0xA,6
;    1988 	SendExPortD();
	CALL _SendExPortD
;    1989 	CalcFrameInterval();
	CALL _CalcFrameInterval
;    1990 	if(F_ERR_CODE != NO_ERR)	return;
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ _0x1D6
	RJMP _0x315
;    1991 	CalcUnitMove();
_0x1D6:
	CALL _CalcUnitMove
;    1992 	MakeFrame();
	CALL _MakeFrame
;    1993 	SendFrame();
	CALL _SendFrame
;    1994 	while(F_SCENE_PLAYING);
_0x1D7:
	SBRC R2,0
	RJMP _0x1D7
;    1995 	if(F_MOTION_STOPPED == 1)	return;
;    1996 }
_0x315:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,3
	RET
;    1997 
;    1998 
;    1999 //------------------------------------------------------------------------------
;    2000 //  ÷( Flash  ̿)
;    2001 //------------------------------------------------------------------------------
;    2002 void M_PlayFlash(void)
;    2003 {
_M_PlayFlash:
;    2004 	float	lGapMax = 0;
;    2005 	WORD	i;
;    2006 
;    2007 	if(F_CHARGING) return;
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x1DB*2)
	LDI  R31,HIGH(_0x1DB*2)
	LDI  R22,BYTE3(_0x1DB*2)
	CALL __INITLOCB
	ST   -Y,R17
	ST   -Y,R16
;	lGapMax -> Y+2
;	i -> R16,R17
	SBRC R2,6
	RJMP _0x314
;    2008 
;    2009 	GetMotionFromFlash();
	CALL _GetMotionFromFlash
;    2010 	SendTGain();
	CALL _SendTGain
;    2011 
;    2012 	F_ERR_CODE = NO_ERR;
	LDI  R30,LOW(255)
	MOV  R14,R30
;    2013 
;    2014 	GetPose();
	CALL _GetPose
;    2015 	if(F_ERR_CODE != NO_ERR)	return;
	LDI  R30,LOW(255)
	CP   R30,R14
	BREQ _0x1DD
	RJMP _0x314
;    2016 	for(i=0;i<Motion.NumOfwCK;i++){
_0x1DD:
	__GETWRN 16,17,0
_0x1DF:
	__GETW1MN _Motion,8
	CP   R16,R30
	CPC  R17,R31
	BRLO PC+3
	JMP _0x1E0
;    2017 		if( abs((float)gpPos_Table[i]-(float)Scene.wCK[i].SPos) > lGapMax )
	MOVW R30,R16
	LDS  R26,_gpPos_Table
	LDS  R27,_gpPos_Table+1
	LDS  R24,_gpPos_Table+2
	LDS  R25,_gpPos_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	MOVW R26,R30
	__GETD1S 2
	CLR  R24
	CLR  R25
	CALL __CDF2
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x1E1
;    2018 			lGapMax = abs((float)gpPos_Table[i]-(float)Scene.wCK[i].SPos);
	MOVW R30,R16
	LDS  R26,_gpPos_Table
	LDS  R27,_gpPos_Table+1
	LDS  R24,_gpPos_Table+2
	LDS  R25,_gpPos_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__MULBNWRU 16,17,5
	__POINTW2MN _Scene,7
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SWAPD12
	CALL __SUBF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __CDF1
	__PUTD1S 2
;    2019 		if(gpT_Table[i] == 6)
_0x1E1:
	MOVW R30,R16
	LDS  R26,_gpT_Table
	LDS  R27,_gpT_Table+1
	LDS  R24,_gpT_Table+2
	LDS  R25,_gpT_Table+3
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__GETBRPF 30
	CPI  R30,LOW(0x6)
	BRNE _0x1E2
;    2020 			lGapMax = 0;
	__CLRD1S 2
;    2021 	}
_0x1E2:
	__ADDWRN 16,17,1
	RJMP _0x1DF
_0x1E0:
;    2022 	if(lGapMax > POS_MARGIN)	MotionTweenFlash((BYTE)(lGapMax/3));
	__GETD2S 2
	__GETD1N 0x41200000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x1E3
	__GETD1N 0x40400000
	CALL __DIVF21
	CALL __CFD1
	ST   -Y,R30
	CALL _MotionTweenFlash
;    2023 
;    2024 	for(i=0; i < Motion.NumOfScene; i++){
_0x1E3:
	__GETWRN 16,17,0
_0x1E5:
	__GETW1MN _Motion,6
	CP   R16,R30
	CPC  R17,R31
	BRSH _0x1E6
;    2025 		gScIdx = i;
	__PUTWMRN _gScIdx,0,16,17
;    2026 		GetSceneFromFlash();
	CALL _GetSceneFromFlash
;    2027 		SendExPortD();
	CALL _SendExPortD
;    2028 		CalcFrameInterval();
	CALL _CalcFrameInterval
;    2029 		if(F_ERR_CODE != NO_ERR)	break;
	LDI  R30,LOW(255)
	CP   R30,R14
	BRNE _0x1E6
;    2030 		CalcUnitMove();
	CALL _CalcUnitMove
;    2031 		MakeFrame();
	CALL _MakeFrame
;    2032 		SendFrame();
	CALL _SendFrame
;    2033 		while(F_SCENE_PLAYING);
_0x1E8:
	SBRC R2,0
	RJMP _0x1E8
;    2034 		if(F_MOTION_STOPPED == 1)	break;
	SBRC R2,3
	RJMP _0x1E6
;    2035 	}
	__ADDWRN 16,17,1
	RJMP _0x1E5
_0x1E6:
;    2036 }
_0x314:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,6
	RET
;    2037 
;    2038 
;    2039 //------------------------------------------------------------------------------
;    2040 //  
;    2041 //------------------------------------------------------------------------------
;    2042 void M_Play(BYTE BtnCode)
;    2043 {
_M_Play:
;    2044 	if(BtnCode == BTN_C){
;	BtnCode -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x7)
	BREQ PC+3
	JMP _0x1EC
;    2045 		P_BMC504_RESET(0);
	CBI  0x18,6
;    2046 		delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    2047 		P_BMC504_RESET(1);
	SBI  0x18,6
;    2048 		delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    2049 		BasicPose(F_PF, 50, 1000, 4);
	ST   -Y,R13
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _BasicPose
;    2050 		if(F_ERR_CODE != NO_ERR){
	LDI  R30,LOW(255)
	CP   R30,R14
	BRNE PC+3
	JMP _0x1F1
;    2051 			gSEC_DCOUNT = 5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	STS  _gSEC_DCOUNT,R30
	STS  _gSEC_DCOUNT+1,R31
;    2052 			EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;    2053 			while(gSEC_DCOUNT){
_0x1F2:
	LDS  R30,_gSEC_DCOUNT
	LDS  R31,_gSEC_DCOUNT+1
	SBIW R30,0
	BREQ _0x1F4
;    2054 				if(g10MSEC == 0 || g10MSEC == 50){
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CALL __CPW02
	BREQ _0x1F6
	SBIW R26,50
	BRNE _0x1F5
_0x1F6:
;    2055 					Get_VOLTAGE();
	CALL _Get_VOLTAGE
;    2056 					DetectPower();
	CALL _DetectPower
;    2057 					IoUpdate();
	CALL _IoUpdate
;    2058 				}
;    2059 				if(g10MSEC < 25)		ERR_LED_ON;
_0x1F5:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,25
	BRSH _0x1F8
	CBI  0x1B,7
;    2060 				else if(g10MSEC < 50)	ERR_LED_OFF;
	RJMP _0x1F9
_0x1F8:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,50
	BRSH _0x1FA
	RJMP _0x32E
;    2061 				else if(g10MSEC < 75)	ERR_LED_ON;
_0x1FA:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CPI  R26,LOW(0x4B)
	LDI  R30,HIGH(0x4B)
	CPC  R27,R30
	BRSH _0x1FC
	CBI  0x1B,7
;    2062 				else if(g10MSEC < 100)	ERR_LED_OFF;
	RJMP _0x1FD
_0x1FC:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRSH _0x1FE
_0x32E:
	SBI  0x1B,7
;    2063 			}
_0x1FE:
_0x1FD:
_0x1F9:
	RJMP _0x1F2
_0x1F4:
;    2064 			F_ERR_CODE = NO_ERR;
	LDI  R30,LOW(255)
	MOV  R14,R30
;    2065 			EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;    2066 		}
;    2067 		return;
_0x1F1:
	RJMP _0x313
;    2068 	}
;    2069 	if(F_PF == PF1_HUNO){
_0x1EC:
	LDI  R30,LOW(1)
	CP   R30,R13
	BREQ PC+3
	JMP _0x1FF
;    2070 		switch(BtnCode){
	LD   R30,Y
;    2071 			case BTN_A:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x203
;    2072 			 	SendToSoundIC(7);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2073 				gpT_Table	= HUNOBASIC_GETUPFRONT_Torque;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2074 				gpE_Table	= HUNOBASIC_GETUPFRONT_Port;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2075 				gpPg_Table 	= HUNOBASIC_GETUPFRONT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2076 				gpDg_Table 	= HUNOBASIC_GETUPFRONT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2077 				gpIg_Table 	= HUNOBASIC_GETUPFRONT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2078 				gpFN_Table	= HUNOBASIC_GETUPFRONT_Frames;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2079 				gpRT_Table	= HUNOBASIC_GETUPFRONT_TrTime;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2080 				gpPos_Table	= HUNOBASIC_GETUPFRONT_Position;
	__POINTD1FN _HUNOBASIC_GETUPFRONT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2081 				Motion.NumOfScene = HUNOBASIC_GETUPFRONT_NUM_OF_SCENES;
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1MN _Motion,6
;    2082 				Motion.NumOfwCK = HUNOBASIC_GETUPFRONT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2083 				break;
	RJMP _0x202
;    2084 			case BTN_B:
_0x203:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x204
;    2085 			 	SendToSoundIC(8);
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2086 				gpT_Table	= HUNOBASIC_GETUPBACK_Torque;
	__POINTD1FN _HUNOBASIC_GETUPBACK_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2087 				gpE_Table	= HUNOBASIC_GETUPBACK_Port;
	__POINTD1FN _HUNOBASIC_GETUPBACK_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2088 				gpPg_Table 	= HUNOBASIC_GETUPBACK_RuntimePGain;
	__POINTD1FN _HUNOBASIC_GETUPBACK_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2089 				gpDg_Table 	= HUNOBASIC_GETUPBACK_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_GETUPBACK_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2090 				gpIg_Table 	= HUNOBASIC_GETUPBACK_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_GETUPBACK_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2091 				gpFN_Table	= HUNOBASIC_GETUPBACK_Frames;
	__POINTD1FN _HUNOBASIC_GETUPBACK_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2092 				gpRT_Table	= HUNOBASIC_GETUPBACK_TrTime;
	__POINTD1FN _HUNOBASIC_GETUPBACK_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2093 				gpPos_Table	= HUNOBASIC_GETUPBACK_Position;
	__POINTD1FN _HUNOBASIC_GETUPBACK_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2094 				Motion.NumOfScene = HUNOBASIC_GETUPBACK_NUM_OF_SCENES;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1MN _Motion,6
;    2095 				Motion.NumOfwCK = HUNOBASIC_GETUPBACK_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2096 				break;
	RJMP _0x202
;    2097 			case BTN_LR:
_0x204:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x205
;    2098 			 	SendToSoundIC(4);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2099 				gpT_Table	= HUNOBASIC_TURNLEFT_Torque;
	__POINTD1FN _HUNOBASIC_TURNLEFT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2100 				gpE_Table	= HUNOBASIC_TURNLEFT_Port;
	__POINTD1FN _HUNOBASIC_TURNLEFT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2101 				gpPg_Table 	= HUNOBASIC_TURNLEFT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_TURNLEFT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2102 				gpDg_Table 	= HUNOBASIC_TURNLEFT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_TURNLEFT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2103 				gpIg_Table 	= HUNOBASIC_TURNLEFT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_TURNLEFT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2104 				gpFN_Table	= HUNOBASIC_TURNLEFT_Frames;
	__POINTD1FN _HUNOBASIC_TURNLEFT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2105 				gpRT_Table	= HUNOBASIC_TURNLEFT_TrTime;
	__POINTD1FN _HUNOBASIC_TURNLEFT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2106 				gpPos_Table	= HUNOBASIC_TURNLEFT_Position;
	__POINTD1FN _HUNOBASIC_TURNLEFT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2107 				Motion.NumOfScene = HUNOBASIC_TURNLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2108 				Motion.NumOfwCK = HUNOBASIC_TURNLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2109 				break;
	RJMP _0x202
;    2110 			case BTN_U:
_0x205:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x206
;    2111 			 	SendToSoundIC(2);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2112 				gpT_Table	= HUNOBASIC_WALKFORWARD_Torque;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2113 				gpE_Table	= HUNOBASIC_WALKFORWARD_Port;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2114 				gpPg_Table 	= HUNOBASIC_WALKFORWARD_RuntimePGain;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2115 				gpDg_Table 	= HUNOBASIC_WALKFORWARD_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2116 				gpIg_Table 	= HUNOBASIC_WALKFORWARD_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2117 				gpFN_Table	= HUNOBASIC_WALKFORWARD_Frames;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2118 				gpRT_Table	= HUNOBASIC_WALKFORWARD_TrTime;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2119 				gpPos_Table	= HUNOBASIC_WALKFORWARD_Position;
	__POINTD1FN _HUNOBASIC_WALKFORWARD_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2120 				Motion.NumOfScene = HUNOBASIC_WALKFORWARD_NUM_OF_SCENES;
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	__PUTW1MN _Motion,6
;    2121 				Motion.NumOfwCK = HUNOBASIC_WALKFORWARD_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2122 				break;
	RJMP _0x202
;    2123 			case BTN_RR:
_0x206:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x207
;    2124 			 	SendToSoundIC(4);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2125 				gpT_Table	= HUNOBASIC_TURNRIGHT_Torque;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2126 				gpE_Table	= HUNOBASIC_TURNRIGHT_Port;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2127 				gpPg_Table 	= HUNOBASIC_TURNRIGHT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2128 				gpDg_Table 	= HUNOBASIC_TURNRIGHT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2129 				gpIg_Table 	= HUNOBASIC_TURNRIGHT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2130 				gpFN_Table	= HUNOBASIC_TURNRIGHT_Frames;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2131 				gpRT_Table	= HUNOBASIC_TURNRIGHT_TrTime;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2132 				gpPos_Table	= HUNOBASIC_TURNRIGHT_Position;
	__POINTD1FN _HUNOBASIC_TURNRIGHT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2133 				Motion.NumOfScene = HUNOBASIC_TURNRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2134 				Motion.NumOfwCK = HUNOBASIC_TURNRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2135 				break;
	RJMP _0x202
;    2136 			case BTN_L:
_0x207:
	CPI  R30,LOW(0x6)
	BREQ PC+3
	JMP _0x208
;    2137 			 	SendToSoundIC(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2138 				gpT_Table	= HUNOBASIC_SIDEWALKLEFT_Torque;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2139 				gpE_Table	= HUNOBASIC_SIDEWALKLEFT_Port;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2140 				gpPg_Table 	= HUNOBASIC_SIDEWALKLEFT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2141 				gpDg_Table 	= HUNOBASIC_SIDEWALKLEFT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2142 				gpIg_Table 	= HUNOBASIC_SIDEWALKLEFT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2143 				gpFN_Table	= HUNOBASIC_SIDEWALKLEFT_Frames;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2144 				gpRT_Table	= HUNOBASIC_SIDEWALKLEFT_TrTime;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2145 				gpPos_Table	= HUNOBASIC_SIDEWALKLEFT_Position;
	__POINTD1FN _HUNOBASIC_SIDEWALKLEFT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2146 				Motion.NumOfScene = HUNOBASIC_SIDEWALKLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2147 				Motion.NumOfwCK = HUNOBASIC_SIDEWALKLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2148 				break;
	RJMP _0x202
;    2149 			case BTN_R:
_0x208:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x209
;    2150 			 	SendToSoundIC(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2151 				gpT_Table	= HUNOBASIC_SIDEWALKRIGHT_Torque;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2152 				gpE_Table	= HUNOBASIC_SIDEWALKRIGHT_Port;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2153 				gpPg_Table 	= HUNOBASIC_SIDEWALKRIGHT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2154 				gpDg_Table 	= HUNOBASIC_SIDEWALKRIGHT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2155 				gpIg_Table 	= HUNOBASIC_SIDEWALKRIGHT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2156 				gpFN_Table	= HUNOBASIC_SIDEWALKRIGHT_Frames;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2157 				gpRT_Table	= HUNOBASIC_SIDEWALKRIGHT_TrTime;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2158 				gpPos_Table	= HUNOBASIC_SIDEWALKRIGHT_Position;
	__POINTD1FN _HUNOBASIC_SIDEWALKRIGHT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2159 				Motion.NumOfScene = HUNOBASIC_SIDEWALKRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2160 				Motion.NumOfwCK = HUNOBASIC_SIDEWALKRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2161 				break;
	RJMP _0x202
;    2162 			case BTN_LA:
_0x209:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x20A
;    2163 			 	SendToSoundIC(6);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2164 				gpT_Table	= HUNOBASIC_PUNCHLEFT_Torque;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2165 				gpE_Table	= HUNOBASIC_PUNCHLEFT_Port;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2166 				gpPg_Table 	= HUNOBASIC_PUNCHLEFT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2167 				gpDg_Table 	= HUNOBASIC_PUNCHLEFT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2168 				gpIg_Table 	= HUNOBASIC_PUNCHLEFT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2169 				gpFN_Table	= HUNOBASIC_PUNCHLEFT_Frames;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2170 				gpRT_Table	= HUNOBASIC_PUNCHLEFT_TrTime;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2171 				gpPos_Table	= HUNOBASIC_PUNCHLEFT_Position;
	__POINTD1FN _HUNOBASIC_PUNCHLEFT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2172 				Motion.NumOfScene = HUNOBASIC_PUNCHLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1MN _Motion,6
;    2173 				Motion.NumOfwCK = HUNOBASIC_PUNCHLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2174 				break;
	RJMP _0x202
;    2175 			case BTN_D:
_0x20A:
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0x20B
;    2176 			 	SendToSoundIC(3);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2177 				gpT_Table	= HUNOBASIC_WALKBACKWARD_Torque;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2178 				gpE_Table	= HUNOBASIC_WALKBACKWARD_Port;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2179 				gpPg_Table 	= HUNOBASIC_WALKBACKWARD_RuntimePGain;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2180 				gpDg_Table 	= HUNOBASIC_WALKBACKWARD_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2181 				gpIg_Table 	= HUNOBASIC_WALKBACKWARD_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2182 				gpFN_Table	= HUNOBASIC_WALKBACKWARD_Frames;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2183 				gpRT_Table	= HUNOBASIC_WALKBACKWARD_TrTime;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2184 				gpPos_Table	= HUNOBASIC_WALKBACKWARD_Position;
	__POINTD1FN _HUNOBASIC_WALKBACKWARD_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2185 				Motion.NumOfScene = HUNOBASIC_WALKBACKWARD_NUM_OF_SCENES;
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	__PUTW1MN _Motion,6
;    2186 				Motion.NumOfwCK = HUNOBASIC_WALKBACKWARD_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2187 				break;
	RJMP _0x202
;    2188 			case BTN_RA:
_0x20B:
	CPI  R30,LOW(0xB)
	BREQ PC+3
	JMP _0x20C
;    2189 			 	SendToSoundIC(6);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2190 				gpT_Table	= HUNOBASIC_PUNCHRIGHT_Torque;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2191 				gpE_Table	= HUNOBASIC_PUNCHRIGHT_Port;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2192 				gpPg_Table 	= HUNOBASIC_PUNCHRIGHT_RuntimePGain;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2193 				gpDg_Table 	= HUNOBASIC_PUNCHRIGHT_RuntimeDGain;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2194 				gpIg_Table 	= HUNOBASIC_PUNCHRIGHT_RuntimeIGain;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2195 				gpFN_Table	= HUNOBASIC_PUNCHRIGHT_Frames;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2196 				gpRT_Table	= HUNOBASIC_PUNCHRIGHT_TrTime;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2197 				gpPos_Table	= HUNOBASIC_PUNCHRIGHT_Position;
	__POINTD1FN _HUNOBASIC_PUNCHRIGHT_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2198 				Motion.NumOfScene = HUNOBASIC_PUNCHRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1MN _Motion,6
;    2199 				Motion.NumOfwCK = HUNOBASIC_PUNCHRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2200 				break;
	RJMP _0x202
;    2201 			case BTN_0:
_0x20C:
	CPI  R30,LOW(0x15)
	BREQ PC+3
	JMP _0x20E
;    2202 				gpT_Table	= MY_DEMO1_Torque;
	__POINTD1FN _MY_DEMO1_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2203 				gpE_Table	= MY_DEMO1_Port;
	__POINTD1FN _MY_DEMO1_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2204 				gpPg_Table 	= MY_DEMO1_RuntimePGain;
	__POINTD1FN _MY_DEMO1_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2205 				gpDg_Table 	= MY_DEMO1_RuntimeDGain;
	__POINTD1FN _MY_DEMO1_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2206 				gpIg_Table 	= MY_DEMO1_RuntimeIGain;
	__POINTD1FN _MY_DEMO1_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2207 				gpFN_Table	= MY_DEMO1_Frames;
	__POINTD1FN _MY_DEMO1_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2208 				gpRT_Table	= MY_DEMO1_TrTime;
	__POINTD1FN _MY_DEMO1_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2209 				gpPos_Table	= MY_DEMO1_Position;
	__POINTD1FN _MY_DEMO1_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2210 				Motion.NumOfScene = MY_DEMO1_NUM_OF_SCENES;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1MN _Motion,6
;    2211 				Motion.NumOfwCK = MY_DEMO1_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2212 				break;
	RJMP _0x202
;    2213 			default:
_0x20E:
;    2214 				return;
_0x313:
	ADIW R28,1
	RET
;    2215 		}
_0x202:
;    2216 	}
;    2217 	else if(F_PF == PF1_DINO){
	JMP  _0x20F
_0x1FF:
	LDI  R30,LOW(2)
	CP   R30,R13
	BREQ PC+3
	JMP _0x210
;    2218 		switch(BtnCode){
	LD   R30,Y
;    2219 			case BTN_A:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x214
;    2220 	 			SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2221 				gpT_Table	= DinoBasic_GetupFront_Torque;
	__POINTD1FN _DinoBasic_GetupFront_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2222 				gpE_Table	= DinoBasic_GetupFront_Port;
	__POINTD1FN _DinoBasic_GetupFront_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2223 				gpPg_Table 	= DinoBasic_GetupFront_RuntimePGain;
	__POINTD1FN _DinoBasic_GetupFront_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2224 				gpDg_Table 	= DinoBasic_GetupFront_RuntimeDGain;
	__POINTD1FN _DinoBasic_GetupFront_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2225 				gpIg_Table 	= DinoBasic_GetupFront_RuntimeIGain;
	__POINTD1FN _DinoBasic_GetupFront_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2226 				gpFN_Table	= DinoBasic_GetupFront_Frames;
	__POINTD1FN _DinoBasic_GetupFront_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2227 				gpRT_Table	= DinoBasic_GetupFront_TrTime;
	__POINTD1FN _DinoBasic_GetupFront_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2228 				gpPos_Table	= DinoBasic_GetupFront_Position;
	__POINTD1FN _DinoBasic_GetupFront_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2229 				Motion.NumOfScene = DINOBASIC_GETUPFRONT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2230 				Motion.NumOfwCK = DINOBASIC_GETUPFRONT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2231 				break;
	RJMP _0x213
;    2232 			case BTN_B:
_0x214:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x215
;    2233 	 			SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2234 				gpT_Table	= DinoBasic_GetupBack_Torque;
	__POINTD1FN _DinoBasic_GetupBack_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2235 				gpE_Table	= DinoBasic_GetupBack_Port;
	__POINTD1FN _DinoBasic_GetupBack_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2236 				gpPg_Table 	= DinoBasic_GetupBack_RuntimePGain;
	__POINTD1FN _DinoBasic_GetupBack_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2237 				gpDg_Table 	= DinoBasic_GetupBack_RuntimeDGain;
	__POINTD1FN _DinoBasic_GetupBack_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2238 				gpIg_Table 	= DinoBasic_GetupBack_RuntimeIGain;
	__POINTD1FN _DinoBasic_GetupBack_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2239 				gpFN_Table	= DinoBasic_GetupBack_Frames;
	__POINTD1FN _DinoBasic_GetupBack_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2240 				gpRT_Table	= DinoBasic_GetupBack_TrTime;
	__POINTD1FN _DinoBasic_GetupBack_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2241 				gpPos_Table	= DinoBasic_GetupBack_Position;
	__POINTD1FN _DinoBasic_GetupBack_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2242 				Motion.NumOfScene = DINOBASIC_GETUPBACK_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2243 				Motion.NumOfwCK = DINOBASIC_GETUPBACK_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2244 				break;
	RJMP _0x213
;    2245 			case BTN_LR:
_0x215:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x216
;    2246 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2247 				gpT_Table	= DinoBasic_TurnLeft_Torque;
	__POINTD1FN _DinoBasic_TurnLeft_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2248 				gpE_Table	= DinoBasic_TurnLeft_Port;
	__POINTD1FN _DinoBasic_TurnLeft_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2249 				gpPg_Table 	= DinoBasic_TurnLeft_RuntimePGain;
	__POINTD1FN _DinoBasic_TurnLeft_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2250 				gpDg_Table 	= DinoBasic_TurnLeft_RuntimeDGain;
	__POINTD1FN _DinoBasic_TurnLeft_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2251 				gpIg_Table 	= DinoBasic_TurnLeft_RuntimeIGain;
	__POINTD1FN _DinoBasic_TurnLeft_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2252 				gpFN_Table	= DinoBasic_TurnLeft_Frames;
	__POINTD1FN _DinoBasic_TurnLeft_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2253 				gpRT_Table	= DinoBasic_TurnLeft_TrTime;
	__POINTD1FN _DinoBasic_TurnLeft_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2254 				gpPos_Table	= DinoBasic_TurnLeft_Position;
	__POINTD1FN _DinoBasic_TurnLeft_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2255 				Motion.NumOfScene = DINOBASIC_TURNLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2256 				Motion.NumOfwCK = DINOBASIC_TURNLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2257 				break;
	RJMP _0x213
;    2258 			case BTN_U:
_0x216:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x217
;    2259 			 	SendToSoundIC(14);
	LDI  R30,LOW(14)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2260 				gpT_Table	= DinoBasic_WalkForward_Torque;
	__POINTD1FN _DinoBasic_WalkForward_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2261 				gpE_Table	= DinoBasic_WalkForward_Port;
	__POINTD1FN _DinoBasic_WalkForward_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2262 				gpPg_Table 	= DinoBasic_WalkForward_RuntimePGain;
	__POINTD1FN _DinoBasic_WalkForward_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2263 				gpDg_Table 	= DinoBasic_WalkForward_RuntimeDGain;
	__POINTD1FN _DinoBasic_WalkForward_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2264 				gpIg_Table 	= DinoBasic_WalkForward_RuntimeIGain;
	__POINTD1FN _DinoBasic_WalkForward_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2265 				gpFN_Table	= DinoBasic_WalkForward_Frames;
	__POINTD1FN _DinoBasic_WalkForward_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2266 				gpRT_Table	= DinoBasic_WalkForward_TrTime;
	__POINTD1FN _DinoBasic_WalkForward_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2267 				gpPos_Table	= DinoBasic_WalkForward_Position;
	__POINTD1FN _DinoBasic_WalkForward_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2268 				Motion.NumOfScene = DINOBASIC_WALKFORWARD_NUM_OF_SCENES;
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	__PUTW1MN _Motion,6
;    2269 				Motion.NumOfwCK = DINOBASIC_WALKFORWARD_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2270 				break;
	RJMP _0x213
;    2271 			case BTN_RR:
_0x217:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x218
;    2272 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2273 				gpT_Table	= DinoBasic_TurnRight_Torque;
	__POINTD1FN _DinoBasic_TurnRight_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2274 				gpE_Table	= DinoBasic_TurnRight_Port;
	__POINTD1FN _DinoBasic_TurnRight_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2275 				gpPg_Table 	= DinoBasic_TurnRight_RuntimePGain;
	__POINTD1FN _DinoBasic_TurnRight_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2276 				gpDg_Table 	= DinoBasic_TurnRight_RuntimeDGain;
	__POINTD1FN _DinoBasic_TurnRight_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2277 				gpIg_Table 	= DinoBasic_TurnRight_RuntimeIGain;
	__POINTD1FN _DinoBasic_TurnRight_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2278 				gpFN_Table	= DinoBasic_TurnRight_Frames;
	__POINTD1FN _DinoBasic_TurnRight_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2279 				gpRT_Table	= DinoBasic_TurnRight_TrTime;
	__POINTD1FN _DinoBasic_TurnRight_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2280 				gpPos_Table	= DinoBasic_TurnRight_Position;
	__POINTD1FN _DinoBasic_TurnRight_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2281 				Motion.NumOfScene = DINOBASIC_TURNRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	__PUTW1MN _Motion,6
;    2282 				Motion.NumOfwCK = DINOBASIC_TURNRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2283 				break;
	RJMP _0x213
;    2284 			case BTN_L:
_0x218:
	CPI  R30,LOW(0x6)
	BREQ PC+3
	JMP _0x219
;    2285 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2286 				gpT_Table	= DinoBasic_SidewalkLeft_Torque;
	__POINTD1FN _DinoBasic_SidewalkLeft_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2287 				gpE_Table	= DinoBasic_SidewalkLeft_Port;
	__POINTD1FN _DinoBasic_SidewalkLeft_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2288 				gpPg_Table 	= DinoBasic_SidewalkLeft_RuntimePGain;
	__POINTD1FN _DinoBasic_SidewalkLeft_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2289 				gpDg_Table 	= DinoBasic_SidewalkLeft_RuntimeDGain;
	__POINTD1FN _DinoBasic_SidewalkLeft_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2290 				gpIg_Table 	= DinoBasic_SidewalkLeft_RuntimeIGain;
	__POINTD1FN _DinoBasic_SidewalkLeft_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2291 				gpFN_Table	= DinoBasic_SidewalkLeft_Frames;
	__POINTD1FN _DinoBasic_SidewalkLeft_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2292 				gpRT_Table	= DinoBasic_SidewalkLeft_TrTime;
	__POINTD1FN _DinoBasic_SidewalkLeft_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2293 				gpPos_Table	= DinoBasic_SidewalkLeft_Position;
	__POINTD1FN _DinoBasic_SidewalkLeft_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2294 				Motion.NumOfScene = DINOBASIC_SIDEWALKLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2295 				Motion.NumOfwCK = DINOBASIC_SIDEWALKLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2296 				break;
	RJMP _0x213
;    2297 			case BTN_R:
_0x219:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x21A
;    2298 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2299 				gpT_Table	= DinoBasic_SidewalkRight_Torque;
	__POINTD1FN _DinoBasic_SidewalkRight_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2300 				gpE_Table	= DinoBasic_SidewalkRight_Port;
	__POINTD1FN _DinoBasic_SidewalkRight_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2301 				gpPg_Table 	= DinoBasic_SidewalkRight_RuntimePGain;
	__POINTD1FN _DinoBasic_SidewalkRight_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2302 				gpDg_Table 	= DinoBasic_SidewalkRight_RuntimeDGain;
	__POINTD1FN _DinoBasic_SidewalkRight_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2303 				gpIg_Table 	= DinoBasic_SidewalkRight_RuntimeIGain;
	__POINTD1FN _DinoBasic_SidewalkRight_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2304 				gpFN_Table	= DinoBasic_SidewalkRight_Frames;
	__POINTD1FN _DinoBasic_SidewalkRight_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2305 				gpRT_Table	= DinoBasic_SidewalkRight_TrTime;
	__POINTD1FN _DinoBasic_SidewalkRight_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2306 				gpPos_Table	= DinoBasic_SidewalkRight_Position;
	__POINTD1FN _DinoBasic_SidewalkRight_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2307 				Motion.NumOfScene = DINOBASIC_SIDEWALKRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1MN _Motion,6
;    2308 				Motion.NumOfwCK = DINOBASIC_SIDEWALKRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2309 				break;
	RJMP _0x213
;    2310 			case BTN_LA:
_0x21A:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x21B
;    2311 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2312 				gpT_Table	= DinoBasic_PunchLeft_Torque;
	__POINTD1FN _DinoBasic_PunchLeft_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2313 				gpE_Table	= DinoBasic_PunchLeft_Port;
	__POINTD1FN _DinoBasic_PunchLeft_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2314 				gpPg_Table 	= DinoBasic_PunchLeft_RuntimePGain;
	__POINTD1FN _DinoBasic_PunchLeft_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2315 				gpDg_Table 	= DinoBasic_PunchLeft_RuntimeDGain;
	__POINTD1FN _DinoBasic_PunchLeft_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2316 				gpIg_Table 	= DinoBasic_PunchLeft_RuntimeIGain;
	__POINTD1FN _DinoBasic_PunchLeft_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2317 				gpFN_Table	= DinoBasic_PunchLeft_Frames;
	__POINTD1FN _DinoBasic_PunchLeft_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2318 				gpRT_Table	= DinoBasic_PunchLeft_TrTime;
	__POINTD1FN _DinoBasic_PunchLeft_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2319 				gpPos_Table	= DinoBasic_PunchLeft_Position;
	__POINTD1FN _DinoBasic_PunchLeft_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2320 				Motion.NumOfScene = DINOBASIC_PUNCHLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1MN _Motion,6
;    2321 				Motion.NumOfwCK = DINOBASIC_PUNCHLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2322 				break;
	RJMP _0x213
;    2323 			case BTN_D:
_0x21B:
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0x21C
;    2324 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2325 				gpT_Table	= DinoBasic_WalkBackward_Torque;
	__POINTD1FN _DinoBasic_WalkBackward_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2326 				gpE_Table	= DinoBasic_WalkBackward_Port;
	__POINTD1FN _DinoBasic_WalkBackward_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2327 				gpPg_Table 	= DinoBasic_WalkBackward_RuntimePGain;
	__POINTD1FN _DinoBasic_WalkBackward_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2328 				gpDg_Table 	= DinoBasic_WalkBackward_RuntimeDGain;
	__POINTD1FN _DinoBasic_WalkBackward_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2329 				gpIg_Table 	= DinoBasic_WalkBackward_RuntimeIGain;
	__POINTD1FN _DinoBasic_WalkBackward_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2330 				gpFN_Table	= DinoBasic_WalkBackward_Frames;
	__POINTD1FN _DinoBasic_WalkBackward_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2331 				gpRT_Table	= DinoBasic_WalkBackward_TrTime;
	__POINTD1FN _DinoBasic_WalkBackward_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2332 				gpPos_Table	= DinoBasic_WalkBackward_Position;
	__POINTD1FN _DinoBasic_WalkBackward_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2333 				Motion.NumOfScene = DINOBASIC_WALKBACKWARD_NUM_OF_SCENES;
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	__PUTW1MN _Motion,6
;    2334 				Motion.NumOfwCK = DINOBASIC_WALKBACKWARD_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2335 				break;
	RJMP _0x213
;    2336 			case BTN_RA:
_0x21C:
	CPI  R30,LOW(0xB)
	BREQ PC+3
	JMP _0x21E
;    2337 			 	SendToSoundIC(13);
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2338 				gpT_Table	= DinoBasic_PunchRight_Torque;
	__POINTD1FN _DinoBasic_PunchRight_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2339 				gpE_Table	= DinoBasic_PunchRight_Port;
	__POINTD1FN _DinoBasic_PunchRight_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2340 				gpPg_Table 	= DinoBasic_PunchRight_RuntimePGain;
	__POINTD1FN _DinoBasic_PunchRight_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2341 				gpDg_Table 	= DinoBasic_PunchRight_RuntimeDGain;
	__POINTD1FN _DinoBasic_PunchRight_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2342 				gpIg_Table 	= DinoBasic_PunchRight_RuntimeIGain;
	__POINTD1FN _DinoBasic_PunchRight_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2343 				gpFN_Table	= DinoBasic_PunchRight_Frames;
	__POINTD1FN _DinoBasic_PunchRight_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2344 				gpRT_Table	= DinoBasic_PunchRight_TrTime;
	__POINTD1FN _DinoBasic_PunchRight_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2345 				gpPos_Table	= DinoBasic_PunchRight_Position;
	__POINTD1FN _DinoBasic_PunchRight_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2346 				Motion.NumOfScene = DINOBASIC_PUNCHRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1MN _Motion,6
;    2347 				Motion.NumOfwCK = DINOBASIC_PUNCHRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2348 				break;
	RJMP _0x213
;    2349 			default:
_0x21E:
;    2350 				return;
	RJMP _0x312
;    2351 		}
_0x213:
;    2352 	}
;    2353 	else if(F_PF == PF1_DOGY){
	RJMP _0x21F
_0x210:
	LDI  R30,LOW(3)
	CP   R30,R13
	BREQ PC+3
	JMP _0x220
;    2354 		switch(BtnCode){
	LD   R30,Y
;    2355 			case BTN_A:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x224
;    2356 	 			SendToSoundIC(12);
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2357 				gpT_Table	= DogyBasic_GetupFront_Torque;
	__POINTD1FN _DogyBasic_GetupFront_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2358 				gpE_Table	= DogyBasic_GetupFront_Port;
	__POINTD1FN _DogyBasic_GetupFront_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2359 				gpPg_Table 	= DogyBasic_GetupFront_RuntimePGain;
	__POINTD1FN _DogyBasic_GetupFront_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2360 				gpDg_Table 	= DogyBasic_GetupFront_RuntimeDGain;
	__POINTD1FN _DogyBasic_GetupFront_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2361 				gpIg_Table 	= DogyBasic_GetupFront_RuntimeIGain;
	__POINTD1FN _DogyBasic_GetupFront_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2362 				gpFN_Table	= DogyBasic_GetupFront_Frames;
	__POINTD1FN _DogyBasic_GetupFront_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2363 				gpRT_Table	= DogyBasic_GetupFront_TrTime;
	__POINTD1FN _DogyBasic_GetupFront_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2364 				gpPos_Table	= DogyBasic_GetupFront_Position;
	__POINTD1FN _DogyBasic_GetupFront_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2365 				Motion.NumOfScene = DOGYBASIC_GETUPFRONT_NUM_OF_SCENES;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1MN _Motion,6
;    2366 				Motion.NumOfwCK = DOGYBASIC_GETUPFRONT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2367 				break;
	RJMP _0x223
;    2368 			case BTN_B:
_0x224:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x225
;    2369 	 			SendToSoundIC(12);
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2370 				gpT_Table	= DogyBasic_GetupBack_Torque;
	__POINTD1FN _DogyBasic_GetupBack_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2371 				gpE_Table	= DogyBasic_GetupBack_Port;
	__POINTD1FN _DogyBasic_GetupBack_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2372 				gpPg_Table 	= DogyBasic_GetupBack_RuntimePGain;
	__POINTD1FN _DogyBasic_GetupBack_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2373 				gpDg_Table 	= DogyBasic_GetupBack_RuntimeDGain;
	__POINTD1FN _DogyBasic_GetupBack_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2374 				gpIg_Table 	= DogyBasic_GetupBack_RuntimeIGain;
	__POINTD1FN _DogyBasic_GetupBack_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2375 				gpFN_Table	= DogyBasic_GetupBack_Frames;
	__POINTD1FN _DogyBasic_GetupBack_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2376 				gpRT_Table	= DogyBasic_GetupBack_TrTime;
	__POINTD1FN _DogyBasic_GetupBack_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2377 				gpPos_Table	= DogyBasic_GetupBack_Position;
	__POINTD1FN _DogyBasic_GetupBack_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2378 				Motion.NumOfScene = DOGYBASIC_GETUPBACK_NUM_OF_SCENES;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1MN _Motion,6
;    2379 				Motion.NumOfwCK = DOGYBASIC_GETUPBACK_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2380 				break;
	RJMP _0x223
;    2381 			case BTN_LR:
_0x225:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x226
;    2382 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2383 				gpT_Table	= DogyBasic_TurnLeft_Torque;
	__POINTD1FN _DogyBasic_TurnLeft_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2384 				gpE_Table	= DogyBasic_TurnLeft_Port;
	__POINTD1FN _DogyBasic_TurnLeft_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2385 				gpPg_Table 	= DogyBasic_TurnLeft_RuntimePGain;
	__POINTD1FN _DogyBasic_TurnLeft_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2386 				gpDg_Table 	= DogyBasic_TurnLeft_RuntimeDGain;
	__POINTD1FN _DogyBasic_TurnLeft_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2387 				gpIg_Table 	= DogyBasic_TurnLeft_RuntimeIGain;
	__POINTD1FN _DogyBasic_TurnLeft_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2388 				gpFN_Table	= DogyBasic_TurnLeft_Frames;
	__POINTD1FN _DogyBasic_TurnLeft_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2389 				gpRT_Table	= DogyBasic_TurnLeft_TrTime;
	__POINTD1FN _DogyBasic_TurnLeft_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2390 				gpPos_Table	= DogyBasic_TurnLeft_Position;
	__POINTD1FN _DogyBasic_TurnLeft_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2391 				Motion.NumOfScene = DOGYBASIC_TURNLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1MN _Motion,6
;    2392 				Motion.NumOfwCK = DOGYBASIC_TURNLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2393 				break;
	RJMP _0x223
;    2394 			case BTN_U:
_0x226:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x227
;    2395 			 	SendToSoundIC(10);
	LDI  R30,LOW(10)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2396 				gpT_Table	= DogyBasic_WalkForward_Torque;
	__POINTD1FN _DogyBasic_WalkForward_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2397 				gpE_Table	= DogyBasic_WalkForward_Port;
	__POINTD1FN _DogyBasic_WalkForward_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2398 				gpPg_Table 	= DogyBasic_WalkForward_RuntimePGain;
	__POINTD1FN _DogyBasic_WalkForward_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2399 				gpDg_Table 	= DogyBasic_WalkForward_RuntimeDGain;
	__POINTD1FN _DogyBasic_WalkForward_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2400 				gpIg_Table 	= DogyBasic_WalkForward_RuntimeIGain;
	__POINTD1FN _DogyBasic_WalkForward_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2401 				gpFN_Table	= DogyBasic_WalkForward_Frames;
	__POINTD1FN _DogyBasic_WalkForward_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2402 				gpRT_Table	= DogyBasic_WalkForward_TrTime;
	__POINTD1FN _DogyBasic_WalkForward_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2403 				gpPos_Table	= DogyBasic_WalkForward_Position;
	__POINTD1FN _DogyBasic_WalkForward_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2404 				Motion.NumOfScene = DOGYBASIC_WALKFORWARD_NUM_OF_SCENES;
	LDI  R30,LOW(51)
	LDI  R31,HIGH(51)
	__PUTW1MN _Motion,6
;    2405 				Motion.NumOfwCK = DOGYBASIC_WALKFORWARD_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2406 				break;
	RJMP _0x223
;    2407 			case BTN_RR:
_0x227:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x228
;    2408 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2409 				gpT_Table	= DogyBasic_TurnRight_Torque;
	__POINTD1FN _DogyBasic_TurnRight_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2410 				gpE_Table	= DogyBasic_TurnRight_Port;
	__POINTD1FN _DogyBasic_TurnRight_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2411 				gpPg_Table 	= DogyBasic_TurnRight_RuntimePGain;
	__POINTD1FN _DogyBasic_TurnRight_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2412 				gpDg_Table 	= DogyBasic_TurnRight_RuntimeDGain;
	__POINTD1FN _DogyBasic_TurnRight_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2413 				gpIg_Table 	= DogyBasic_TurnRight_RuntimeIGain;
	__POINTD1FN _DogyBasic_TurnRight_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2414 				gpFN_Table	= DogyBasic_TurnRight_Frames;
	__POINTD1FN _DogyBasic_TurnRight_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2415 				gpRT_Table	= DogyBasic_TurnRight_TrTime;
	__POINTD1FN _DogyBasic_TurnRight_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2416 				gpPos_Table	= DogyBasic_TurnRight_Position;
	__POINTD1FN _DogyBasic_TurnRight_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2417 				Motion.NumOfScene = DOGYBASIC_TURNRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1MN _Motion,6
;    2418 				Motion.NumOfwCK = DOGYBASIC_TURNRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2419 				break;
	RJMP _0x223
;    2420 			case BTN_L:
_0x228:
	CPI  R30,LOW(0x6)
	BREQ PC+3
	JMP _0x229
;    2421 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2422 				gpT_Table	= DogyBasic_SidewalkLeft_Torque;
	__POINTD1FN _DogyBasic_SidewalkLeft_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2423 				gpE_Table	= DogyBasic_SidewalkLeft_Port;
	__POINTD1FN _DogyBasic_SidewalkLeft_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2424 				gpPg_Table 	= DogyBasic_SidewalkLeft_RuntimePGain;
	__POINTD1FN _DogyBasic_SidewalkLeft_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2425 				gpDg_Table 	= DogyBasic_SidewalkLeft_RuntimeDGain;
	__POINTD1FN _DogyBasic_SidewalkLeft_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2426 				gpIg_Table 	= DogyBasic_SidewalkLeft_RuntimeIGain;
	__POINTD1FN _DogyBasic_SidewalkLeft_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2427 				gpFN_Table	= DogyBasic_SidewalkLeft_Frames;
	__POINTD1FN _DogyBasic_SidewalkLeft_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2428 				gpRT_Table	= DogyBasic_SidewalkLeft_TrTime;
	__POINTD1FN _DogyBasic_SidewalkLeft_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2429 				gpPos_Table	= DogyBasic_SidewalkLeft_Position;
	__POINTD1FN _DogyBasic_SidewalkLeft_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2430 				Motion.NumOfScene = DOGYBASIC_SIDEWALKLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	__PUTW1MN _Motion,6
;    2431 				Motion.NumOfwCK = DOGYBASIC_SIDEWALKLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2432 				break;
	RJMP _0x223
;    2433 			case BTN_R:
_0x229:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x22A
;    2434 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2435 				gpT_Table	= DogyBasic_SidewalkRight_Torque;
	__POINTD1FN _DogyBasic_SidewalkRight_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2436 				gpE_Table	= DogyBasic_SidewalkRight_Port;
	__POINTD1FN _DogyBasic_SidewalkRight_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2437 				gpPg_Table 	= DogyBasic_SidewalkRight_RuntimePGain;
	__POINTD1FN _DogyBasic_SidewalkRight_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2438 				gpDg_Table 	= DogyBasic_SidewalkRight_RuntimeDGain;
	__POINTD1FN _DogyBasic_SidewalkRight_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2439 				gpIg_Table 	= DogyBasic_SidewalkRight_RuntimeIGain;
	__POINTD1FN _DogyBasic_SidewalkRight_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2440 				gpFN_Table	= DogyBasic_SidewalkRight_Frames;
	__POINTD1FN _DogyBasic_SidewalkRight_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2441 				gpRT_Table	= DogyBasic_SidewalkRight_TrTime;
	__POINTD1FN _DogyBasic_SidewalkRight_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2442 				gpPos_Table	= DogyBasic_SidewalkRight_Position;
	__POINTD1FN _DogyBasic_SidewalkRight_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2443 				Motion.NumOfScene = DOGYBASIC_SIDEWALKRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	__PUTW1MN _Motion,6
;    2444 				Motion.NumOfwCK = DOGYBASIC_SIDEWALKRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2445 				break;
	RJMP _0x223
;    2446 			case BTN_LA:
_0x22A:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x22B
;    2447 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2448 				gpT_Table	= DogyBasic_PunchLeft_Torque;
	__POINTD1FN _DogyBasic_PunchLeft_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2449 				gpE_Table	= DogyBasic_PunchLeft_Port;
	__POINTD1FN _DogyBasic_PunchLeft_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2450 				gpPg_Table 	= DogyBasic_PunchLeft_RuntimePGain;
	__POINTD1FN _DogyBasic_PunchLeft_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2451 				gpDg_Table 	= DogyBasic_PunchLeft_RuntimeDGain;
	__POINTD1FN _DogyBasic_PunchLeft_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2452 				gpIg_Table 	= DogyBasic_PunchLeft_RuntimeIGain;
	__POINTD1FN _DogyBasic_PunchLeft_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2453 				gpFN_Table	= DogyBasic_PunchLeft_Frames;
	__POINTD1FN _DogyBasic_PunchLeft_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2454 				gpRT_Table	= DogyBasic_PunchLeft_TrTime;
	__POINTD1FN _DogyBasic_PunchLeft_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2455 				gpPos_Table	= DogyBasic_PunchLeft_Position;
	__POINTD1FN _DogyBasic_PunchLeft_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2456 				Motion.NumOfScene = DOGYBASIC_PUNCHLEFT_NUM_OF_SCENES;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1MN _Motion,6
;    2457 				Motion.NumOfwCK = DOGYBASIC_PUNCHLEFT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2458 				break;
	RJMP _0x223
;    2459 			case BTN_D:
_0x22B:
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0x22C
;    2460 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2461 				gpT_Table	= DogyBasic_WalkBackward_Torque;
	__POINTD1FN _DogyBasic_WalkBackward_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2462 				gpE_Table	= DogyBasic_WalkBackward_Port;
	__POINTD1FN _DogyBasic_WalkBackward_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2463 				gpPg_Table 	= DogyBasic_WalkBackward_RuntimePGain;
	__POINTD1FN _DogyBasic_WalkBackward_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2464 				gpDg_Table 	= DogyBasic_WalkBackward_RuntimeDGain;
	__POINTD1FN _DogyBasic_WalkBackward_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2465 				gpIg_Table 	= DogyBasic_WalkBackward_RuntimeIGain;
	__POINTD1FN _DogyBasic_WalkBackward_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2466 				gpFN_Table	= DogyBasic_WalkBackward_Frames;
	__POINTD1FN _DogyBasic_WalkBackward_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2467 				gpRT_Table	= DogyBasic_WalkBackward_TrTime;
	__POINTD1FN _DogyBasic_WalkBackward_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2468 				gpPos_Table	= DogyBasic_WalkBackward_Position;
	__POINTD1FN _DogyBasic_WalkBackward_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2469 				Motion.NumOfScene = DOGYBASIC_WALKBACKWARD_NUM_OF_SCENES;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	__PUTW1MN _Motion,6
;    2470 				Motion.NumOfwCK = DOGYBASIC_WALKBACKWARD_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2471 				break;
	RJMP _0x223
;    2472 			case BTN_RA:
_0x22C:
	CPI  R30,LOW(0xB)
	BREQ PC+3
	JMP _0x22E
;    2473 			 	SendToSoundIC(11);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _SendToSoundIC
;    2474 				gpT_Table	= DogyBasic_PunchRight_Torque;
	__POINTD1FN _DogyBasic_PunchRight_Torque,0
	STS  _gpT_Table,R30
	STS  _gpT_Table+1,R31
	STS  _gpT_Table+2,R22
	STS  _gpT_Table+3,R23
;    2475 				gpE_Table	= DogyBasic_PunchRight_Port;
	__POINTD1FN _DogyBasic_PunchRight_Port,0
	STS  _gpE_Table,R30
	STS  _gpE_Table+1,R31
	STS  _gpE_Table+2,R22
	STS  _gpE_Table+3,R23
;    2476 				gpPg_Table 	= DogyBasic_PunchRight_RuntimePGain;
	__POINTD1FN _DogyBasic_PunchRight_RuntimePGain,0
	STS  _gpPg_Table,R30
	STS  _gpPg_Table+1,R31
	STS  _gpPg_Table+2,R22
	STS  _gpPg_Table+3,R23
;    2477 				gpDg_Table 	= DogyBasic_PunchRight_RuntimeDGain;
	__POINTD1FN _DogyBasic_PunchRight_RuntimeDGain,0
	STS  _gpDg_Table,R30
	STS  _gpDg_Table+1,R31
	STS  _gpDg_Table+2,R22
	STS  _gpDg_Table+3,R23
;    2478 				gpIg_Table 	= DogyBasic_PunchRight_RuntimeIGain;
	__POINTD1FN _DogyBasic_PunchRight_RuntimeIGain,0
	STS  _gpIg_Table,R30
	STS  _gpIg_Table+1,R31
	STS  _gpIg_Table+2,R22
	STS  _gpIg_Table+3,R23
;    2479 				gpFN_Table	= DogyBasic_PunchRight_Frames;
	__POINTD1FN _DogyBasic_PunchRight_Frames,0
	STS  _gpFN_Table,R30
	STS  _gpFN_Table+1,R31
	STS  _gpFN_Table+2,R22
	STS  _gpFN_Table+3,R23
;    2480 				gpRT_Table	= DogyBasic_PunchRight_TrTime;
	__POINTD1FN _DogyBasic_PunchRight_TrTime,0
	STS  _gpRT_Table,R30
	STS  _gpRT_Table+1,R31
	STS  _gpRT_Table+2,R22
	STS  _gpRT_Table+3,R23
;    2481 				gpPos_Table	= DogyBasic_PunchRight_Position;
	__POINTD1FN _DogyBasic_PunchRight_Position,0
	STS  _gpPos_Table,R30
	STS  _gpPos_Table+1,R31
	STS  _gpPos_Table+2,R22
	STS  _gpPos_Table+3,R23
;    2482 				Motion.NumOfScene = DOGYBASIC_PUNCHRIGHT_NUM_OF_SCENES;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1MN _Motion,6
;    2483 				Motion.NumOfwCK = DOGYBASIC_PUNCHRIGHT_NUM_OF_WCKS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1MN _Motion,8
;    2484 				break;
	RJMP _0x223
;    2485 			default:
_0x22E:
;    2486 				return;
	RJMP _0x312
;    2487 		}
_0x223:
;    2488 	}
;    2489 	else if(F_PF == PF2){
	RJMP _0x22F
_0x220:
	LDI  R30,LOW(4)
	CP   R30,R13
	BRNE _0x230
;    2490 		return;
	RJMP _0x312
;    2491 	}
;    2492 	Motion.PF = F_PF;
_0x230:
_0x22F:
_0x21F:
_0x20F:
	__PUTBMRN _Motion,5,13
;    2493 	M_PlayFlash();
	CALL _M_PlayFlash
;    2494 }
_0x312:
	ADIW R28,1
	RET
;    2495 //==============================================================================
;    2496 //						Digital Input Output  Լ
;    2497 //==============================================================================
;    2498 
;    2499 #include <mega128.h>
;    2500 #include "Main.h"
;    2501 #include "Macro.h"
;    2502 #include "DIO.h"
;    2503 
;    2504 //------------------------------------------------------------------------------
;    2505 // ư б
;    2506 //------------------------------------------------------------------------------
;    2507 void ReadButton(void)
;    2508 {
_ReadButton:
;    2509 	BYTE	lbtmp;
;    2510 
;    2511 	lbtmp = PINA & 0x03;
	ST   -Y,R16
;	lbtmp -> R16
	IN   R30,0x19
	ANDI R30,LOW(0x3)
	MOV  R16,R30
;    2512 
;    2513 	if(F_DOWNLOAD) return;
	SBRC R2,4
	RJMP _0x311
;    2514 
;    2515 	if(lbtmp == 0x02){
	CPI  R16,2
	BRNE _0x232
;    2516 		gPF1BtnCnt++;		gPF2BtnCnt = 0;		gPF12BtnCnt = 0;
	LDS  R30,_gPF1BtnCnt
	LDS  R31,_gPF1BtnCnt+1
	ADIW R30,1
	STS  _gPF1BtnCnt,R30
	STS  _gPF1BtnCnt+1,R31
	LDI  R30,0
	STS  _gPF2BtnCnt,R30
	STS  _gPF2BtnCnt+1,R30
	LDI  R30,0
	STS  _gPF12BtnCnt,R30
	STS  _gPF12BtnCnt+1,R30
;    2517        	if(gPF1BtnCnt > 3000){
	LDS  R26,_gPF1BtnCnt
	LDS  R27,_gPF1BtnCnt+1
	CPI  R26,LOW(0xBB9)
	LDI  R30,HIGH(0xBB9)
	CPC  R27,R30
	BRLO _0x233
;    2518 			gBtn_val = PF1_BTN_LONG;
	LDI  R30,LOW(4)
	STS  _gBtn_val,R30
;    2519 			gPF1BtnCnt = 0;
	LDI  R30,0
	STS  _gPF1BtnCnt,R30
	STS  _gPF1BtnCnt+1,R30
;    2520 		}
;    2521 	}
_0x233:
;    2522 	else if(lbtmp == 0x01){
	RJMP _0x234
_0x232:
	CPI  R16,1
	BRNE _0x235
;    2523 		gPF1BtnCnt = 0;		gPF2BtnCnt++;		gPF12BtnCnt = 0;
	LDI  R30,0
	STS  _gPF1BtnCnt,R30
	STS  _gPF1BtnCnt+1,R30
	LDS  R30,_gPF2BtnCnt
	LDS  R31,_gPF2BtnCnt+1
	ADIW R30,1
	STS  _gPF2BtnCnt,R30
	STS  _gPF2BtnCnt+1,R31
	LDI  R30,0
	STS  _gPF12BtnCnt,R30
	STS  _gPF12BtnCnt+1,R30
;    2524        	if(gPF2BtnCnt > 3000){
	LDS  R26,_gPF2BtnCnt
	LDS  R27,_gPF2BtnCnt+1
	CPI  R26,LOW(0xBB9)
	LDI  R30,HIGH(0xBB9)
	CPC  R27,R30
	BRLO _0x236
;    2525 			gBtn_val = PF2_BTN_LONG;
	LDI  R30,LOW(5)
	STS  _gBtn_val,R30
;    2526 			gPF2BtnCnt = 0;
	LDI  R30,0
	STS  _gPF2BtnCnt,R30
	STS  _gPF2BtnCnt+1,R30
;    2527 		}
;    2528 	}
_0x236:
;    2529 	else if(lbtmp == 0x00){
	RJMP _0x237
_0x235:
	CPI  R16,0
	BRNE _0x238
;    2530 		gPF1BtnCnt = 0;		gPF2BtnCnt = 0;		gPF12BtnCnt++;
	LDI  R30,0
	STS  _gPF1BtnCnt,R30
	STS  _gPF1BtnCnt+1,R30
	LDI  R30,0
	STS  _gPF2BtnCnt,R30
	STS  _gPF2BtnCnt+1,R30
	LDS  R30,_gPF12BtnCnt
	LDS  R31,_gPF12BtnCnt+1
	ADIW R30,1
	STS  _gPF12BtnCnt,R30
	STS  _gPF12BtnCnt+1,R31
;    2531        	if(gPF12BtnCnt > 2000){
	LDS  R26,_gPF12BtnCnt
	LDS  R27,_gPF12BtnCnt+1
	CPI  R26,LOW(0x7D1)
	LDI  R30,HIGH(0x7D1)
	CPC  R27,R30
	BRLO _0x239
;    2532            	if(F_PF_CHANGED == 0){
	SBRC R3,1
	RJMP _0x23A
;    2533 				gBtn_val = PF12_BTN_LONG;
	LDI  R30,LOW(6)
	STS  _gBtn_val,R30
;    2534 	       	    gPF12BtnCnt = 0;
	LDI  R30,0
	STS  _gPF12BtnCnt,R30
	STS  _gPF12BtnCnt+1,R30
;    2535 			}
;    2536 		}
_0x23A:
;    2537 	}
_0x239:
;    2538 	else{
	RJMP _0x23B
_0x238:
;    2539 		if(gPF1BtnCnt > 40 && gPF1BtnCnt < 500){
	LDS  R26,_gPF1BtnCnt
	LDS  R27,_gPF1BtnCnt+1
	SBIW R26,41
	BRLO _0x23D
	LDS  R26,_gPF1BtnCnt
	LDS  R27,_gPF1BtnCnt+1
	CPI  R26,LOW(0x1F4)
	LDI  R30,HIGH(0x1F4)
	CPC  R27,R30
	BRLO _0x23E
_0x23D:
	RJMP _0x23C
_0x23E:
;    2540 			gBtn_val = PF1_BTN_SHORT;
	LDI  R30,LOW(1)
	RJMP _0x32F
;    2541 		}
;    2542 		else if(gPF2BtnCnt > 40 && gPF2BtnCnt < 500){
_0x23C:
	LDS  R26,_gPF2BtnCnt
	LDS  R27,_gPF2BtnCnt+1
	SBIW R26,41
	BRLO _0x241
	LDS  R26,_gPF2BtnCnt
	LDS  R27,_gPF2BtnCnt+1
	CPI  R26,LOW(0x1F4)
	LDI  R30,HIGH(0x1F4)
	CPC  R27,R30
	BRLO _0x242
_0x241:
	RJMP _0x240
_0x242:
;    2543 			gBtn_val = PF2_BTN_SHORT;
	LDI  R30,LOW(2)
	RJMP _0x32F
;    2544 		}
;    2545 		else if(gPF12BtnCnt > 40 && gPF12BtnCnt < 500){
_0x240:
	LDS  R26,_gPF12BtnCnt
	LDS  R27,_gPF12BtnCnt+1
	SBIW R26,41
	BRLO _0x245
	LDS  R26,_gPF12BtnCnt
	LDS  R27,_gPF12BtnCnt+1
	CPI  R26,LOW(0x1F4)
	LDI  R30,HIGH(0x1F4)
	CPC  R27,R30
	BRLO _0x246
_0x245:
	RJMP _0x244
_0x246:
;    2546 			gBtn_val = PF12_BTN_SHORT;
	LDI  R30,LOW(3)
	RJMP _0x32F
;    2547 		}
;    2548 		else
_0x244:
;    2549 			gBtn_val = BTN_NOT_PRESSED;
	LDI  R30,LOW(0)
_0x32F:
	STS  _gBtn_val,R30
;    2550 		gPF1BtnCnt = 0;
	LDI  R30,0
	STS  _gPF1BtnCnt,R30
	STS  _gPF1BtnCnt+1,R30
;    2551 		gPF2BtnCnt = 0;
	LDI  R30,0
	STS  _gPF2BtnCnt,R30
	STS  _gPF2BtnCnt+1,R30
;    2552 		gPF12BtnCnt = 0;
	LDI  R30,0
	STS  _gPF12BtnCnt,R30
	STS  _gPF12BtnCnt+1,R30
;    2553 		F_PF_CHANGED = 0;
	CLT
	BLD  R3,1
;    2554 	}
_0x23B:
_0x237:
_0x234:
;    2555 } 
_0x311:
	LD   R16,Y+
	RET
;    2556 
;    2557 
;    2558 //------------------------------------------------------------------------------
;    2559 // ư ó
;    2560 //------------------------------------------------------------------------------
;    2561 void ProcButton(void)
;    2562 {
_ProcButton:
;    2563 	WORD	i;
;    2564 	if(gBtn_val == PF12_BTN_LONG){
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDS  R26,_gBtn_val
	CPI  R26,LOW(0x6)
	BRNE _0x248
;    2565 		gBtn_val = 0;
	LDI  R30,LOW(0)
	STS  _gBtn_val,R30
;    2566 		if(F_PS_PLUGGED){
	SBRS R2,5
	RJMP _0x249
;    2567 			BreakModeCmdSend();
	CALL _BreakModeCmdSend
;    2568 			ChargeNiMH();
	CALL _ChargeNiMH
;    2569 		}
;    2570 	}
_0x249:
;    2571 	else if(gBtn_val == PF1_BTN_LONG){
	RJMP _0x24A
_0x248:
	LDS  R26,_gBtn_val
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0x24B
;    2572 		gBtn_val = 0;
	LDI  R30,LOW(0)
	STS  _gBtn_val,R30
;    2573 		if(F_PF==PF1_HUNO){
	LDI  R30,LOW(1)
	CP   R30,R13
	BRNE _0x24C
;    2574 			F_PF=PF1_DINO;
	LDI  R30,LOW(2)
	MOV  R13,R30
;    2575 			for(i=0;i<16;i++) BoundSetCmdSend(i, L_Boundary_Dino[i], U_Boundary_Dino[i]);
	__GETWRN 16,17,0
_0x24E:
	__CPWRN 16,17,16
	BRSH _0x24F
	ST   -Y,R16
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_L_Boundary_Dino*2)
	SBCI R31,HIGH(-_L_Boundary_Dino*2)
	SBCI R22,BYTE3(-_L_Boundary_Dino*2)
	__GETBRPF 30
	ST   -Y,R30
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_U_Boundary_Dino*2)
	SBCI R31,HIGH(-_U_Boundary_Dino*2)
	SBCI R22,BYTE3(-_U_Boundary_Dino*2)
	__GETBRPF 30
	ST   -Y,R30
	CALL _BoundSetCmdSend
;    2576 		}
	__ADDWRN 16,17,1
	RJMP _0x24E
_0x24F:
;    2577 		else if(F_PF==PF1_DINO){
	RJMP _0x250
_0x24C:
	LDI  R30,LOW(2)
	CP   R30,R13
	BRNE _0x251
;    2578 			F_PF=PF1_DOGY;
	LDI  R30,LOW(3)
	MOV  R13,R30
;    2579 			for(i=0;i<16;i++) BoundSetCmdSend(i, L_Boundary_Dogy[i], U_Boundary_Dogy[i]);
	__GETWRN 16,17,0
_0x253:
	__CPWRN 16,17,16
	BRSH _0x254
	ST   -Y,R16
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_L_Boundary_Dogy*2)
	SBCI R31,HIGH(-_L_Boundary_Dogy*2)
	SBCI R22,BYTE3(-_L_Boundary_Dogy*2)
	__GETBRPF 30
	ST   -Y,R30
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_U_Boundary_Dogy*2)
	SBCI R31,HIGH(-_U_Boundary_Dogy*2)
	SBCI R22,BYTE3(-_U_Boundary_Dogy*2)
	__GETBRPF 30
	ST   -Y,R30
	CALL _BoundSetCmdSend
;    2580 		}
	__ADDWRN 16,17,1
	RJMP _0x253
_0x254:
;    2581 		else{
	RJMP _0x255
_0x251:
;    2582 			F_PF=PF1_HUNO;
	LDI  R30,LOW(1)
	MOV  R13,R30
;    2583 			for(i=0;i<16;i++) BoundSetCmdSend(i, L_Boundary_Huno[i], U_Boundary_Huno[i]);
	__GETWRN 16,17,0
_0x257:
	__CPWRN 16,17,16
	BRSH _0x258
	ST   -Y,R16
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_L_Boundary_Huno*2)
	SBCI R31,HIGH(-_L_Boundary_Huno*2)
	SBCI R22,BYTE3(-_L_Boundary_Huno*2)
	__GETBRPF 30
	ST   -Y,R30
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_U_Boundary_Huno*2)
	SBCI R31,HIGH(-_U_Boundary_Huno*2)
	SBCI R22,BYTE3(-_U_Boundary_Huno*2)
	__GETBRPF 30
	ST   -Y,R30
	CALL _BoundSetCmdSend
;    2584 		}
	__ADDWRN 16,17,1
	RJMP _0x257
_0x258:
_0x255:
_0x250:
;    2585 		BreakModeCmdSend();
	RJMP _0x330
;    2586 		delay_ms(10);
;    2587 		F_PF_CHANGED = 1;
;    2588 		ePF = F_PF;
;    2589 	}
;    2590 	else if(gBtn_val == PF2_BTN_LONG){
_0x24B:
	LDS  R26,_gBtn_val
	CPI  R26,LOW(0x5)
	BRNE _0x25A
;    2591 		gBtn_val = 0;
	LDI  R30,LOW(0)
	STS  _gBtn_val,R30
;    2592 		F_PF = PF2;
	LDI  R30,LOW(4)
	MOV  R13,R30
;    2593 		BreakModeCmdSend();
_0x330:
	CALL _BreakModeCmdSend
;    2594 		delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    2595 		F_PF_CHANGED = 1;
	SET
	BLD  R3,1
;    2596 		ePF = F_PF;
	MOV  R30,R13
	LDI  R26,LOW(_ePF)
	LDI  R27,HIGH(_ePF)
	CALL __EEPROMWRB
;    2597 	}
;    2598 }
_0x25A:
_0x24A:
	RJMP _0x310
;    2599 
;    2600 
;    2601 //------------------------------------------------------------------------------
;    2602 // Io Ʈ ó
;    2603 //------------------------------------------------------------------------------
;    2604 void IoUpdate(void)
;    2605 {
_IoUpdate:
;    2606 	if(F_DOWNLOAD) return;
	SBRC R2,4
	RET
;    2607 	if(F_DIRECT_C_EN){
	SBRS R2,2
	RJMP _0x25C
;    2608 			PF1_LED1_ON;
	CBI  0x1B,2
;    2609 			PF1_LED2_OFF;
	SBI  0x1B,3
;    2610 			PF2_LED_ON;
	CBI  0x1B,4
;    2611 			return;
	RET
;    2612 	}
;    2613 	switch(F_PF){
_0x25C:
	MOV  R30,R13
;    2614 		case PF1_HUNO:
	CPI  R30,LOW(0x1)
	BRNE _0x260
;    2615 			PF1_LED1_ON;
	CBI  0x1B,2
;    2616 			PF1_LED2_OFF;
	SBI  0x1B,3
;    2617 			PF2_LED_OFF;
	SBI  0x1B,4
;    2618 			break;
	RJMP _0x25F
;    2619 		case PF1_DINO:
_0x260:
	CPI  R30,LOW(0x2)
	BRNE _0x261
;    2620 			PF1_LED1_ON;
	CBI  0x1B,2
;    2621 			PF1_LED2_ON;
	CBI  0x1B,3
;    2622 			PF2_LED_OFF;
	SBI  0x1B,4
;    2623 			break;
	RJMP _0x25F
;    2624 		case PF1_DOGY:
_0x261:
	CPI  R30,LOW(0x3)
	BRNE _0x262
;    2625 			PF1_LED1_OFF;
	SBI  0x1B,2
;    2626 			PF1_LED2_ON;
	CBI  0x1B,3
;    2627 			PF2_LED_OFF;
	SBI  0x1B,4
;    2628 			break;
	RJMP _0x25F
;    2629 		case PF2:
_0x262:
	CPI  R30,LOW(0x4)
	BRNE _0x264
;    2630 			PF1_LED1_OFF;
	SBI  0x1B,2
;    2631 			PF1_LED2_OFF;
	SBI  0x1B,3
;    2632 			PF2_LED_ON;
	CBI  0x1B,4
;    2633 			break;
	RJMP _0x25F
;    2634 		default:
_0x264:
;    2635 			F_PF = PF2;
	LDI  R30,LOW(4)
	MOV  R13,R30
;    2636 	}
_0x25F:
;    2637 
;    2638 	if(gVOLTAGE>M_T_OF_POWER){
	LDI  R30,LOW(8600)
	LDI  R31,HIGH(8600)
	CP   R30,R6
	CPC  R31,R7
	BRSH _0x265
;    2639 		PWR_LED1_ON;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;    2640 		PWR_LED2_OFF;
	SBI  0x15,7
;    2641 		gPwrLowCount = 0;
	LDI  R30,0
	STS  _gPwrLowCount,R30
	STS  _gPwrLowCount+1,R30
;    2642 	}
;    2643 	else if(gVOLTAGE>L_T_OF_POWER){
	RJMP _0x266
_0x265:
	LDI  R30,LOW(8100)
	LDI  R31,HIGH(8100)
	CP   R30,R6
	CPC  R31,R7
	BRSH _0x267
;    2644 		PWR_LED1_OFF;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;    2645 		PWR_LED2_ON;
	CBI  0x15,7
;    2646 		gPwrLowCount++;
	LDS  R30,_gPwrLowCount
	LDS  R31,_gPwrLowCount+1
	ADIW R30,1
	STS  _gPwrLowCount,R30
	STS  _gPwrLowCount+1,R31
;    2647 		if(gPwrLowCount>5000){
	LDS  R26,_gPwrLowCount
	LDS  R27,_gPwrLowCount+1
	CPI  R26,LOW(0x1389)
	LDI  R30,HIGH(0x1389)
	CPC  R27,R30
	BRLO _0x268
;    2648 			gPwrLowCount = 0;
	LDI  R30,0
	STS  _gPwrLowCount,R30
	STS  _gPwrLowCount+1,R30
;    2649 			BreakModeCmdSend();
	CALL _BreakModeCmdSend
;    2650 		}
;    2651 	}
_0x268:
;    2652 	else{
	RJMP _0x269
_0x267:
;    2653 		PWR_LED1_OFF;
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;    2654 		if(g10MSEC<25)			PWR_LED2_ON;
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,25
	BRSH _0x26A
	CBI  0x15,7
;    2655 		else if(g10MSEC<50)		PWR_LED2_OFF;
	RJMP _0x26B
_0x26A:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	SBIW R26,50
	BRSH _0x26C
	RJMP _0x331
;    2656 		else if(g10MSEC<75)		PWR_LED2_ON;
_0x26C:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CPI  R26,LOW(0x4B)
	LDI  R30,HIGH(0x4B)
	CPC  R27,R30
	BRSH _0x26E
	CBI  0x15,7
;    2657 		else if(g10MSEC<100)	PWR_LED2_OFF;
	RJMP _0x26F
_0x26E:
	LDS  R26,_g10MSEC
	LDS  R27,_g10MSEC+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRSH _0x270
_0x331:
	SBI  0x15,7
;    2658 		gPwrLowCount++;
_0x270:
_0x26F:
_0x26B:
	LDS  R30,_gPwrLowCount
	LDS  R31,_gPwrLowCount+1
	ADIW R30,1
	STS  _gPwrLowCount,R30
	STS  _gPwrLowCount+1,R31
;    2659 		if(gPwrLowCount>3000){
	LDS  R26,_gPwrLowCount
	LDS  R27,_gPwrLowCount+1
	CPI  R26,LOW(0xBB9)
	LDI  R30,HIGH(0xBB9)
	CPC  R27,R30
	BRLO _0x271
;    2660 			gPwrLowCount=0;
	LDI  R30,0
	STS  _gPwrLowCount,R30
	STS  _gPwrLowCount+1,R30
;    2661 			BreakModeCmdSend();
	CALL _BreakModeCmdSend
;    2662 		}
;    2663 	}
_0x271:
_0x269:
_0x266:
;    2664 	if(F_ERR_CODE == NO_ERR)	ERR_LED_OFF;
	LDI  R30,LOW(255)
	CP   R30,R14
	BRNE _0x272
	SBI  0x1B,7
;    2665 	else ERR_LED_ON;
	RJMP _0x273
_0x272:
	CBI  0x1B,7
;    2666 }
_0x273:
	RET
;    2667 
;    2668 
;    2669 //------------------------------------------------------------------------------
;    2670 // ü ׽Ʈ1
;    2671 //------------------------------------------------------------------------------
;    2672 void SelfTest1(void)
;    2673 {
_SelfTest1:
;    2674 	WORD	i;
;    2675 
;    2676 	if(F_DIRECT_C_EN)	return;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	SBRC R2,2
	RJMP _0x310
;    2677 
;    2678 	for(i=0;i<16;i++){
	__GETWRN 16,17,0
_0x276:
	__CPWRN 16,17,16
	BRSH _0x277
;    2679 		if((StandardZeroPos[i]+15)<eM_OriginPose[i]
;    2680 		 ||(StandardZeroPos[i]-15)>eM_OriginPose[i]){
	MOVW R30,R16
	CLR  R22
	CLR  R23
	SUBI R30,LOW(-_StandardZeroPos*2)
	SBCI R31,HIGH(-_StandardZeroPos*2)
	SBCI R22,BYTE3(-_StandardZeroPos*2)
	__GETBRPF 30
	MOV  R1,R30
	SUBI R30,-LOW(15)
	MOV  R0,R30
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	CP   R0,R30
	BRLO _0x279
	MOV  R30,R1
	SUBI R30,LOW(15)
	MOV  R0,R30
	LDI  R26,LOW(_eM_OriginPose)
	LDI  R27,HIGH(_eM_OriginPose)
	ADD  R26,R16
	ADC  R27,R17
	CALL __EEPROMRDB
	CP   R30,R0
	BRSH _0x278
_0x279:
;    2681 			F_ERR_CODE = ZERO_DATA_ERR;
	LDI  R30,LOW(8)
	MOV  R14,R30
;    2682 			return;
	RJMP _0x310
;    2683 		}
;    2684 	}
_0x278:
	__ADDWRN 16,17,1
	RJMP _0x276
_0x277:
;    2685 	PWR_LED1_ON;	delay_ms(60);	PWR_LED1_OFF;
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;    2686 	PWR_LED2_ON;	delay_ms(60);	PWR_LED2_OFF;
	CBI  0x15,7
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x15,7
;    2687 	RUN_LED1_ON;	delay_ms(60);	RUN_LED1_OFF;
	CBI  0x1B,5
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x1B,5
;    2688 	RUN_LED2_ON;	delay_ms(60);	RUN_LED2_OFF;
	CBI  0x1B,6
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x1B,6
;    2689 	ERR_LED_ON;		delay_ms(60);	ERR_LED_OFF;
	CBI  0x1B,7
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x1B,7
;    2690 
;    2691 	PF2_LED_ON;		delay_ms(60);	PF2_LED_OFF;
	CBI  0x1B,4
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x1B,4
;    2692 	PF1_LED2_ON;	delay_ms(60);	PF1_LED2_OFF;
	CBI  0x1B,3
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x1B,3
;    2693 	PF1_LED1_ON;	delay_ms(60);	PF1_LED1_OFF;
	CBI  0x1B,2
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	SBI  0x1B,2
;    2694 }
	RJMP _0x310
;    2695 
;    2696 
;    2697 //------------------------------------------------------------------------------
;    2698 // IR  ó
;    2699 //------------------------------------------------------------------------------
;    2700 void ProcIr(void)
;    2701 {
_ProcIr:
;    2702     WORD    i;
;    2703 
;    2704 	if(F_DOWNLOAD) return;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	SBRC R2,4
	RJMP _0x310
;    2705 	if(F_FIRST_M && gIrBuf[3]!=BTN_C && gIrBuf[3]!=BTN_SHARP_A && F_PF!=PF2) return;
	SBRS R3,3
	RJMP _0x27D
	__GETB1MN _gIrBuf,3
	CPI  R30,LOW(0x7)
	BREQ _0x27D
	__GETB1MN _gIrBuf,3
	CPI  R30,LOW(0x2B)
	BREQ _0x27D
	LDI  R30,LOW(4)
	CP   R30,R13
	BRNE _0x27E
_0x27D:
	RJMP _0x27C
_0x27E:
	RJMP _0x310
;    2706 	if(F_IR_RECEIVED){
_0x27C:
	SBRS R3,2
	RJMP _0x27F
;    2707 	    EIMSK &= 0xBF;
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;    2708 		F_IR_RECEIVED = 0;
	CLT
	BLD  R3,2
;    2709 		if((gIrBuf[0]==eRCodeH[0] && gIrBuf[1]==eRCodeM[0] && gIrBuf[2]==eRCodeL[0])
;    2710 		 ||(gIrBuf[0]==eRCodeH[1] && gIrBuf[1]==eRCodeM[1] && gIrBuf[2]==eRCodeL[1])
;    2711 		 ||(gIrBuf[0]==eRCodeH[2] && gIrBuf[1]==eRCodeM[2] && gIrBuf[2]==eRCodeL[2])
;    2712 		 ||(gIrBuf[0]==eRCodeH[3] && gIrBuf[1]==eRCodeM[3] && gIrBuf[2]==eRCodeL[3])
;    2713 		 ||(gIrBuf[0]==eRCodeH[4] && gIrBuf[1]==eRCodeM[4] && gIrBuf[2]==eRCodeL[4])){
	LDI  R26,LOW(_eRCodeH)
	LDI  R27,HIGH(_eRCodeH)
	CALL __EEPROMRDB
	LDS  R26,_gIrBuf
	CP   R30,R26
	BRNE _0x281
	LDI  R26,LOW(_eRCodeM)
	LDI  R27,HIGH(_eRCodeM)
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,1
	CP   R30,R26
	BRNE _0x281
	LDI  R26,LOW(_eRCodeL)
	LDI  R27,HIGH(_eRCodeL)
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,2
	CP   R30,R26
	BRNE _0x281
	RJMP _0x283
_0x281:
	__POINTW2MN _eRCodeH,1
	CALL __EEPROMRDB
	LDS  R26,_gIrBuf
	CP   R30,R26
	BRNE _0x284
	__POINTW2MN _eRCodeM,1
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,1
	CP   R30,R26
	BRNE _0x284
	__POINTW2MN _eRCodeL,1
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,2
	CP   R30,R26
	BRNE _0x284
	RJMP _0x283
_0x284:
	__POINTW2MN _eRCodeH,2
	CALL __EEPROMRDB
	LDS  R26,_gIrBuf
	CP   R30,R26
	BRNE _0x286
	__POINTW2MN _eRCodeM,2
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,1
	CP   R30,R26
	BRNE _0x286
	__POINTW2MN _eRCodeL,2
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,2
	CP   R30,R26
	BREQ _0x283
_0x286:
	__POINTW2MN _eRCodeH,3
	CALL __EEPROMRDB
	LDS  R26,_gIrBuf
	CP   R30,R26
	BRNE _0x288
	__POINTW2MN _eRCodeM,3
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,1
	CP   R30,R26
	BRNE _0x288
	__POINTW2MN _eRCodeL,3
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,2
	CP   R30,R26
	BREQ _0x283
_0x288:
	__POINTW2MN _eRCodeH,4
	CALL __EEPROMRDB
	LDS  R26,_gIrBuf
	CP   R30,R26
	BRNE _0x28A
	__POINTW2MN _eRCodeM,4
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,1
	CP   R30,R26
	BRNE _0x28A
	__POINTW2MN _eRCodeL,4
	CALL __EEPROMRDB
	__GETB2MN _gIrBuf,2
	CP   R30,R26
	BREQ _0x283
_0x28A:
	RJMP _0x280
_0x283:
;    2714 			switch(gIrBuf[3]){
	__GETB1MN _gIrBuf,3
;    2715 				case BTN_A:
	CPI  R30,LOW(0x1)
	BRNE _0x290
;    2716 					M_Play(BTN_A);
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _M_Play
;    2717 					break;
	RJMP _0x28F
;    2718 				case BTN_B:
_0x290:
	CPI  R30,LOW(0x2)
	BRNE _0x291
;    2719 					M_Play(BTN_B);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _M_Play
;    2720 					break;
	RJMP _0x28F
;    2721 				case BTN_LR:
_0x291:
	CPI  R30,LOW(0x3)
	BRNE _0x292
;    2722 					M_Play(BTN_LR);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _M_Play
;    2723 					break;
	RJMP _0x28F
;    2724 				case BTN_U:
_0x292:
	CPI  R30,LOW(0x4)
	BRNE _0x293
;    2725 					M_Play(BTN_U);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _M_Play
;    2726 					break;
	RJMP _0x28F
;    2727 				case BTN_RR:
_0x293:
	CPI  R30,LOW(0x5)
	BRNE _0x294
;    2728 					M_Play(BTN_RR);
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _M_Play
;    2729 					break;
	RJMP _0x28F
;    2730 				case BTN_L:
_0x294:
	CPI  R30,LOW(0x6)
	BRNE _0x295
;    2731 					M_Play(BTN_L);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _M_Play
;    2732 					break;
	RJMP _0x28F
;    2733 				case BTN_R:
_0x295:
	CPI  R30,LOW(0x8)
	BRNE _0x296
;    2734 					M_Play(BTN_R);
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _M_Play
;    2735 					break;
	RJMP _0x28F
;    2736 				case BTN_LA:
_0x296:
	CPI  R30,LOW(0x9)
	BRNE _0x297
;    2737 					M_Play(BTN_LA);
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _M_Play
;    2738 					break;
	RJMP _0x28F
;    2739 				case BTN_D:
_0x297:
	CPI  R30,LOW(0xA)
	BRNE _0x298
;    2740 					M_Play(BTN_D);
	LDI  R30,LOW(10)
	ST   -Y,R30
	CALL _M_Play
;    2741 					break;
	RJMP _0x28F
;    2742 				case BTN_RA:
_0x298:
	CPI  R30,LOW(0xB)
	BRNE _0x299
;    2743 					M_Play(BTN_RA);
	LDI  R30,LOW(11)
	ST   -Y,R30
	CALL _M_Play
;    2744 					break;
	RJMP _0x28F
;    2745 				case BTN_C:
_0x299:
	CPI  R30,LOW(0x7)
	BRNE _0x29A
;    2746 					F_FIRST_M = 0;
	CLT
	BLD  R3,3
;    2747 					M_Play(BTN_C);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _M_Play
;    2748 					break;
	RJMP _0x28F
;    2749 				case BTN_1:
_0x29A:
	CPI  R30,LOW(0xC)
	BRNE _0x29B
;    2750 					break;
	RJMP _0x28F
;    2751 				case BTN_2:
_0x29B:
	CPI  R30,LOW(0xD)
	BRNE _0x29C
;    2752 					break;
	RJMP _0x28F
;    2753 				case BTN_3:
_0x29C:
	CPI  R30,LOW(0xE)
	BRNE _0x29D
;    2754 					break;
	RJMP _0x28F
;    2755 				case BTN_4:
_0x29D:
	CPI  R30,LOW(0xF)
	BRNE _0x29E
;    2756 					break;
	RJMP _0x28F
;    2757 				case BTN_5:
_0x29E:
	CPI  R30,LOW(0x10)
	BRNE _0x29F
;    2758 					break;
	RJMP _0x28F
;    2759 				case BTN_6:
_0x29F:
	CPI  R30,LOW(0x11)
	BRNE _0x2A0
;    2760 					break;
	RJMP _0x28F
;    2761 				case BTN_7:
_0x2A0:
	CPI  R30,LOW(0x12)
	BRNE _0x2A1
;    2762 					break;
	RJMP _0x28F
;    2763 				case BTN_8:
_0x2A1:
	CPI  R30,LOW(0x13)
	BRNE _0x2A2
;    2764 					break;
	RJMP _0x28F
;    2765 				case BTN_9:
_0x2A2:
	CPI  R30,LOW(0x14)
	BRNE _0x2A3
;    2766 					break;
	RJMP _0x28F
;    2767 				case BTN_0:
_0x2A3:
	CPI  R30,LOW(0x15)
	BRNE _0x2A4
;    2768 					M_Play(BTN_0);
	LDI  R30,LOW(21)
	ST   -Y,R30
	CALL _M_Play
;    2769 					break;
	RJMP _0x28F
;    2770 				case BTN_STAR_A:
_0x2A4:
	CPI  R30,LOW(0x16)
	BRNE _0x2A5
;    2771 					M_Play(BTN_STAR_A);
	LDI  R30,LOW(22)
	ST   -Y,R30
	CALL _M_Play
;    2772 					break;
	RJMP _0x28F
;    2773 				case BTN_STAR_B:
_0x2A5:
	CPI  R30,LOW(0x17)
	BRNE _0x2A6
;    2774 					M_Play(BTN_STAR_B);
	LDI  R30,LOW(23)
	ST   -Y,R30
	CALL _M_Play
;    2775 					break;
	RJMP _0x28F
;    2776 				case BTN_STAR_C:
_0x2A6:
	CPI  R30,LOW(0x1C)
	BRNE _0x2A7
;    2777 					M_Play(BTN_STAR_C);
	LDI  R30,LOW(28)
	ST   -Y,R30
	CALL _M_Play
;    2778 					break;
	RJMP _0x28F
;    2779 				case BTN_STAR_1:
_0x2A7:
	CPI  R30,LOW(0x21)
	BRNE _0x2A8
;    2780 					break;
	RJMP _0x28F
;    2781 				case BTN_STAR_2:
_0x2A8:
	CPI  R30,LOW(0x22)
	BRNE _0x2A9
;    2782 					break;
	RJMP _0x28F
;    2783 				case BTN_STAR_3:
_0x2A9:
	CPI  R30,LOW(0x23)
	BRNE _0x2AA
;    2784 					break;
	RJMP _0x28F
;    2785 				case BTN_STAR_4:
_0x2AA:
	CPI  R30,LOW(0x24)
	BRNE _0x2AB
;    2786 					break;
	RJMP _0x28F
;    2787 				case BTN_STAR_5:
_0x2AB:
	CPI  R30,LOW(0x25)
	BRNE _0x2AC
;    2788 					break;
	RJMP _0x28F
;    2789 				case BTN_STAR_6:
_0x2AC:
	CPI  R30,LOW(0x26)
	BRNE _0x2AD
;    2790 					break;
	RJMP _0x28F
;    2791 				case BTN_STAR_7:
_0x2AD:
	CPI  R30,LOW(0x27)
	BRNE _0x2AE
;    2792 					break;
	RJMP _0x28F
;    2793 				case BTN_STAR_8:
_0x2AE:
	CPI  R30,LOW(0x28)
	BRNE _0x2AF
;    2794 					break;
	RJMP _0x28F
;    2795 				case BTN_STAR_9:
_0x2AF:
	CPI  R30,LOW(0x29)
	BRNE _0x2B0
;    2796 					break;
	RJMP _0x28F
;    2797 				case BTN_STAR_0:
_0x2B0:
	CPI  R30,LOW(0x2A)
	BREQ _0x28F
;    2798 					break;
;    2799 				case BTN_SHARP_1:
	CPI  R30,LOW(0x36)
	BREQ _0x28F
;    2800 					break;
;    2801 				case BTN_SHARP_2:
	CPI  R30,LOW(0x37)
	BREQ _0x28F
;    2802 					break;
;    2803 				case BTN_SHARP_3:
	CPI  R30,LOW(0x38)
	BREQ _0x28F
;    2804 					break;
;    2805 				case BTN_SHARP_4:
	CPI  R30,LOW(0x39)
	BREQ _0x28F
;    2806 					break;
;    2807 				case BTN_SHARP_5:
	CPI  R30,LOW(0x3A)
	BREQ _0x28F
;    2808 					break;
;    2809 				case BTN_SHARP_6:
	CPI  R30,LOW(0x3B)
	BREQ _0x28F
;    2810 					break;
;    2811 				case BTN_SHARP_7:
	CPI  R30,LOW(0x3C)
	BREQ _0x28F
;    2812 					break;
;    2813 				case BTN_SHARP_8:
	CPI  R30,LOW(0x3D)
	BREQ _0x28F
;    2814 					break;
;    2815 				case BTN_SHARP_9:
	CPI  R30,LOW(0x3E)
	BREQ _0x28F
;    2816 					break;
;    2817 				case BTN_SHARP_0:
	CPI  R30,LOW(0x3F)
	BREQ _0x28F
;    2818 					break;
;    2819 				case BTN_SHARP_A:
	CPI  R30,LOW(0x2B)
	BRNE _0x2BC
;    2820 					if(F_PS_PLUGGED){
	SBRS R2,5
	RJMP _0x2BD
;    2821 						BreakModeCmdSend();
	CALL _BreakModeCmdSend
;    2822 						ChargeNiMH();
	CALL _ChargeNiMH
;    2823 					}
;    2824 					else{
_0x2BD:
;    2825 					}
;    2826 					break;
	RJMP _0x28F
;    2827 				case BTN_SHARP_B:
_0x2BC:
	CPI  R30,LOW(0x2C)
	BREQ _0x28F
;    2828 					break;
;    2829 				case BTN_SHARP_C:
	CPI  R30,LOW(0x31)
	BRNE _0x28F
;    2830 					BasicPose(0, 50, 1000, 4);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _BasicPose
;    2831 					BasicPose(0, 1, 100, 1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _BasicPose
;    2832 					break;
;    2833 			}
_0x28F:
;    2834 		}
;    2835 		if(F_RSV_MOTION){
_0x280:
	SBRS R3,4
	RJMP _0x2C1
;    2836 			F_RSV_MOTION = 0;
	CLT
	BLD  R3,4
;    2837 			SendToPC(20,1);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _SendToPC
;    2838 			gFileCheckSum = 0;
	LDI  R30,LOW(0)
	STS  _gFileCheckSum,R30
;    2839 			sciTx1Data(gIrBuf[3]);
	__GETB1MN _gIrBuf,3
	ST   -Y,R30
	CALL _sciTx1Data
;    2840 			gFileCheckSum ^= gIrBuf[3];
	__GETB1MN _gIrBuf,3
	LDS  R26,_gFileCheckSum
	EOR  R30,R26
	STS  _gFileCheckSum,R30
;    2841 			sciTx1Data(gFileCheckSum);
	ST   -Y,R30
	CALL _sciTx1Data
;    2842 		}
;    2843 		for(i=0;i<IR_BUFFER_SIZE;i++)	gIrBuf[i]=0;
_0x2C1:
	__GETWRN 16,17,0
_0x2C3:
	__CPWRN 16,17,4
	BRSH _0x2C4
	LDI  R26,LOW(_gIrBuf)
	LDI  R27,HIGH(_gIrBuf)
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
;    2844 	    EIMSK |= 0x40;
	__ADDWRN 16,17,1
	RJMP _0x2C3
_0x2C4:
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;    2845 	}
;    2846 }
_0x27F:
_0x310:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    2847 //==============================================================================
;    2848 //						A/D converter  Լ
;    2849 //==============================================================================
;    2850 #include <mega128.h>
;    2851 #include "Main.h"
;    2852 #include "Macro.h"
;    2853 
;    2854 //------------------------------------------------------------------------------
;    2855 // PSD Ÿ ȣ A/D
;    2856 //------------------------------------------------------------------------------
;    2857 void Get_AD_PSD(void)
;    2858 {
_Get_AD_PSD:
;    2859 	float	tmp = 0;
;    2860 	float	dist;
;    2861 	
;    2862 	EIMSK &= 0xBF;
	SBIW R28,8
	LDI  R24,4
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	LDI  R30,LOW(_0x2C5*2)
	LDI  R31,HIGH(_0x2C5*2)
	LDI  R22,BYTE3(_0x2C5*2)
	CALL __INITLOCB
;	tmp -> Y+4
;	dist -> Y+0
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;    2863 	PSD_ON;
	SBI  0x18,5
;    2864    	delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    2865 	gAD_Ch_Index = PSD_CH;
	CLR  R5
;    2866    	F_AD_CONVERTING = 1;
	SET
	BLD  R2,7
;    2867    	ADC_set(ADC_MODE_SINGLE);
	LDI  R30,LOW(220)
	ST   -Y,R30
	CALL _ADC_set
;    2868    	while(F_AD_CONVERTING);            
_0x2C6:
	SBRC R2,7
	RJMP _0x2C6
;    2869    	tmp = tmp + gPSD_val;
	MOV  R30,R10
	__GETD2S 4
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __ADDF12
	__PUTD1S 4
;    2870 	PSD_OFF;
	CBI  0x18,5
;    2871 	EIMSK |= 0x40;
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;    2872 
;    2873 	dist = 1117.2 / (tmp - 6.89);
	__GETD2S 4
	__GETD1N 0x40DC7AE1
	CALL __SWAPD12
	CALL __SUBF12
	__GETD2N 0x448BA666
	CALL __DIVF21
	__PUTD1S 0
;    2874 	if(dist < 0) dist = 50;
	__GETD2S 0
	CALL __CPD20
	BRGE _0x2C9
	RJMP _0x332
;    2875 	else if(dist < 10) dist = 10;
_0x2C9:
	__GETD2S 0
	__GETD1N 0x41200000
	CALL __CMPF12
	BRSH _0x2CB
	RJMP _0x333
;    2876 	else if(dist > 50) dist = 50;
_0x2CB:
	__GETD2S 0
	__GETD1N 0x42480000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2CD
_0x332:
	__GETD1N 0x42480000
_0x333:
	__PUTD1S 0
;    2877 	gDistance = (BYTE)dist;
_0x2CD:
	__GETD1S 0
	CALL __CFD1
	MOV  R8,R30
;    2878 }
	ADIW R28,8
	RET
;    2879 
;    2880 
;    2881 //------------------------------------------------------------------------------
;    2882 // MIC ȣ A/D
;    2883 //------------------------------------------------------------------------------
;    2884 void Get_AD_MIC(void)
;    2885 {
_Get_AD_MIC:
;    2886 	WORD	i;
;    2887 	float	tmp = 0;
;    2888 	
;    2889 	gAD_Ch_Index = MIC_CH;
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x2CE*2)
	LDI  R31,HIGH(_0x2CE*2)
	LDI  R22,BYTE3(_0x2CE*2)
	CALL __INITLOCB
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
;	tmp -> Y+2
	LDI  R30,LOW(15)
	MOV  R5,R30
;    2890 	for(i = 0; i < 50; i++){
	__GETWRN 16,17,0
_0x2D0:
	__CPWRN 16,17,50
	BRSH _0x2D1
;    2891     	F_AD_CONVERTING = 1;
	SET
	BLD  R2,7
;    2892 	   	ADC_set(ADC_MODE_SINGLE);
	LDI  R30,LOW(220)
	ST   -Y,R30
	CALL _ADC_set
;    2893     	while(F_AD_CONVERTING);            
_0x2D2:
	SBRC R2,7
	RJMP _0x2D2
;    2894     	tmp = tmp + gMIC_val;
	MOV  R30,R11
	__GETD2S 2
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __ADDF12
	__PUTD1S 2
;    2895     }
	__ADDWRN 16,17,1
	RJMP _0x2D0
_0x2D1:
;    2896     tmp = tmp / 50;
	__GETD2S 2
	__GETD1N 0x42480000
	CALL __DIVF21
	__PUTD1S 2
;    2897 	gSoundLevel = (BYTE)tmp;
	CALL __CFD1
	MOV  R9,R30
;    2898 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,6
	RET
;    2899 
;    2900 
;    2901 //------------------------------------------------------------------------------
;    2902 //   A/D
;    2903 //------------------------------------------------------------------------------
;    2904 void Get_VOLTAGE(void)
;    2905 {
_Get_VOLTAGE:
;    2906 	if(F_DOWNLOAD) return;
	SBRC R2,4
	RET
;    2907 	gAD_Ch_Index = VOLTAGE_CH;
	LDI  R30,LOW(1)
	MOV  R5,R30
;    2908 	F_AD_CONVERTING = 1;
	SET
	BLD  R2,7
;    2909    	ADC_set(ADC_MODE_SINGLE);
	LDI  R30,LOW(220)
	ST   -Y,R30
	CALL _ADC_set
;    2910 	while(F_AD_CONVERTING);
_0x2D6:
	SBRC R2,7
	RJMP _0x2D6
;    2911 }
	RET
;    2912 #include <mega128.h>
;    2913 #include "Main.h"
;    2914 #include "Macro.h"
;    2915 #include "accel.h"
;    2916 
;    2917 //==============================================================//
;    2918 // Start
;    2919 //==============================================================//
;    2920 void AccStart(void)
;    2921 {
_AccStart:
;    2922 SDI_SET_OUTPUT;
	SBI  0x2,5
;    2923 SCK_SET_OUTPUT;
	SBI  0x2,4
;    2924 	P_ACC_SDI(1);
	SBI  0x3,5
;    2925 	P_ACC_SCK(1);
	SBI  0x3,4
;    2926 	#asm("nop");
	nop
;    2927 	#asm("nop");
	nop
;    2928 	P_ACC_SDI(0);
	CBI  0x3,5
;    2929 	#asm("nop");
	nop
;    2930 	#asm("nop");
	nop
;    2931 	P_ACC_SCK(0);
	CBI  0x3,4
;    2932 	#asm("nop");
	nop
;    2933 	#asm("nop");
	nop
;    2934 }
	RET
;    2935 
;    2936 
;    2937 //==============================================================//
;    2938 // Stop
;    2939 //==============================================================//
;    2940 void AccStop(void)
;    2941 {
_AccStop:
;    2942 SDI_SET_OUTPUT;
	SBI  0x2,5
;    2943 SCK_SET_OUTPUT;
	SBI  0x2,4
;    2944 	P_ACC_SDI(0);
	CBI  0x3,5
;    2945 	P_ACC_SCK(1);
	SBI  0x3,4
;    2946 	#asm("nop");
	nop
;    2947 	#asm("nop");
	nop
;    2948 	P_ACC_SDI(1);
	SBI  0x3,5
;    2949 	#asm("nop");
	nop
;    2950 	#asm("nop");
	nop
;    2951 SDI_SET_INPUT;
	CBI  0x2,5
;    2952 SCK_SET_INPUT;
	CBI  0x2,4
;    2953 }
	RET
;    2954 
;    2955 
;    2956 //==============================================================//
;    2957 //
;    2958 //==============================================================//
;    2959 void AccByteWrite(BYTE bData)
;    2960 {
_AccByteWrite:
;    2961 	BYTE	i;
;    2962 	BYTE	bTmp;
;    2963 
;    2964 SDI_SET_OUTPUT;
	ST   -Y,R17
	ST   -Y,R16
;	bData -> Y+2
;	i -> R16
;	bTmp -> R17
	SBI  0x2,5
;    2965 	for(i=0; i<8; i++){
	LDI  R16,LOW(0)
_0x2E8:
	CPI  R16,8
	BRSH _0x2E9
;    2966 		bTmp = CHK_BIT7(bData);
	LDD  R30,Y+2
	ANDI R30,LOW(0x80)
	MOV  R17,R30
;    2967     	if(bTmp){
	CPI  R17,0
	BREQ _0x2EA
;    2968 			P_ACC_SDI(1);
	SBI  0x3,5
;    2969 		}else{
	RJMP _0x2ED
_0x2EA:
;    2970 			P_ACC_SDI(0);
	CBI  0x3,5
;    2971 		}
_0x2ED:
;    2972 		#asm("nop");
	nop
;    2973 		#asm("nop");
	nop
;    2974 		P_ACC_SCK(1);;
	SBI  0x3,4
;    2975 		#asm("nop");
	nop
;    2976 		#asm("nop");
	nop
;    2977 		#asm("nop");
	nop
;    2978 		#asm("nop");
	nop
;    2979 		P_ACC_SCK(0);
	CBI  0x3,4
;    2980 		#asm("nop");
	nop
;    2981 		#asm("nop");
	nop
;    2982 		bData =	bData << 1;
	LDD  R30,Y+2
	LSL  R30
	STD  Y+2,R30
;    2983 	}
	SUBI R16,-1
	JMP  _0x2E8
_0x2E9:
;    2984 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,3
	RET
;    2985 
;    2986 
;    2987 //==============================================================//
;    2988 //
;    2989 //==============================================================//
;    2990 char AccByteRead(void)
;    2991 {
_AccByteRead:
;    2992 	BYTE	i;
;    2993 	char	bTmp = 0;
;    2994 
;    2995 SDI_SET_INPUT;
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16
;	bTmp -> R17
	LDI  R17,0
	CBI  0x2,5
;    2996 	for(i = 0; i < 8;	i++){
	LDI  R16,LOW(0)
_0x2F5:
	CPI  R16,8
	BRSH _0x2F6
;    2997 		bTmp = bTmp << 1;
	LSL  R17
;    2998 		#asm("nop");
	nop
;    2999 		#asm("nop");
	nop
;    3000 		#asm("nop");
	nop
;    3001 		#asm("nop");
	nop
;    3002 		P_ACC_SCK(1);
	SBI  0x3,4
;    3003 		#asm("nop");
	nop
;    3004 		#asm("nop");
	nop
;    3005 		if(SDI_CHK)	bTmp |= 0x01;
	SBIC 0x1,5
	ORI  R17,LOW(1)
;    3006 		#asm("nop");
	nop
;    3007 		#asm("nop");
	nop
;    3008 		P_ACC_SCK(0);
	CBI  0x3,4
;    3009 	}
	SUBI R16,-1
	JMP  _0x2F5
_0x2F6:
;    3010 SDI_SET_OUTPUT;
	SBI  0x2,5
;    3011 
;    3012 	return	bTmp;
	MOV  R30,R17
	LD   R16,Y+
	LD   R17,Y+
	RET
;    3013 }
;    3014 
;    3015 
;    3016 //==============================================================//
;    3017 //
;    3018 //==============================================================//
;    3019 void AccAckRead(void)
;    3020 {
_AccAckRead:
;    3021 SDI_SET_INPUT;
	CBI  0x2,5
;    3022 	#asm("nop");
	nop
;    3023 	#asm("nop");
	nop
;    3024 	P_ACC_SDI(1);
	SBI  0x3,5
;    3025 	#asm("nop");
	nop
;    3026 	#asm("nop");
	nop
;    3027 	P_ACC_SCK(1);
	SBI  0x3,4
;    3028 	#asm("nop");
	nop
;    3029 	#asm("nop");
	nop
;    3030 	P_ACC_SCK(0);
	CBI  0x3,4
;    3031 	#asm("nop");
	nop
;    3032 	#asm("nop");
	nop
;    3033 SDI_SET_OUTPUT;
	SBI  0x2,5
;    3034 	#asm("nop");
	nop
;    3035 	#asm("nop");
	nop
;    3036 }
	RET
;    3037 
;    3038 
;    3039 //==============================================================//
;    3040 //
;    3041 //==============================================================//
;    3042 void AccAckWrite(void)
;    3043 {
_AccAckWrite:
;    3044 SDI_SET_OUTPUT;
	SBI  0x2,5
;    3045 	#asm("nop");
	nop
;    3046 	#asm("nop");
	nop
;    3047 	P_ACC_SDI(0);
	CBI  0x3,5
;    3048 	#asm("nop");
	nop
;    3049 	#asm("nop");
	nop
;    3050 	P_ACC_SCK(1);
	SBI  0x3,4
;    3051 	#asm("nop");
	nop
;    3052 	#asm("nop");
	nop
;    3053 	P_ACC_SCK(0);
	CBI  0x3,4
;    3054 	#asm("nop");
	nop
;    3055 	#asm("nop");
	nop
;    3056 	P_ACC_SDI(1);
	SBI  0x3,5
;    3057 	#asm("nop");
	nop
;    3058 	#asm("nop");
	nop
;    3059 }
	RET
;    3060 
;    3061 
;    3062 //==============================================================//
;    3063 //
;    3064 //==============================================================//
;    3065 void AccNotAckWrite(void)
;    3066 {
_AccNotAckWrite:
;    3067 SDI_SET_OUTPUT;
	SBI  0x2,5
;    3068 	#asm("nop");
	nop
;    3069 	#asm("nop");
	nop
;    3070 	P_ACC_SDI(1);
	SBI  0x3,5
;    3071 	#asm("nop");
	nop
;    3072 	#asm("nop");
	nop
;    3073 	P_ACC_SCK(1);
	SBI  0x3,4
;    3074 	#asm("nop");
	nop
;    3075 	#asm("nop");
	nop
;    3076 	P_ACC_SCK(0);
	CBI  0x3,4
;    3077 	#asm("nop");
	nop
;    3078 	#asm("nop");
	nop
;    3079 }
	RET
;    3080 
;    3081 
;    3082 //==============================================================//
;    3083 //==============================================================//
;    3084 void Acc_init(void)
;    3085 {
_Acc_init:
;    3086 	AccStart();
	CALL _AccStart
;    3087 	AccByteWrite(0x70);
	LDI  R30,LOW(112)
	ST   -Y,R30
	CALL _AccByteWrite
;    3088 	AccAckRead();
	CALL _AccAckRead
;    3089 	AccByteWrite(0x14);
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _AccByteWrite
;    3090 	AccAckRead();
	CALL _AccAckRead
;    3091 	AccByteWrite(0x03);
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _AccByteWrite
;    3092 	AccAckRead();
	CALL _AccAckRead
;    3093 	AccStop();
	CALL _AccStop
;    3094 }
	RET
;    3095 
;    3096 //==============================================================//
;    3097 //==============================================================//
;    3098 void AccGetData(void)
;    3099 {
_AccGetData:
;    3100 	signed char	bTmp = 0;
;    3101 
;    3102 	AccStart();
	ST   -Y,R16
;	bTmp -> R16
	LDI  R16,0
	CALL _AccStart
;    3103 	AccByteWrite(0x70);
	LDI  R30,LOW(112)
	ST   -Y,R30
	CALL _AccByteWrite
;    3104 	AccAckRead();
	CALL _AccAckRead
;    3105 	AccByteWrite(0x02);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _AccByteWrite
;    3106 	AccAckRead();
	CALL _AccAckRead
;    3107 	AccStop();
	CALL _AccStop
;    3108 
;    3109 	#asm("nop");
	nop
;    3110 	#asm("nop");
	nop
;    3111 	#asm("nop");
	nop
;    3112 	#asm("nop");
	nop
;    3113 
;    3114 	AccStart();
	CALL _AccStart
;    3115 	AccByteWrite(0x71);
	LDI  R30,LOW(113)
	ST   -Y,R30
	CALL _AccByteWrite
;    3116 	AccAckRead();
	CALL _AccAckRead
;    3117 
;    3118 	bTmp = AccByteRead();
	CALL _AccByteRead
	MOV  R16,R30
;    3119 	AccAckWrite();
	CALL _AccAckWrite
;    3120 
;    3121 	bTmp = AccByteRead();
	CALL _AccByteRead
	MOV  R16,R30
;    3122 	AccAckWrite();
	CALL _AccAckWrite
;    3123 	gAccX = bTmp;
	STS  _gAccX,R16
;    3124 
;    3125 	bTmp = AccByteRead();
	CALL _AccByteRead
	MOV  R16,R30
;    3126 	AccAckWrite();
	CALL _AccAckWrite
;    3127 
;    3128 	bTmp = AccByteRead();
	CALL _AccByteRead
	MOV  R16,R30
;    3129 	AccAckWrite();
	CALL _AccAckWrite
;    3130 	gAccY = bTmp;
	STS  _gAccY,R16
;    3131 
;    3132 	bTmp = AccByteRead();
	CALL _AccByteRead
	MOV  R16,R30
;    3133 	AccAckWrite();
	CALL _AccAckWrite
;    3134 
;    3135 	bTmp = AccByteRead();
	CALL _AccByteRead
	MOV  R16,R30
;    3136 	AccNotAckWrite();
	CALL _AccNotAckWrite
;    3137 	gAccZ = bTmp;
	STS  _gAccZ,R16
;    3138 
;    3139 	AccStop();
	CALL _AccStop
;    3140 }
	LD   R16,Y+
	RET

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xE66
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

	rjmp __addfc

_ceil:
	rcall __ftrunc
	brne __ceil1
__ceil0:
	ret
__ceil1:
	brts __ceil0
	ldi  r25,0x3f

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__GETW1PF:
	OUT  RAMPZ,R22
	ELPM R0,Z+
	ELPM R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
	OUT  RAMPZ,R22
__INITLOC0:
	ELPM R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
